 /*********************************************************************/
 /*                                                                   */
 /* dde.cpy -     Dynamic Data Exchange structures and definitions    */
 /*                                                                   */
 /* Copyright 1993 - 1998 Microsoft Corp. All rights reserved         */
 /*                                                                   */
 /*********************************************************************/

 %dcl #DDEHEADER_INCLUDED_ char ext;
 %if #DDEHEADER_INCLUDED_ = '' %then %do;
 %#DDEHEADER_INCLUDED_ = 'Y';

 %dcl #WINDEF_ char ext;
 %if #WINDEF_ = '' %then %do;
 %include windef;
 %end;


 /* begin_r_dde */

 /* DDE window messages */

 dcl WM_DDE_FIRST     fixed bin(15) value('03E0'xn);
 dcl WM_DDE_INITIATE  fixed bin(15) value(WM_DDE_FIRST);
 dcl WM_DDE_TERMINATE fixed bin(15) value(WM_DDE_FIRST+1);
 dcl WM_DDE_ADVISE    fixed bin(15) value(WM_DDE_FIRST+2);
 dcl WM_DDE_UNADVISE  fixed bin(15) value(WM_DDE_FIRST+3);
 dcl WM_DDE_ACK       fixed bin(15) value(WM_DDE_FIRST+4);
 dcl WM_DDE_DATA      fixed bin(15) value(WM_DDE_FIRST+5);
 dcl WM_DDE_REQUEST   fixed bin(15) value(WM_DDE_FIRST+6);
 dcl WM_DDE_POKE      fixed bin(15) value(WM_DDE_FIRST+7);
 dcl WM_DDE_EXECUTE   fixed bin(15) value(WM_DDE_FIRST+8);
 dcl WM_DDE_LAST      fixed bin(15) value(WM_DDE_FIRST+8);

 /* end_r_dde */

 /* ----------------------------------------------------------------- */
 /* DDEACK structure                                                  */
 /*                                                                   */
 /* Structure of wStatus (LOWORD(lParam)) in WM_DDE_ACK message       */
 /* sent in response to a WM_DDE_DATA, WM_DDE_REQUEST, WM_DDE_POKE,   */
 /* WM_DDE_ADVISE, or WM_DDE_UNADVISE message.                        */
 /*                                                                   */
 /* ----------------------------------------------------------------- */


 define structure
   1 DDEACK,
     2 fAck           bit (1),
     2 fBusy          bit (1),
     2 reserved       bit (6),
     2 bAppReturnCode fixed bin (8) unsigned;


 /* ----------------------------------------------------------------- */
 /* DDEADVISE structure                                               */
 /*                                                                   */
 /* WM_DDE_ADVISE parameter structure for hOptions (LOWORD(lParam))   */
 /*                                                                   */
 /* ----------------------------------------------------------------- */

 define structure
   1 DDEADVISE,
     2 fAckReq   bit (1),
     2 fDeferUpd bit (1),
     2 reserved  bit (14),
     2 usFlags   unsigned fixed bin(16),
     2 cfFormat  fixed bin(15);



 /* ----------------------------------------------------------------- */
 /* DDEDATA structure                                                 */
 /*                                                                   */
 /* WM_DDE_DATA parameter structure for hData (LOWORD(lParam)).       */
 /* The actual size of this structure depends on the size of          */
 /* the Value array.                                                  */
 /*                                                                   */
 /* ----------------------------------------------------------------- */

 define structure
   1 DDEDATA,
     2 fAckReq   bit (1),
     2 reserved  bit (1),
     2 fRelease  bit (1),
     2 fResponse bit (1),
     2 unused    bit (12),
     2 cfFormat  fixed bin(15),
     2 Value (1) type BYTE; /* actual array size is variable */


 /* ----------------------------------------------------------------- */
 /* DDEPOKE structure                                                 */
 /*                                                                   */
 /* WM_DDE_POKE parameter structure for hData (LOWORD(lParam)).       */
 /* The actual size of this structure depends on the size of          */
 /* the Value array.                                                  */
 /*                                                                   */
 /* ----------------------------------------------------------------- */

 define structure
   1 DDEPOKE,
     2 fReserved bit(2),
     2 fRelease  bit(1),
     2 unused    bit(13),
     2 cfFormat  fixed bin(15),
     2 Value (1) type BYTE; /* actual array size is variable */

 /* ----------------------------------------------------------------- */
 /* The following define structures were used in previous versions of */
 /* the Windows SDK. They are still valid.                            */
 /* The above define structures define exactly the same structures as */
 /* those below. The above define structure names are recommended,    */
 /* however, as they are more meaningful.                             */
 /*                                                                   */
 /* Note that the DDEPOKE structure defined in earlier "virtual"      */
 /* versions of DDE.CPY did not correctly define the bit positions.   */
 /* ----------------------------------------------------------------- */

 define structure
   1 DDELN,
     2 fAckReq   bit (1),
     2 fDeferUpd bit (1),
     2 fRelease  bit (1),
     2 unused    bit (13),
     2 cfFormat  fixed bin(15);

 define structure
   1 DDEUP,
     2 fAckReq   bit (1),
     2 fReserved bit (1),
     2 fRelease  bit (1),
     2 fAck      bit (1),
     2 unused    bit (12),
     2 cfFormat  fixed bin(15),
     2 rgb (1)   type BYTE; /* actual array size is variable */


 /* DDE SECURITY */

 dcl DdeSetQualityOfService
     entry (type HWND,
            type SECURITY_QUALITY_OF_SERVICE byaddr nonasgn,
            type SECURITY_QUALITY_OF_SERVICE byaddr optional)
     returns (type BOOL byvalue optional)
     WINAPI external('DdeSetQualityOfService');

 dcl ImpersonateDdeClientWindow
     entry (type HWND,
            type HWND)
     returns (type BOOL byvalue optional)
     WINAPI external('ImpersonateDdeClientWindow');

 /* DDE message packing APIs */
 dcl PackDDElParam
     entry (type UINT,
            type UINT,
            type UINT)
     returns (type LONG byvalue optional)
     APIENTRY external('PackDDElParam');

 dcl UnpackDDElParam
     entry (type UINT,
            type LONG,
            type UINT byaddr,
            type UINT byaddr)
     returns (type BOOL byvalue optional)
     APIENTRY external('UnpackDDElParam');

 dcl FreeDDElParam
     entry (type UINT,
            type LONG)
     returns (type BOOL byvalue optional)
     APIENTRY external('FreeDDElParam');

 dcl ReuseDDElParam
     entry (type LONG,
            type UINT,
            type UINT,
            type UINT,
            type UINT)
     returns (type LONG byvalue optional)
     APIENTRY external('ReuseDDElParam');

 %end; /* _DDEHEADER_INCLUDED_ */
