 /*********************************************************************/
 /*                                                                   */
 /* HtmlHelp.cpy                                                      */
 /*                                                                   */
 /* Copyright (c) 1996-1999, Microsoft Corp. All rights reserved.     */
 /*                                                                   */
 /*********************************************************************/

 %dcl #_HTMLHELP_H__ char ext;
 %if #_HTMLHELP_H__ = '' %then %do;
 %#_HTMLHELP_H__ = 'Y';

 %dcl #WINUSER_ char ext;
 %if #WINUSER_ = '' %then %do;
 %include winuser;
 %end;

 /* Commands to pass to HtmlHelp() */

 dcl HH_DISPLAY_TOPIC            type UINT value('0000'xu);
 dcl HH_HELP_FINDER              type UINT value('0000'xu);
     /* WinHelp equivalent */
 dcl HH_DISPLAY_TOC              type UINT value('0001'xu);
 dcl HH_DISPLAY_INDEX            type UINT value('0002'xu);
 dcl HH_DISPLAY_SEARCH           type UINT value('0003'xu);
 dcl HH_SET_WIN_TYPE             type UINT value('0004'xu);
 dcl HH_GET_WIN_TYPE             type UINT value('0005'xu);
 dcl HH_GET_WIN_HANDLE           type UINT value('0006'xu);
 dcl HH_ENUM_INFO_TYPE           type UINT value('0007'xu);
     /* Get Info type name, call repeatedly to enumerate, -1 at end */
 dcl HH_SET_INFO_TYPE            type UINT value('0008'xu);
     /* Add Info type to filter. */
 dcl HH_SYNC                     type UINT value('0009'xu);
 dcl HH_RESERVED1                type UINT value('000A'xu);
 dcl HH_RESERVED2                type UINT value('000B'xu);
 dcl HH_RESERVED3                type UINT value('000C'xu);
 dcl HH_KEYWORD_LOOKUP           type UINT value('000D'xu);
 dcl HH_DISPLAY_TEXT_POPUP       type UINT value('000E'xu);
     /* display string resource id or text in a popup window */
 dcl HH_HELP_CONTEXT             type UINT value('000F'xu);
     /* display mapped numeric value in dwData */
 dcl HH_TP_HELP_CONTEXTMENU      type UINT value('0010'xu);
     /* text popup help, same as WinHelp HELP_CONTEXTMENU */
 dcl HH_TP_HELP_WM_HELP          type UINT value('0011'xu);
     /* text popup help, same as WinHelp HELP_WM_HELP */
 dcl HH_CLOSE_ALL                type UINT value('0012'xu);
     /* close all windows opened directly or indirectly by the caller */
 dcl HH_ALINK_LOOKUP             type UINT value('0013'xu);
     /* ALink version of HH_KEYWORD_LOOKUP */
 dcl HH_GET_LAST_ERROR           type UINT value('0014'xu);
     /* not currently implemented /* See HHERROR.h */
 dcl HH_ENUM_CATEGORY            type UINT value('0015'xu);
     /* Get category name, call repeatedly to enumerate, -1 at end */
 dcl HH_ENUM_CATEGORY_IT         type UINT value('0016'xu);
     /* Get category info type members, call repeatedly to enumerate, */
     /* -1 at end                                                     */
 dcl HH_RESET_IT_FILTER          type UINT value('0017'xu);
     /* Clear the info type filter of all info types. */
 dcl HH_SET_INCLUSIVE_FILTER     type UINT value('0018'xu);
     /* set inclusive filtering method for untyped topics */
     /* to be included in display                         */
 dcl HH_SET_EXCLUSIVE_FILTER     type UINT value('0019'xu);
     /* set exclusive filtering method for untyped topics */
     /* to be excluded from display                       */
 dcl HH_INITIALIZE               type UINT value('001C'xu);
     /* Initializes the help system. */
 dcl HH_UNINITIALIZE             type UINT value('001D'xu);
     /* Uninitializes the help system. */
 dcl HH_PRETRANSLATEMESSAGE      type UINT value('00fd'xu);
     /* Pumps messages. (NULL, NULL, MSG*). */
 dcl HH_SET_GLOBAL_PROPERTY      type UINT value('00fc'xu);
     /* Set a global property. (NULL, NULL, HH_GPROP) */

 dcl HHWIN_PROP_TAB_AUTOHIDESHOW type UINT value(raise2(1,0));
     /* Automatically hide/show tri-pane window */
 dcl HHWIN_PROP_ONTOP            type UINT value(raise2(1,1));
     /* Top-most window */
 dcl HHWIN_PROP_NOTITLEBAR       type UINT value(raise2(1,2));
     /* no title bar */
 dcl HHWIN_PROP_NODEF_STYLES     type UINT value(raise2(1,3));
     /* no default window styles (only HH_WINTYPE.dwStyles) */
 dcl HHWIN_PROP_NODEF_EXSTYLES   type UINT value(raise2(1,4));
     /* no default extended window styles (only HH_WINTYPE.dwExStyles)*/
 dcl HHWIN_PROP_TRI_PANE         type UINT value(raise2(1,5));
     /* use a tri-pane window */
 dcl HHWIN_PROP_NOTB_TEXT        type UINT value(raise2(1,6));
     /* no text on toolbar buttons */
 dcl HHWIN_PROP_POST_QUIT        type UINT value(raise2(1,7));
     /* post WM_QUIT message when window closes */
 dcl HHWIN_PROP_AUTO_SYNC        type UINT value(raise2(1,8));
     /* automatically ssync contents and index */
 dcl HHWIN_PROP_TRACKING         type UINT value(raise2(1,9));
     /* send tracking notification messages */
 dcl HHWIN_PROP_TAB_SEARCH       type UINT value(raise2(1,10));
     /* include search tab in navigation pane */
 dcl HHWIN_PROP_TAB_HISTORY      type UINT value(raise2(1,11));
     /* include history tab in navigation pane */
 dcl HHWIN_PROP_TAB_FAVORITES    type UINT value(raise2(1,12));
     /* include favorites tab in navigation pane */
 dcl HHWIN_PROP_CHANGE_TITLE     type UINT value(raise2(1,13));
     /* Put current HTML title in title bar */
 dcl HHWIN_PROP_NAV_ONLY_WIN     type UINT value(raise2(1,14));
     /* Only display the navigation window */
 dcl HHWIN_PROP_NO_TOOLBAR       type UINT value(raise2(1,15));
     /* Don't display a toolbar */
 dcl HHWIN_PROP_MENU             type UINT value(raise2(1,16));
     /* Menu */
 dcl HHWIN_PROP_TAB_ADVSEARCH    type UINT value(raise2(1,17));
     /* Advanced FTS UI. */
 dcl HHWIN_PROP_USER_POS         type UINT value(raise2(1,18));
     /* After initial creation, user controls window size/position */
 dcl HHWIN_PROP_TAB_CUSTOM1      type UINT value(raise2(1,19));
     /* Use custom tab #1 */
 dcl HHWIN_PROP_TAB_CUSTOM2      type UINT value(raise2(1,20));
     /* Use custom tab #2 */
 dcl HHWIN_PROP_TAB_CUSTOM3      type UINT value(raise2(1,21));
     /* Use custom tab #3 */
 dcl HHWIN_PROP_TAB_CUSTOM4      type UINT value(raise2(1,22));
     /* Use custom tab #4 */
 dcl HHWIN_PROP_TAB_CUSTOM5      type UINT value(raise2(1,23));
     /* Use custom tab #5 */
 dcl HHWIN_PROP_TAB_CUSTOM6      type UINT value(raise2(1,24));
     /* Use custom tab #6 */
 dcl HHWIN_PROP_TAB_CUSTOM7      type UINT value(raise2(1,25));
     /* Use custom tab #7 */
 dcl HHWIN_PROP_TAB_CUSTOM8      type UINT value(raise2(1,26));
     /* Use custom tab #8 */
 dcl HHWIN_PROP_TAB_CUSTOM9      type UINT value(raise2(1,27));
     /* Use custom tab #9 */
 dcl HHWIN_TB_MARGIN             type UINT value(raise2(1,28));
     /* the window type has a margin */

 dcl HHWIN_PARAM_PROPERTIES      type UINT value(raise2(1,1));
     /* valid fsWinProperties */
 dcl HHWIN_PARAM_STYLES          type UINT value(raise2(1,2));
     /* valid dwStyles */
 dcl HHWIN_PARAM_EXSTYLES        type UINT value(raise2(1,3));
     /* valid dwExStyles */
 dcl HHWIN_PARAM_RECT            type UINT value(raise2(1,4));
     /* valid rcWindowPos */
 dcl HHWIN_PARAM_NAV_WIDTH       type UINT value(raise2(1,5));
     /* valid iNavWidth */
 dcl HHWIN_PARAM_SHOWSTATE       type UINT value(raise2(1,6));
     /* valid nShowState */
 dcl HHWIN_PARAM_INFOTYPES       type UINT value(raise2(1,7));
     /* valid apInfoTypes */
 dcl HHWIN_PARAM_TB_FLAGS        type UINT value(raise2(1,8));
     /* valid fsToolBarFlags */
 dcl HHWIN_PARAM_EXPANSION       type UINT value(raise2(1,9));
     /* valid fNotExpanded */
 dcl HHWIN_PARAM_TABPOS          type UINT value(raise2(1,10));
     /* valid tabpos */
 dcl HHWIN_PARAM_TABORDER        type UINT value(raise2(1,11));
     /* valid taborder */
 dcl HHWIN_PARAM_HISTORY_COUNT   type UINT value(raise2(1,12));
     /* valid cHistory */
 dcl HHWIN_PARAM_CUR_TAB         type UINT value(raise2(1,13));
     /* valid curNavType */

 dcl HHWIN_BUTTON_EXPAND         type UINT value(raise2(1,1));
     /* Expand/contract button */
 dcl HHWIN_BUTTON_BACK           type UINT value(raise2(1,2));
     /* Back button */
 dcl HHWIN_BUTTON_FORWARD        type UINT value(raise2(1,3));
     /* Forward button */
 dcl HHWIN_BUTTON_STOP           type UINT value(raise2(1,4));
     /* Stop button */
 dcl HHWIN_BUTTON_REFRESH        type UINT value(raise2(1,5));
     /* Refresh button */
 dcl HHWIN_BUTTON_HOME           type UINT value(raise2(1,6));
     /* Home button */
 dcl HHWIN_BUTTON_BROWSE_FWD     type UINT value(raise2(1,7));
     /* not implemented */
 dcl HHWIN_BUTTON_BROWSE_BCK     type UINT value(raise2(1,8));
     /* not implemented */
 dcl HHWIN_BUTTON_NOTES          type UINT value(raise2(1,9));
     /* not implemented */
 dcl HHWIN_BUTTON_CONTENTS       type UINT value(raise2(1,10));
     /* not implemented */
 dcl HHWIN_BUTTON_SYNC           type UINT value(raise2(1,11));
     /* Sync button */
 dcl HHWIN_BUTTON_OPTIONS        type UINT value(raise2(1,12));
     /* Options button */
 dcl HHWIN_BUTTON_PRINT          type UINT value(raise2(1,13));
     /* Print button */
 dcl HHWIN_BUTTON_INDEX          type UINT value(raise2(1,14));
     /* not implemented */
 dcl HHWIN_BUTTON_SEARCH         type UINT value(raise2(1,15));
     /* not implemented */
 dcl HHWIN_BUTTON_HISTORY        type UINT value(raise2(1,16));
     /* not implemented */
 dcl HHWIN_BUTTON_FAVORITES      type UINT value(raise2(1,17));
     /* not implemented */
 dcl HHWIN_BUTTON_JUMP1          type UINT value(raise2(1,18));
 dcl HHWIN_BUTTON_JUMP2          type UINT value(raise2(1,19));
 dcl HHWIN_BUTTON_ZOOM           type UINT value(raise2(1,20));
 dcl HHWIN_BUTTON_TOC_NEXT       type UINT value(raise2(1,21));
 dcl HHWIN_BUTTON_TOC_PREV       type UINT value(raise2(1,22));

 dcl HHWIN_DEF_BUTTONS           type UINT
                                 value (ior (HHWIN_BUTTON_EXPAND,
                                             HHWIN_BUTTON_BACK,
                                             HHWIN_BUTTON_OPTIONS,
                                             HHWIN_BUTTON_PRINT));


 /* Button IDs */

 dcl IDTB_EXPAND         fixed bin(31) value(200);
 dcl IDTB_CONTRACT       fixed bin(31) value(201);
 dcl IDTB_STOP           fixed bin(31) value(202);
 dcl IDTB_REFRESH        fixed bin(31) value(203);
 dcl IDTB_BACK           fixed bin(31) value(204);
 dcl IDTB_HOME           fixed bin(31) value(205);
 dcl IDTB_SYNC           fixed bin(31) value(206);
 dcl IDTB_PRINT          fixed bin(31) value(207);
 dcl IDTB_OPTIONS        fixed bin(31) value(208);
 dcl IDTB_FORWARD        fixed bin(31) value(209);
 dcl IDTB_NOTES          fixed bin(31) value(210); /* not implemented */
 dcl IDTB_BROWSE_FWD     fixed bin(31) value(211);
 dcl IDTB_BROWSE_BACK    fixed bin(31) value(212);
 dcl IDTB_CONTENTS       fixed bin(31) value(213); /* not implemented */
 dcl IDTB_INDEX          fixed bin(31) value(214); /* not implemented */
 dcl IDTB_SEARCH         fixed bin(31) value(215); /* not implemented */
 dcl IDTB_HISTORY        fixed bin(31) value(216); /* not implemented */
 dcl IDTB_FAVORITES      fixed bin(31) value(217); /* not implemented */
 dcl IDTB_JUMP1          fixed bin(31) value(218);
 dcl IDTB_JUMP2          fixed bin(31) value(219);
 dcl IDTB_CUSTOMIZE      fixed bin(31) value(221);
 dcl IDTB_ZOOM           fixed bin(31) value(222);
 dcl IDTB_TOC_NEXT       fixed bin(31) value(223);
 dcl IDTB_TOC_PREV       fixed bin(31) value(224);

 /* Notification codes */

 dcl HHN_FIRST           fixed bin(31) value(-860);
 dcl HHN_LAST            fixed bin(31) value(-879);

 dcl HHN_NAVCOMPLETE     fixed bin(31) value(HHN_FIRST-0);
 dcl HHN_TRACK           fixed bin(31) value(HHN_FIRST-1);
 dcl HHN_WINDOW_CREATE   fixed bin(31) value(HHN_FIRST-2);

 define structure
   1 HHN_NOTIFY,
     2 hdr    type NMHDR,
     2 pszUrl type PCSTR; /* Multi-byte, null-terminated string */

 define structure
   1 HH_POPUP,
     2 cbStruct      fixed bin(31),/* sizeof this structure           */
     2 hinst         type HINSTANCE,
                     /* instance handle for string resource           */
     2 idString      type UINT,    /* string resource id, or text id  */
                     /* if pszFile is specified in HtmlHelp call      */
     2 pszText       type LPCTSTR, /* used if idString is zero        */
     2 pt            type POINT,   /* top center of popup window      */
     2 clrForeground type COLORREF,/* use -1 for default              */
     2 clrBackground type COLORREF,/* use -1 for default              */
     2 rcMargins     type RECT,    /* amount of space between edges of*/
                     /* window and text, -1 for each member to ignore */
     2 pszFont       type LPCTSTR; /* facename, point size, char set, */
                                   /* BOLD ITALIC UNDERLINE           */

 define structure
   1 HH_AKLINK,
     2 cbStruct      fixed bin(31),/* sizeof this structure           */
     2 fReserved     type BOOL,    /* must be FALSE (really!)         */
     2 pszKeywords   type LPCTSTR, /* semi-colon separated keywords   */
     2 pszUrl        type LPCTSTR, /* URL to jump to if no keywords   */
                                   /* found (may be NULL)             */
     2 pszMsgText    type LPCTSTR, /* Message text to display in      */
                 /* MessageBox if pszUrl is NULL and no keyword match */
     2 pszMsgTitle   type LPCTSTR, /* Message text to display in      */
                 /* MessageBox if pszUrl is NULL and no keyword match */
     2 pszWindow     type LPCTSTR, /* Window to display URL in        */
     2 fIndexOnFail  type BOOL;    /* Displays index if keyword       */
                                   /* lookup fails.                   */

 define ordinal HH_NAVTYPE
   ( HHWIN_NAVTYPE_TOC,
     HHWIN_NAVTYPE_INDEX,
     HHWIN_NAVTYPE_SEARCH,
     HHWIN_NAVTYPE_FAVORITES,
     HHWIN_NAVTYPE_HISTORY, /* not implemented */
     HHWIN_NAVTYPE_AUTHOR,
     HHWIN_NAVTYPE_CUSTOM_FIRST value(11)
   ) prec (31);

 define ordinal HH_IDNOTIFY
   ( IT_INCLUSIVE,
     IT_EXCLUSIVE,
     IT_HIDDEN
   ) prec (31);

 define structure
   1 HH_ENUM_IT,
     2 cbStruct   fixed bin(31),/* size of this structure             */
     2 iType      fixed bin(31),/* the type of the information type   */
       /* ie. Inclusive, Exclusive, or Hidden                         */
     2 pszCatName type LPCSTR,  /* Set to the name of the Category to */
       /* enumerate the info types in a category; else NULL           */
     2 pszITName  type LPCSTR,  /* volatile pointer to the name of the*/
       /* infotype. Allocated by call. Caller responsible for freeing */
     2 pszITDescription type LPCSTR;/* volatile pointer to the        */
       /* description of the infotype. */
 define alias PHH_ENUM_IT handle HH_ENUM_IT;

 define structure
   1 HH_ENUM_CAT,
     2 cbStruct   fixed bin(31),/* size of this structure             */
     2 pszCatName type LPCSTR,/* volatile pointer to the category name*/
     2 pszCatDescription type LPCSTR;
       /* volatile pointer to the category description                */
 define alias PHH_ENUM_CAT handle HH_ENUM_CAT;

 define structure
   1 HH_SET_INFOTYPE,
     2 cbStruct   fixed bin(31),/* the size of this structure         */
     2 pszCatName type LPCSTR,  /* the name of the category, if any,  */
                                /* the InfoType is a member of.       */
     2 pszInfoTypeName type LPCSTR;
       /* the name of the info type to add to the filter              */
 define alias PHH_SET_INFOTYPE handle HH_SET_INFOTYPE;

 define alias  HH_INFOTYPE type DWORD;
 define alias PHH_INFOTYPE pointer;

 define ordinal HH_TABPOS
   ( HHWIN_NAVTAB_TOP,
     HHWIN_NAVTAB_LEFT,
     HHWIN_NAVTAB_BOTTOM
   ) prec(31);

 dcl HH_MAX_TABS fixed bin(31) value(19);
 /* maximum number of tabs */

 define ordinal HH_TABS
   ( HH_TAB_CONTENTS,
     HH_TAB_INDEX,
     HH_TAB_SEARCH,
     HH_TAB_FAVORITES,
     HH_TAB_HISTORY,
     HH_TAB_AUTHOR,
     HH_TAB_CUSTOM_FIRST value (11),
     HH_TAB_CUSTOM_LAST  value (19) /* = HH_MAX_TABS */
   ) prec(7);

 dcl HH_MAX_TABS_CUSTOM fixed bin(31)
     value (binvalue (HH_TAB_CUSTOM_LAST)
            - binvalue (HH_TAB_CUSTOM_FIRST) + 1);

 /* HH_DISPLAY_SEARCH Command Related Structures and Constants */

 dcl HH_FTS_DEFAULT_PROXIMITY fixed bin(31) value(-1 );

 define structure
   1 HH_FTS_QUERY,
     2 cbStruct        fixed bin(31),/* Sizeof structure in bytes.   */
     2 fUniCodeStrings type BOOL,/* TRUE if all strings are unicode. */
     2 pszSearchQuery  type LPCTSTR,
                       /* String containing the search query.        */
     2 iProximity      type LONG,    /* Word proximity.              */
     2 fStemmedSearch  type BOOL,    /* TRUE for StemmedSearch only. */
     2 fTitleOnly      type BOOL,    /* TRUE for Title search only.  */
     2 fExecute        type BOOL,    /* TRUE to initiate the search. */
     2 pszWindow       type LPCTSTR; /* Window to display in         */

 /* HH_WINTYPE Structure */

 define structure
   1 HH_WINTYPE,
     2 cbStruct        fixed bin(31),
       /* IN: size of this structure including all Information Types */
     2 fUniCodeStrings type BOOL,
       /* IN/OUT: TRUE if all strings are in UNICODE */
     2 pszType         type LPCTSTR,
       /* IN/OUT: Name of a type of window */
     2 fsValidMembers  type DWORD,
       /* IN: Bit flag of valid members (HHWIN_PARAM_) */
     2 fsWinProperties type DWORD,
       /* IN/OUT: Properties/attributes of the window (HHWIN_) */
     2 pszCaption      type LPCTSTR,
       /* IN/OUT: Window title */
     2 dwStyles        type DWORD,
       /* IN/OUT: Window styles */
     2 dwExStyles      type DWORD,
       /* IN/OUT: Extended Window styles */
     2 rcWindowPos     type RECT,
       /* IN: Starting position, OUT: current position */
     2 nShowState      fixed bin(31),
       /* IN: show state (e.g., SW_SHOW) */
     2 hwndHelp        type HWND,
       /* OUT: window handle */
     2 hwndCaller      type HWND,
       /* OUT: who called this window */
     2 paInfoTypes     type PHH_INFOTYPE,
       /* IN: Pointer to an array of Information Types */
     /* The following members are only valid */
     /* if HHWIN_PROP_TRI_PANE is set */
     2 hwndToolBar     type HWND,
       /* OUT: toolbar window in tri-pane window */
     2 hwndNavigation  type HWND,
       /* OUT: navigation window in tri-pane window */
     2 hwndHTML        type HWND,
       /* OUT: window displaying HTML in tri-pane window */
     2 iNavWidth       fixed bin(31),
       /* IN/OUT: width of navigation window */
     2 rcHTML          type RECT,
       /* OUT: HTML window coordinates */
     2 pszToc          type LPCTSTR,
       /* IN: Location of the table of contents file */
     2 pszIndex        type LPCTSTR,
       /* IN: Location of the index file */
     2 pszFile         type LPCTSTR,
       /* IN: Default location of the html file */
     2 pszHome         type LPCTSTR,
       /* IN/OUT: html file to display when Home button is clicked */
     2 fsToolBarFlags  type DWORD,
       /* IN: flags controling the appearance of the toolbar */
     2 fNotExpanded    type BOOL,
       /* IN: TRUE/FALSE to contract or expand, OUT: current state */
     2 curNavType      type HH_NAVTYPE,
       /* IN/OUT: UI to display in the navigational pane */
     2 tabpos          type HH_TABPOS,
       /* IN/OUT: HHWIN_NAVTAB_TOP, HHWIN_NAVTAB_LEFT, */
       /* or HHWIN_NAVTAB_BOTTOM */
     2 idNotify        type HH_IDNOTIFY,
       /* IN: ID to use for WM_NOTIFY messages */
     2 tabOrder (HH_MAX_TABS + 1) type HH_TABS,
       /* IN/OUT: tab order: Contents, Index, Search, History, */
       /* Favorites, Reserved 1-5, Custom tabs */
     2 cHistory        fixed bin(31),
       /* IN/OUT: number of history items to keep (default is 30) */
     2 pszJump1        type LPCTSTR,
       /* Text for HHWIN_BUTTON_JUMP1 */
     2 pszJump2        type LPCTSTR,
       /* Text for HHWIN_BUTTON_JUMP2 */
     2 pszUrlJump1     type LPCTSTR,
       /* URL for HHWIN_BUTTON_JUMP1 */
     2 pszUrlJump2     type LPCTSTR,
       /* URL for HHWIN_BUTTON_JUMP2 */
     2 rcMinSize       type RECT,
       /* Minimum size for window (ignored in version 1) */
     2 cbInfoTypes     fixed bin(31),
       /* size of paInfoTypes; */
     2 pszCustomTabs   type LPCTSTR;
       /* multiple zero-terminated strings */
 define alias PHH_WINTYPE handle HH_WINTYPE;

 define ordinal HH_ACTION
   ( HHACT_TAB_CONTENTS,
     HHACT_TAB_INDEX,
     HHACT_TAB_SEARCH,
     HHACT_TAB_HISTORY,
     HHACT_TAB_FAVORITES,

     HHACT_EXPAND,
     HHACT_CONTRACT,
     HHACT_BACK,
     HHACT_FORWARD,
     HHACT_STOP,
     HHACT_REFRESH,
     HHACT_HOME,
     HHACT_SYNC,
     HHACT_OPTIONS,
     HHACT_PRINT,
     HHACT_HIGHLIGHT,
     HHACT_CUSTOMIZE,
     HHACT_JUMP1,
     HHACT_JUMP2,
     HHACT_ZOOM,
     HHACT_TOC_NEXT,
     HHACT_TOC_PREV,
     HHACT_NOTES,

     HHACT_LAST_ENUM
   ) prec(31);

 define structure
   1 HHNTRACK,
     2 hdr        type NMHDR,
     2 pszCurUrl  type PCSTR, /* Multi-byte, null-terminated string */
     2 idAction   type HH_ACTION, /* HHACT_ value */
     2 phhWinType pointer;    /* Current window type structure */

 dcl HtmlHelpA
     entry (type HWND,
            char(*) varz byaddr nonasgn,
            type UINT,
            type DWORD_PTR)
     returns (type HWND byvalue optional)
     WINAPI external('HtmlHelpA');

 dcl HtmlHelpW
     entry (type HWND,
            WCHAR(*) varz byaddr nonasgn,
            type UINT,
            type DWORD_PTR)
      returns (type HWND byvalue optional)
      WINAPI external('HtmlHelpW');

 %dcl HtmlHelp char ext;
 %dcl UNICODE char ext;
 %if UNICODE ^= '' %then %do;
   %HtmlHelp='HtmlHelpW';
 %end; %else %do;
   %HtmlHelp='HtmlHelpA';
 %end; /* !UNICODE */

 /* Use the following for GetProcAddress to load from hhctrl.ocx */

 %dcl ATOM_HTMLHELP_API_ANSI    char;
 %ATOM_HTMLHELP_API_ANSI    = 'pli_b2z (14)'; /* pli_b2z: windef.cpy */
 %dcl ATOM_HTMLHELP_API_UNICODE char;
 %ATOM_HTMLHELP_API_UNICODE = 'pli_b2z (15)'; /* pli_b2z: windef.cpy */

 /* Global Control Properties. */

 define ordinal HH_GPROPID
   ( HH_GPROPID_SINGLETHREAD     value(1),
        /* VARIANT_BOOL: True for single thread */
     HH_GPROPID_TOOLBAR_MARGIN   value(2),
        /* long: Provides a left/right margin around the toolbar. */
     HH_GPROPID_UI_LANGUAGE      value(3),
        /* long: LangId of the UI. */
     HH_GPROPID_CURRENT_SUBSET   value(4),
        /* BSTR: Current subset. */
     HH_GPROPID_CONTENT_LANGUAGE value(5)
        /* long: LandId for desired content. */
   ) prec(31);

 /* Global Property structure */

 %dcl #_oaidl_h__ char ext;
 %if #_oaidl_h__ ^= '' %then %do;

 /* #pragma pack(push, 8) */

 define structure
   1 HH_GLOBAL_PROPERTY,
    2 id  type HH_GPROPID,
    2 var type VARIANT;

 /* #pragma pack(pop) */

 %end;

 %end; /* __HTMLHELP_H__ */
