 /* ++ BUILD Version: 0001                              */
 /*    -- Increment this if a change has global effects */
 /********************************************************************/
 /**                     Microsoft LAN Manager                      **/
 /**               Copyright(c) Microsoft Corp., 1987-1997          **/
 /********************************************************************/

 /* lmerr.CPY - network error definitions */


 /** INTERNAL_ONLY **/

 /*********** WARNING ******************/
 /* See the comment in lmcons.cpy for  */
 /* info on the allocation of errors   */
 /**************************************/

 /** END_INTERNAL **/

 %dcl NETERR_INCLUDED char ext;
 %if NETERR_INCLUDED = '' %then %do;

 %NETERR_INCLUDED = 'Y';


 dcl NERR_Success fixed bin(31) value(0); /* Success */

 /* ERROR_ equates can be intermixed with NERR_ equates. */
 %dcl #WINERROR_ char ext;
 %if #WINERROR_ = '' %then %do;
 %include winerror;
 %end;


 /* NERR_BASE is the base of error codes from network utilities,     */
 /* chosen to avoid conflict with system and redirector error codes. */
 /* 2100 is a value that has been assigned to us by system.          */
 dcl NERR_BASE fixed bin(31) value(2100);


 /** INTERNAL_ONLY **/

 /*********** WARNING ****************/
 /* See the comment in lmcons.h for  */
 /* info on the allocation of errors */
 /************************************/

 /*********** WARNING ****************/
 /* The range 2750-2799 has been     */
 /* allocated to the IBM LAN Server  */
 /************************************/

 /*********** WARNING ****************/
 /* The range 2900-2999 has been     */
 /* reserved for Microsoft OEMs      */
 /************************************/

 /** END_INTERNAL **/

 /* UNUSED BASE+0 */
 /* UNUSED BASE+1 */
 dcl NERR_NetNotStarted            fixed bin(31) value(NERR_BASE+2);
     /* The workstation driver is not installed. */
 dcl NERR_UnknownServer            fixed bin(31) value(NERR_BASE+3);
     /* The server could not be located. */
 dcl NERR_ShareMem                 fixed bin(31) value(NERR_BASE+4);
     /* An internal error occurred. */
     /* The network cannot access a shared memory segment. */

 dcl NERR_NoNetworkResource        fixed bin(31) value(NERR_BASE+5);
     /* A network resource shortage occurred . */
 dcl NERR_RemoteOnly               fixed bin(31) value(NERR_BASE+6);
     /* This operation is not supported on workstations. */
 dcl NERR_DevNotRedirected         fixed bin(31) value(NERR_BASE+7);
     /* The device is not connected. */
 /* NERR_BASE+8 is used for ERROR_CONNECTED_OTHER_PASSWORD */
 /* UNUSED BASE+9 */
 /* UNUSED BASE+10 */
 /* UNUSED BASE+11 */
 /* UNUSED BASE+12 */
 /* UNUSED BASE+13 */
 dcl NERR_ServerNotStarted         fixed bin(31) value(NERR_BASE+14);
     /* The Server service is not started. */
 dcl NERR_ItemNotFound             fixed bin(31) value(NERR_BASE+15);
     /* The queue is empty. */
 dcl NERR_UnknownDevDir            fixed bin(31) value(NERR_BASE+16);
     /* The device or directory does not exist. */
 dcl NERR_RedirectedPath           fixed bin(31) value(NERR_BASE+17);
     /* The operation is invalid on a redirected resource. */
 dcl NERR_DuplicateShare           fixed bin(31) value(NERR_BASE+18);
     /* The name has already been shared. */
 dcl NERR_NoRoom                   fixed bin(31) value(NERR_BASE+19);
     /* The server is currently out of the requested resource. */
 /* UNUSED BASE+20 */
 dcl NERR_TooManyItems             fixed bin(31) value(NERR_BASE+21);
     /* Requested addition of items exceeds the maximum allowed. */
 dcl NERR_InvalidMaxUsers          fixed bin(31) value(NERR_BASE+22);
     /* The Peer service supports only two simultaneous users. */
 dcl NERR_BufTooSmall              fixed bin(31) value(NERR_BASE+23);
     /* The API return buffer is too small. */
 /* UNUSED BASE+24 */
 /* UNUSED BASE+25 */
 /* UNUSED BASE+26 */
 dcl NERR_RemoteErr                fixed bin(31) value(NERR_BASE+27);
     /* A remote API error occurred.  */
 /* UNUSED BASE+28 */
 /* UNUSED BASE+29 */
 /* UNUSED BASE+30 */
 dcl NERR_LanmanIniError           fixed bin(31) value(NERR_BASE+31);
     /* An error occurred when opening or reading */
     /* the configuration file.                   */
 /* UNUSED BASE+32 */
 /* UNUSED BASE+33 */
 /* UNUSED BASE+34 */
 /* UNUSED BASE+35 */
 dcl NERR_NetworkError             fixed bin(31) value(NERR_BASE+36);
     /* A general network error occurred. */
 dcl NERR_WkstaInconsistentState   fixed bin(31) value(NERR_BASE+37);
     /* The Workstation service is in an inconsistent state. Restart */
     /* the computer before restarting the Workstation service.      */
 dcl NERR_WkstaNotStarted          fixed bin(31) value(NERR_BASE+38);
     /* The Workstation service has not been started. */
 dcl NERR_BrowserNotStarted        fixed bin(31) value(NERR_BASE+39);
 /* The requested information is not available. */
 dcl NERR_InternalError            fixed bin(31) value(NERR_BASE+40);
 /* An internal Windows NT error occurred.*/
 dcl NERR_BadTransactConfig        fixed bin(31) value(NERR_BASE+41);
 /* The server is not configured for transactions. */
 dcl NERR_InvalidAPI               fixed bin(31) value(NERR_BASE+42);
 /* The requested API is not supported on the remote server. */
 dcl NERR_BadEventName             fixed bin(31) value(NERR_BASE+43);
 /* The event name is invalid. */
 dcl NERR_DupNameReboot            fixed bin(31) value(NERR_BASE+44);
     /* The computer name already exists on the network. */
     /* Change it and restart the computer.              */

 /* Config API related                  */
 /* Error codes from BASE+45 to BASE+49 */

 /* UNUSED BASE+45 */
 dcl NERR_CfgCompNotFound          fixed bin(31) value(NERR_BASE+46);
     /* The specified component could not be found in */
     /* the configuration information.                */
 dcl NERR_CfgParamNotFound         fixed bin(31) value(NERR_BASE+47);
     /* The specified parameter could not be found in */
     /* the configuration information.                */
 dcl NERR_LineTooLong              fixed bin(31) value(NERR_BASE+49);
     /* A line in the configuration file is too long. */

 /* Spooler API related                 */
 /* Error codes from BASE+50 to BASE+79 */

 dcl NERR_QNotFound                fixed bin(31) value(NERR_BASE+50);
     /* The printer does not exist. */
 dcl NERR_JobNotFound              fixed bin(31) value(NERR_BASE+51);
     /* The print job does not exist. */
 dcl NERR_DestNotFound             fixed bin(31) value(NERR_BASE+52);
     /* The printer destination cannot be found. */
 dcl NERR_DestExists               fixed bin(31) value(NERR_BASE+53);
     /* The printer destination already exists. */
 dcl NERR_QExists                  fixed bin(31) value(NERR_BASE+54);
     /* The printer queue already exists. */
 dcl NERR_QNoRoom                  fixed bin(31) value(NERR_BASE+55);
     /* No more printers can be added. */
 dcl NERR_JobNoRoom                fixed bin(31) value(NERR_BASE+56);
     /* No more print jobs can be added.  */
 dcl NERR_DestNoRoom               fixed bin(31) value(NERR_BASE+57);
     /* No more printer destinations can be added. */
 dcl NERR_DestIdle                 fixed bin(31) value(NERR_BASE+58);
     /* This printer destination is idle and cannot accept control */
     /* operations.                                                */
 dcl NERR_DestInvalidOp            fixed bin(31) value(NERR_BASE+59);
     /* This printer destination request contains an invalid control */
     /* function. */
 dcl NERR_ProcNoRespond            fixed bin(31) value(NERR_BASE+60);
     /* The print processor is not responding. */
 dcl NERR_SpoolerNotLoaded         fixed bin(31) value(NERR_BASE+61);
     /* The spooler is not running. */
 dcl NERR_DestInvalidState         fixed bin(31) value(NERR_BASE+62);
     /* This operation cannot be performed on the print destination */
     /* in its current state.                                       */
 dcl NERR_QInvalidState            fixed bin(31) value(NERR_BASE+63);
     /* This operation cannot be performed on the printer queue */
     /* in its current state. */
 dcl NERR_JobInvalidState          fixed bin(31) value(NERR_BASE+64);
     /* This operation cannot be performed on the print job */
     /* in its current state.                               */
 dcl NERR_SpoolNoMemory            fixed bin(31) value(NERR_BASE+65);
     /* A spooler memory allocation failure occurred. */
 dcl NERR_DriverNotFound           fixed bin(31) value(NERR_BASE+66);
     /* The device driver does not exist. */
 dcl NERR_DataTypeInvalid          fixed bin(31) value(NERR_BASE+67);
     /* The data type is not supported by the print processor. */
 dcl NERR_ProcNotFound             fixed bin(31) value(NERR_BASE+68);
     /* The print processor is not installed. */

 /* Service API related                 */
 /* Error codes from BASE+80 to BASE+99 */

 dcl NERR_ServiceTableLocked       fixed bin(31) value(NERR_BASE+80);
     /* The service database is locked. */
 dcl NERR_ServiceTableFull         fixed bin(31) value(NERR_BASE+81);
     /* The service table is full. */
 dcl NERR_ServiceInstalled         fixed bin(31) value(NERR_BASE+82);
     /* The requested service has already been started. */
 dcl NERR_ServiceEntryLocked       fixed bin(31) value(NERR_BASE+83);
     /* The service does not respond to control actions. */
 dcl NERR_ServiceNotInstalled      fixed bin(31) value(NERR_BASE+84);
     /* The service has not been started. */
 dcl NERR_BadServiceName           fixed bin(31) value(NERR_BASE+85);
     /* The service name is invalid. */
 dcl NERR_ServiceCtlTimeout        fixed bin(31) value(NERR_BASE+86);
     /* The service is not responding to the control function. */
 dcl NERR_ServiceCtlBusy           fixed bin(31) value(NERR_BASE+87);
     /* The service control is busy. */
 dcl NERR_BadServiceProgName       fixed bin(31) value(NERR_BASE+88);
     /* The configuration file contains an invalid service */
     /* program name.                                      */
 dcl NERR_ServiceNotCtrl           fixed bin(31) value(NERR_BASE+89);
     /* The service could not be controlled in its present state. */
 dcl NERR_ServiceKillProc          fixed bin(31) value(NERR_BASE+90);
     /* The service ended abnormally. */
 dcl NERR_ServiceCtlNotValid       fixed bin(31) value(NERR_BASE+91);
     /* The requested pause or stop is not valid for this service. */
 dcl NERR_NotInDispatchTbl         fixed bin(31) value(NERR_BASE+92);
     /* The service control dispatcher could not find the service */
     /* name in the dispatch table.                               */
 dcl NERR_BadControlRecv           fixed bin(31) value(NERR_BASE+93);
     /* The service control dispatcher pipe read failed. */
 dcl NERR_ServiceNotStarting       fixed bin(31) value(NERR_BASE+94);
     /* A thread for the new service could not be created. */

 /* Wksta and Logon API related           */
 /* Error codes from BASE+100 to BASE+118 */

 dcl NERR_AlreadyLoggedOn          fixed bin(31) value(NERR_BASE+100);
     /* This workstation is already logged on to the local-area */
     /* network.                                                */
 dcl NERR_NotLoggedOn              fixed bin(31) value(NERR_BASE+101);
     /* The workstation is not logged on to the local-area network. */
 dcl NERR_BadUsername              fixed bin(31) value(NERR_BASE+102);
     /* The user name or group name parameter is invalid.  */
 dcl NERR_BadPassword              fixed bin(31) value(NERR_BASE+103);
     /* The password parameter is invalid. */
 dcl NERR_UnableToAddName_W        fixed bin(31) value(NERR_BASE+104);
     /* @W The logon processor did not add the message alias. */
 dcl NERR_UnableToAddName_F        fixed bin(31) value(NERR_BASE+105);
     /* The logon processor did not add the message alias. */
 dcl NERR_UnableToDelName_W        fixed bin(31) value(NERR_BASE+106);
     /* @W The logoff processor did not delete the message alias. */
 dcl NERR_UnableToDelName_F        fixed bin(31) value(NERR_BASE+107);
     /* The logoff processor did not delete the message alias. */
 /* UNUSED BASE+108 */
 dcl NERR_LogonsPaused             fixed bin(31) value(NERR_BASE+109);
     /* Network logons are paused. */
 dcl NERR_LogonServerConflict      fixed bin(31) value(NERR_BASE+110);
     /* A centralized logon-server conflict occurred. */
 dcl NERR_LogonNoUserPath          fixed bin(31) value(NERR_BASE+111);
     /* The server is configured without a valid user path. */
 dcl NERR_LogonScriptError         fixed bin(31) value(NERR_BASE+112);
     /* An error occurred while loading or running the logon script. */
 /* UNUSED BASE+113 */
 dcl NERR_StandaloneLogon          fixed bin(31) value(NERR_BASE+114);
     /* The logon server was not specified.            */
     /* Your computer will be logged on as STANDALONE. */
 dcl NERR_LogonServerNotFound      fixed bin(31) value(NERR_BASE+115);
     /* The logon server could not be found.  */
 dcl NERR_LogonDomainExists        fixed bin(31) value(NERR_BASE+116);
     /* There is already a logon domain for this computer.  */
 dcl NERR_NonValidatedLogon        fixed bin(31) value(NERR_BASE+117);
     /* The logon server could not validate the logon. */

 /* ACF API related (access, user, group) */
 /* Error codes from BASE+119 to BASE+149 */

 dcl NERR_ACFNotFound              fixed bin(31) value(NERR_BASE+119);
     /* The security database could not be found. */
 dcl NERR_GroupNotFound            fixed bin(31) value(NERR_BASE+120);
     /* The group name could not be found. */
 dcl NERR_UserNotFound             fixed bin(31) value(NERR_BASE+121);
     /* The user name could not be found. */
 dcl NERR_ResourceNotFound         fixed bin(31) value(NERR_BASE+122);
     /* The resource name could not be found.  */
 dcl NERR_GroupExists              fixed bin(31) value(NERR_BASE+123);
     /* The group already exists. */
 dcl NERR_UserExists               fixed bin(31) value(NERR_BASE+124);
     /* The user account already exists. */
 dcl NERR_ResourceExists           fixed bin(31) value(NERR_BASE+125);
     /* The resource permission list already exists. */
 dcl NERR_NotPrimary               fixed bin(31) value(NERR_BASE+126);
     /* This operation is only allowed on the primary domain */
     /* controller of the domain.                            */
 dcl NERR_ACFNotLoaded             fixed bin(31) value(NERR_BASE+127);
     /* The security database has not been started. */
 dcl NERR_ACFNoRoom                fixed bin(31) value(NERR_BASE+128);
     /* There are too many names in the user accounts database. */
 dcl NERR_ACFFileIOFail            fixed bin(31) value(NERR_BASE+129);
     /* A disk I/O failure occurred.*/
 dcl NERR_ACFTooManyLists          fixed bin(31) value(NERR_BASE+130);
    /* The limit of 64 entries per resource was exceeded. */
 dcl NERR_UserLogon                fixed bin(31) value(NERR_BASE+131);
     /* Deleting a user with a session is not allowed. */
 dcl NERR_ACFNoParent              fixed bin(31) value(NERR_BASE+132);
     /* The parent directory could not be located. */
 dcl NERR_CanNotGrowSegment        fixed bin(31) value(NERR_BASE+133);
     /* Unable to add to the security database session cache segment. */
 dcl NERR_SpeGroupOp               fixed bin(31) value(NERR_BASE+134);
     /* This operation is not allowed on this special group. */
 dcl NERR_NotInCache               fixed bin(31) value(NERR_BASE+135);
    /* This user is not cached in user accounts database */
    /* session cache.                                    */
 dcl NERR_UserInGroup              fixed bin(31) value(NERR_BASE+136);
     /* The user already belongs to this group. */
 dcl NERR_UserNotInGroup           fixed bin(31) value(NERR_BASE+137);
     /* The user does not belong to this group. */
 dcl NERR_AccountUndefined         fixed bin(31) value(NERR_BASE+138);
     /* This user account is undefined. */
 dcl NERR_AccountExpired           fixed bin(31) value(NERR_BASE+139);
     /* This user account has expired. */
 dcl NERR_InvalidWorkstation       fixed bin(31) value(NERR_BASE+140);
     /* The user is not allowed to log on from this workstation. */
 dcl NERR_InvalidLogonHours        fixed bin(31) value(NERR_BASE+141);
     /* The user is not allowed to log on at this time.  */
 dcl NERR_PasswordExpired          fixed bin(31) value(NERR_BASE+142);
     /* The password of this user has expired. */
 dcl NERR_PasswordCantChange       fixed bin(31) value(NERR_BASE+143);
     /* The password of this user cannot change. */
 dcl NERR_PasswordHistConflict     fixed bin(31) value(NERR_BASE+144);
     /* This password cannot be used now. */
 dcl NERR_PasswordTooShort         fixed bin(31) value(NERR_BASE+145);
     /* The password is shorter than required. */
 dcl NERR_PasswordTooRecent        fixed bin(31) value(NERR_BASE+146);
     /* The password of this user is too recent to change.  */
 dcl NERR_InvalidDatabase          fixed bin(31) value(NERR_BASE+147);
     /* The security database is corrupted. */
 dcl NERR_DatabaseUpToDate         fixed bin(31) value(NERR_BASE+148);
     /* No updates are necessary to this replicant network/local */
     /* security database.                                       */
 dcl NERR_SyncRequired             fixed bin(31) value(NERR_BASE+149);
     /* This replicant database is outdated, */
     /* synchronization is required.         */

 /* Use API related                       */
 /* Error codes from BASE+150 to BASE+169 */

 dcl NERR_UseNotFound              fixed bin(31) value(NERR_BASE+150);
     /* The network connection could not be found. */
 dcl NERR_BadAsgType               fixed bin(31) value(NERR_BASE+151);
     /* This asg_type is invalid. */
 dcl NERR_DeviceIsShared           fixed bin(31) value(NERR_BASE+152);
     /* This device is currently being shared. */

 /* Message Server related           */
 /* Error codes BASE+170 to BASE+209 */

 dcl NERR_NoComputerName           fixed bin(31) value(NERR_BASE+170);
     /* The computer name could not be added as a message alias. */
     /* The name may already exist on the network. */
 dcl NERR_MsgAlreadyStarted        fixed bin(31) value(NERR_BASE+171);
     /* The Messenger service is already started. */
 dcl NERR_MsgInitFailed            fixed bin(31) value(NERR_BASE+172);
     /* The Messenger service failed to start.  */
 dcl NERR_NameNotFound             fixed bin(31) value(NERR_BASE+173);
     /* The message alias could not be found on the network. */
 dcl NERR_AlreadyForwarded         fixed bin(31) value(NERR_BASE+174);
     /* This message alias has already been forwarded. */
 dcl NERR_AddForwarded             fixed bin(31) value(NERR_BASE+175);
     /* This message alias has been added but is still forwarded. */
 dcl NERR_AlreadyExists            fixed bin(31) value(NERR_BASE+176);
     /* This message alias already exists locally. */
 dcl NERR_TooManyNames             fixed bin(31) value(NERR_BASE+177);
     /* The maximum number of added message aliases has been exceeded.*/
 dcl NERR_DelComputerName          fixed bin(31) value(NERR_BASE+178);
     /* The computer name could not be deleted.*/
 dcl NERR_LocalForward             fixed bin(31) value(NERR_BASE+179);
     /* Messages cannot be forwarded back to the same workstation. */
 dcl NERR_GrpMsgProcessor          fixed bin(31) value(NERR_BASE+180);
     /* An error occurred in the domain message processor. */
 dcl NERR_PausedRemote             fixed bin(31) value(NERR_BASE+181);
     /* The message was sent, but the recipient has paused the */
     /* Messenger service.                                     */
 dcl NERR_BadReceive               fixed bin(31) value(NERR_BASE+182);
     /* The message was sent but not received. */
 dcl NERR_NameInUse                fixed bin(31) value(NERR_BASE+183);
     /* The message alias is currently in use. Try again later. */
 dcl NERR_MsgNotStarted            fixed bin(31) value(NERR_BASE+184);
     /* The Messenger service has not been started. */
 dcl NERR_NotLocalName             fixed bin(31) value(NERR_BASE+185);
     /* The name is not on the local computer. */
 dcl NERR_NoForwardName            fixed bin(31) value(NERR_BASE+186);
     /* The forwarded message alias could not be found on the network.*/
 dcl NERR_RemoteFull               fixed bin(31) value(NERR_BASE+187);
     /* The message alias table on the remote station is full. */
 dcl NERR_NameNotForwarded         fixed bin(31) value(NERR_BASE+188);
     /* Messages for this alias are not currently being forwarded. */
 dcl NERR_TruncatedBroadcast       fixed bin(31) value(NERR_BASE+189);
     /* The broadcast message was truncated. */
 dcl NERR_InvalidDevice            fixed bin(31) value(NERR_BASE+194);
     /* This is an invalid device name. */
 dcl NERR_WriteFault               fixed bin(31) value(NERR_BASE+195);
     /* A write fault occurred. */
 /* UNUSED BASE+196 */
 dcl NERR_DuplicateName            fixed bin(31) value(NERR_BASE+197);
     /* A duplicate message alias exists on the network. */
 dcl NERR_DeleteLater              fixed bin(31) value(NERR_BASE+198);
     /* @W This message alias will be deleted later. */
 dcl NERR_IncompleteDel            fixed bin(31) value(NERR_BASE+199);
     /* The message alias was not successfully deleted from all */
     /* networks.                                               */
 dcl NERR_MultipleNets             fixed bin(31) value(NERR_BASE+200);
     /* This operation is not supported on computers with multiple */
     /* networks.                                                  */

 /* Server API related               */
 /* Error codes BASE+210 to BASE+229 */

 dcl NERR_NetNameNotFound          fixed bin(31) value(NERR_BASE+210);
     /* This shared resource does not exist.*/
 dcl NERR_DeviceNotShared          fixed bin(31) value(NERR_BASE+211);
     /* This device is not shared. */
 dcl NERR_ClientNameNotFound       fixed bin(31) value(NERR_BASE+212);
     /* A session does not exist with that computer name. */
 dcl NERR_FileIdNotFound           fixed bin(31) value(NERR_BASE+214);
     /* There is not an open file with that identification number. */
 dcl NERR_ExecFailure              fixed bin(31) value(NERR_BASE+215);
     /* A failure occurred when executing a remote administration */
     /* command.                                                  */
 dcl NERR_TmpFile                  fixed bin(31) value(NERR_BASE+216);
     /* A failure occurred when opening a remote temporary file. */
 dcl NERR_TooMuchData              fixed bin(31) value(NERR_BASE+217);
     /* The data returned from a remote administration command has */
     /* been truncated to 64K.                                     */
 dcl NERR_DeviceShareConflict      fixed bin(31) value(NERR_BASE+218);
     /* This device cannot be shared as both a spooled and a */
     /* non-spooled resource.                                */
 dcl NERR_BrowserTableIncomplete   fixed bin(31) value(NERR_BASE+219);
     /* The information in the list of servers may be incorrect. */
 dcl NERR_NotLocalDomain           fixed bin(31) value(NERR_BASE+220);
     /* The computer is not active in this domain. */
 dcl NERR_IsDfsShare               fixed bin(31) value(NERR_BASE+221);
     /* The share must be removed from the Distributed File System */
     /* before it can be deleted.                                  */

 /* CharDev API related              */
 /* Error codes BASE+230 to BASE+249 */

 /* UNUSED BASE+230 */
 dcl NERR_DevInvalidOpCode         fixed bin(31) value(NERR_BASE+231);
     /* The operation is invalid for this device. */
 dcl NERR_DevNotFound              fixed bin(31) value(NERR_BASE+232);
     /* This device cannot be shared. */
 dcl NERR_DevNotOpen               fixed bin(31) value(NERR_BASE+233);
     /* This device was not open. */
 dcl NERR_BadQueueDevString        fixed bin(31) value(NERR_BASE+234);
     /* This device name list is invalid. */
 dcl NERR_BadQueuePriority         fixed bin(31) value(NERR_BASE+235);
     /* The queue priority is invalid. */
 dcl NERR_NoCommDevs               fixed bin(31) value(NERR_BASE+237);
     /* There are no shared communication devices. */
 dcl NERR_QueueNotFound            fixed bin(31) value(NERR_BASE+238);
     /* The queue you specified does not exist. */
 dcl NERR_BadDevString             fixed bin(31) value(NERR_BASE+240);
     /* This list of devices is invalid. */
 dcl NERR_BadDev                   fixed bin(31) value(NERR_BASE+241);
     /* The requested device is invalid. */
 dcl NERR_InUseBySpooler           fixed bin(31) value(NERR_BASE+242);
     /* This device is already in use by the spooler. */
 dcl NERR_CommDevInUse             fixed bin(31) value(NERR_BASE+243);
     /* This device is already in use as a communication device. */

 /* NetICanonicalize and NetIType and NetIMakeLMFileName */
 /* NetIListCanon and NetINameCheck                      */
 /* Error codes BASE+250 to BASE+269                     */

 dcl NERR_InvalidComputer          fixed bin(31) value(NERR_BASE+251);
    /* This computer name is invalid. */
 /* UNUSED BASE+252 */
 /* UNUSED BASE+253 */
 dcl NERR_MaxLenExceeded           fixed bin(31) value(NERR_BASE+254);
     /* The string and prefix specified are too long. */
 /* UNUSED BASE+255 */
 dcl NERR_BadComponent             fixed bin(31) value(NERR_BASE+256);
     /* This path component is invalid. */
 dcl NERR_CantType                 fixed bin(31) value(NERR_BASE+257);
     /* Could not determine the type of input. */
 /* UNUSED BASE+258 */
 /* UNUSED BASE+259 */
 dcl NERR_TooManyEntries           fixed bin(31) value(NERR_BASE+262);
     /* The buffer for types is not big enough. */

 /* NetProfile                       */
 /* Error codes BASE+270 to BASE+276 */

 dcl NERR_ProfileFileTooBig        fixed bin(31) value(NERR_BASE+270);
     /* Profile files cannot exceed 64K. */
 dcl NERR_ProfileOffset            fixed bin(31) value(NERR_BASE+271);
     /* The start offset is out of range. */
 dcl NERR_ProfileCleanup           fixed bin(31) value(NERR_BASE+272);
     /* The system cannot delete current connections to network */
     /* resources.                                              */
 dcl NERR_ProfileUnknownCmd        fixed bin(31) value(NERR_BASE+273);
     /* The system was unable to parse the command line in this file.*/
 dcl NERR_ProfileLoadErr           fixed bin(31) value(NERR_BASE+274);
     /* An error occurred while loading the profile file. */
 dcl NERR_ProfileSaveErr           fixed bin(31) value(NERR_BASE+275);
     /* @W Errors occurred while saving the profile file. */
     /* The profile was partially saved.                  */


 /* NetAudit and NetErrorLog         */
 /* Error codes BASE+277 to BASE+279 */

 dcl NERR_LogOverflow              fixed bin(31) value(NERR_BASE+277);
     /* Log file %1 is full. */
 dcl NERR_LogFileChanged           fixed bin(31) value(NERR_BASE+278);
     /* This log file has changed between reads. */
 dcl NERR_LogFileCorrupt           fixed bin(31) value(NERR_BASE+279);
     /* Log file %1 is corrupt. */


 /* NetRemote                        */
 /* Error codes BASE+280 to BASE+299 */

 dcl NERR_SourceIsDir              fixed bin(31) value(NERR_BASE+280);
     /* The source path cannot be a directory. */
 dcl NERR_BadSource                fixed bin(31) value(NERR_BASE+281);
     /* The source path is illegal. */
 dcl NERR_BadDest                  fixed bin(31) value(NERR_BASE+282);
     /* The destination path is illegal. */
 dcl NERR_DifferentServers         fixed bin(31) value(NERR_BASE+283);
     /* The source and destination paths are on different servers. */
 /* UNUSED BASE+284 */
 dcl NERR_RunSrvPaused             fixed bin(31) value(NERR_BASE+285);
     /* The Run server you requested is paused. */
 /* UNUSED BASE+286 */
 /* UNUSED BASE+287 */
 /* UNUSED BASE+288 */
 dcl NERR_ErrCommRunSrv            fixed bin(31) value(NERR_BASE+289);
     /* An error occurred when communicating with a Run server. */
 /* UNUSED BASE+290 */
 dcl NERR_ErrorExecingGhost        fixed bin(31) value(NERR_BASE+291);
     /* An error occurred when starting a background process. */
 dcl NERR_ShareNotFound            fixed bin(31) value(NERR_BASE+292);
     /* The shared resource you are connected to could not be found.*/
 /* UNUSED BASE+293 */
 /* UNUSED BASE+294 */


 /* NetWksta.sys (redir) returned error codes. */
 /* NERR_BASE + (300-329)                      */

 dcl NERR_InvalidLana              fixed bin(31) value(NERR_BASE+300);
     /* The LAN adapter number is invalid.  */
 dcl NERR_OpenFiles                fixed bin(31) value(NERR_BASE+301);
     /* There are open files on the connection.    */
 dcl NERR_ActiveConns              fixed bin(31) value(NERR_BASE+302);
     /* Active connections still exist. */
 dcl NERR_BadPasswordCore          fixed bin(31) value(NERR_BASE+303);
     /* This share name or password is invalid. */
 dcl NERR_DevInUse                 fixed bin(31) value(NERR_BASE+304);
     /* The device is being accessed by an active process. */
 dcl NERR_LocalDrive               fixed bin(31) value(NERR_BASE+305);
     /* The drive letter is in use locally. */

 /* Alert error codes.    */
 /* NERR_BASE + (330-339) */

 dcl NERR_AlertExists              fixed bin(31) value(NERR_BASE+330);
     /* The specified client is already registered for */
     /* the specified event.                           */
 dcl NERR_TooManyAlerts            fixed bin(31) value(NERR_BASE+331);
     /* The alert table is full. */
 dcl NERR_NoSuchAlert              fixed bin(31) value(NERR_BASE+332);
     /* An invalid or nonexistent alert name was raised. */
 dcl NERR_BadRecipient             fixed bin(31) value(NERR_BASE+333);
     /* The alert recipient is invalid.*/
 dcl NERR_AcctLimitExceeded        fixed bin(31) value(NERR_BASE+334);
     /* A user's session with this server has been deleted  */
     /* because the user's logon hours are no longer valid. */

 /* Additional Error and Audit log codes. */
 /* NERR_BASE +(340-343)                  */

 dcl NERR_InvalidLogSeek           fixed bin(31) value(NERR_BASE+340);
     /* The log file does not contain the requested record number. */
 /* UNUSED BASE+341 */
 /* UNUSED BASE+342 */
 /* UNUSED BASE+343 */

 /* Additional UAS and NETLOGON codes */
 /* NERR_BASE +(350-359)              */

 dcl NERR_BadUasConfig             fixed bin(31) value(NERR_BASE+350);
     /* The user accounts database is not configured correctly. */
 dcl NERR_InvalidUASOp             fixed bin(31) value(NERR_BASE+351);
     /* This operation is not permitted when the Netlogon service */
     /* is running.                                               */
 dcl NERR_LastAdmin                fixed bin(31) value(NERR_BASE+352);
     /* This operation is not allowed on the last administrative */
     /* account.                                                 */
 dcl NERR_DCNotFound               fixed bin(31) value(NERR_BASE+353);
     /* Could not find domain controller for this domain. */
 dcl NERR_LogonTrackingError       fixed bin(31) value(NERR_BASE+354);
     /* Could not set logon information for this user. */
 dcl NERR_NetlogonNotStarted       fixed bin(31) value(NERR_BASE+355);
     /* The Netlogon service has not been started. */
 dcl NERR_CanNotGrowUASFile        fixed bin(31) value(NERR_BASE+356);
     /* Unable to add to the user accounts database. */
 dcl NERR_TimeDiffAtDC             fixed bin(31) value(NERR_BASE+357);
     /* This server's clock is not synchronized with the */
     /* primary domain controller's clock.               */
 dcl NERR_PasswordMismatch         fixed bin(31) value(NERR_BASE+358);
     /* A password mismatch has been detected. */


 /* Server Integration error codes. */
 /* NERR_BASE +(360-369)            */

 dcl NERR_NoSuchServer             fixed bin(31) value(NERR_BASE+360);
     /* The server identification does not specify a valid server. */
 dcl NERR_NoSuchSession            fixed bin(31) value(NERR_BASE+361);
     /* The session identification does not specify a valid session. */
 dcl NERR_NoSuchConnection         fixed bin(31) value(NERR_BASE+362);
     /* The connection identification does not specify a valid  */
     /* connection.                                             */
 dcl NERR_TooManyServers           fixed bin(31) value(NERR_BASE+363);
     /* There is no space for another entry in the table of */
     /* available servers.                                  */
 dcl NERR_TooManySessions          fixed bin(31) value(NERR_BASE+364);
     /* The server has reached the maximum number of sessions */
     /* it supports.                                          */
 dcl NERR_TooManyConnections       fixed bin(31) value(NERR_BASE+365);
     /* The server has reached the maximum number of connections */
     /* it supports.                                             */
 dcl NERR_TooManyFiles             fixed bin(31) value(NERR_BASE+366);
     /* The server cannot open more files because it has reached */
     /* its maximum number.                                      */
 dcl NERR_NoAlternateServers       fixed bin(31) value(NERR_BASE+367);
     /* There are no alternate servers registered on this server. */
 /* UNUSED BASE+368 */
 /* UNUSED BASE+369 */

 dcl NERR_TryDownLevel             fixed bin(31) value(NERR_BASE+370);
     /* Try down-level (remote admin protocol) version of API instead.*/

 /* UPS error codes.      */
 /* NERR_BASE + (380-384) */
 dcl NERR_UPSDriverNotStarted      fixed bin(31) value(NERR_BASE+380);
     /* The UPS driver could not be accessed by the UPS service. */
 dcl NERR_UPSInvalidConfig         fixed bin(31) value(NERR_BASE+381);
     /* The UPS service is not configured correctly. */
 dcl NERR_UPSInvalidCommPort       fixed bin(31) value(NERR_BASE+382);
     /* The UPS service could not access the specified Comm Port. */
 dcl NERR_UPSSignalAsserted        fixed bin(31) value(NERR_BASE+383);
     /* The UPS indicated a line fail or low battery situation. */
     /* Service not started.                                    */
 dcl NERR_UPSShutdownFailed        fixed bin(31) value(NERR_BASE+384);
     /* The UPS service failed to perform a system shut down. */

 /* Remoteboot error codes.                                           */
 /* NERR_BASE + (400-419)                                             */
 /* Error codes 400 - 405 are used by RPLBOOT.SYS.                    */
 /* Error codes 403, 407 - 416 are used by RPLLOADR.COM,              */
 /* Error code 417 is the alerter message of REMOTEBOOT (RPLSERVR.EXE)*/
 /* Error code 418 is for when REMOTEBOOT can't start                 */
 /* Error code 419 is for a disallowed 2nd rpl connection             */

 dcl NERR_BadDosRetCode            fixed bin(31) value(NERR_BASE+400);
     /* The program below returned an MS-DOS error code: */
 dcl NERR_ProgNeedsExtraMem        fixed bin(31) value(NERR_BASE+401);
     /* The program below needs more memory: */
 dcl NERR_BadDosFunction           fixed bin(31) value(NERR_BASE+402);
     /* The program below called an unsupported MS-DOS function: */
 dcl NERR_RemoteBootFailed         fixed bin(31) value(NERR_BASE+403);
     /* The workstation failed to boot. */
 dcl NERR_BadFileCheckSum          fixed bin(31) value(NERR_BASE+404);
     /* The file below is corrupt. */
 dcl NERR_NoRplBootSystem          fixed bin(31) value(NERR_BASE+405);
     /* No loader is specified in the boot-block definition file. */
 dcl NERR_RplLoadrNetBiosErr       fixed bin(31) value(NERR_BASE+406);
     /* NetBIOS returned an error: The NCB and SMB are dumped above. */
 dcl NERR_RplLoadrDiskErr          fixed bin(31) value(NERR_BASE+407);
     /* A disk I/O error occurred. */
 dcl NERR_ImageParamErr            fixed bin(31) value(NERR_BASE+408);
    /* Image parameter substitution failed. */
 dcl NERR_TooManyImageParams       fixed bin(31) value(NERR_BASE+409);
     /* Too many image parameters cross disk sector boundaries. */
 dcl NERR_NonDosFloppyUsed         fixed bin(31) value(NERR_BASE+410);
     /* The image was not generated from an MS-DOS diskette */
     /* formatted with /S.                                  */
 dcl NERR_RplBootRestart           fixed bin(31) value(NERR_BASE+411);
     /* Remote boot will be restarted later. */
 dcl NERR_RplSrvrCallFailed        fixed bin(31) value(NERR_BASE+412);
     /* The call to the Remoteboot server failed. */
 dcl NERR_CantConnectRplSrvr       fixed bin(31) value(NERR_BASE+413);
     /* Cannot connect to the Remoteboot server. */
 dcl NERR_CantOpenImageFile        fixed bin(31) value(NERR_BASE+414);
     /* Cannot open image file on the Remoteboot server. */
 dcl NERR_CallingRplSrvr           fixed bin(31) value(NERR_BASE+415);
     /* Connecting to the Remoteboot server... */
 dcl NERR_StartingRplBoot          fixed bin(31) value(NERR_BASE+416);
     /* Connecting to the Remoteboot server... */
 dcl NERR_RplBootServiceTerm       fixed bin(31) value(NERR_BASE+417);
     /* Remote boot service was stopped,                  */
     /* check the error log for the cause of the problem. */
 dcl NERR_RplBootStartFailed       fixed bin(31) value(NERR_BASE+418);
     /* Remote boot startup failed,                       */
     /* check the error log for the cause of the problem. */
 dcl NERR_RPL_CONNECTED            fixed bin(31) value(NERR_BASE+419);
     /* A second connection to a Remoteboot resource is not allowed. */

 /* FTADMIN API error codes    */
 /* NERR_BASE + (425-434)      */
 /*                            */
 /* (Currently not used in NT) */

 /* Browser service API error codes */
 /* NERR_BASE + (450-475)           */

 dcl NERR_BrowserConfiguredToNotRun fixed bin(31) value(NERR_BASE+450);
     /* The browser service was configured with MaintainServerList=No.*/

 /* Additional Remoteboot error codes. */
 /* NERR_BASE + (510-550)              */

 dcl NERR_RplNoAdaptersStarted     fixed bin(31) value(NERR_BASE+510);
     /* Service failed to start since none of the network adapters */
     /* started with this service.                                 */
 dcl NERR_RplBadRegistry           fixed bin(31) value(NERR_BASE+511);
     /* Service failed to start due to bad startup information in */
     /* the registry.                                             */
 dcl NERR_RplBadDatabase           fixed bin(31) value(NERR_BASE+512);
     /* Service failed to start because its database is absent or */
     /* corrupt.                                                  */
 dcl NERR_RplRplfilesShare         fixed bin(31) value(NERR_BASE+513);
     /* Service failed to start because RPLFILES share is absent. */
 dcl NERR_RplNotRplServer          fixed bin(31) value(NERR_BASE+514);
     /* Service failed to start because RPLUSER group is absent. */
 dcl NERR_RplCannotEnum            fixed bin(31) value(NERR_BASE+515);
     /* Cannot enumerate service records. */
 dcl NERR_RplWkstaInfoCorrupted    fixed bin(31) value(NERR_BASE+516);
     /* Workstation record information has been corrupted.*/
 dcl NERR_RplWkstaNotFound         fixed bin(31) value(NERR_BASE+517);
     /* Workstation record was not found.*/
 dcl NERR_RplWkstaNameUnavailable  fixed bin(31) value(NERR_BASE+518);
     /* Workstation name is in use by some other workstation.*/
 dcl NERR_RplProfileInfoCorrupted  fixed bin(31) value(NERR_BASE+519);
     /* Profile record information has been corrupted.*/
 dcl NERR_RplProfileNotFound       fixed bin(31) value(NERR_BASE+520);
     /* Profile record was not found.*/
 dcl NERR_RplProfileNameUnavailable fixed bin(31) value(NERR_BASE+521);
     /* Profile name is in use by some other profile.*/
 dcl NERR_RplProfileNotEmpty       fixed bin(31) value(NERR_BASE+522);
     /* There are workstations using this profile.*/
 dcl NERR_RplConfigInfoCorrupted   fixed bin(31) value(NERR_BASE+523);
     /* Configuration record information has been corrupted.*/
 dcl NERR_RplConfigNotFound        fixed bin(31) value(NERR_BASE+524);
     /* Configuration record was not found.*/
 dcl NERR_RplAdapterInfoCorrupted  fixed bin(31) value(NERR_BASE+525);
     /* Adapter id record information has been corrupted.*/
 dcl NERR_RplInternal              fixed bin(31) value(NERR_BASE+526);
     /* An internal service error has occurred.*/
 dcl NERR_RplVendorInfoCorrupted   fixed bin(31) value(NERR_BASE+527);
     /* Vendor id record information has been corrupted.*/
 dcl NERR_RplBootInfoCorrupted     fixed bin(31) value(NERR_BASE+528);
     /* Boot block record information has been corrupted.*/
 dcl NERR_RplWkstaNeedsUserAcct    fixed bin(31) value(NERR_BASE+529);
     /* The user account for this workstation record is missing.*/
 dcl NERR_RplNeedsRPLUSERAcct      fixed bin(31) value(NERR_BASE+530);
     /* The RPLUSER local group could not be found.*/
 dcl NERR_RplBootNotFound          fixed bin(31) value(NERR_BASE+531);
     /* Boot block record was not found.*/
 dcl NERR_RplIncompatibleProfile   fixed bin(31) value(NERR_BASE+532);
     /* Chosen profile is incompatible with this workstation.*/
 dcl NERR_RplAdapterNameUnavailable fixed bin(31) value(NERR_BASE+533);
     /* Chosen network adapter id is in use by some other workstation.*/
 dcl NERR_RplConfigNotEmpty        fixed bin(31) value(NERR_BASE+534);
     /* There are profiles using this configuration.*/
 dcl NERR_RplBootInUse             fixed bin(31) value(NERR_BASE+535);
     /* There are workstations, profiles or configurations using */
     /* this boot block.                                         */
 dcl NERR_RplBackupDatabase        fixed bin(31) value(NERR_BASE+536);
     /* Service failed to backup Remoteboot database.*/
 dcl NERR_RplAdapterNotFound       fixed bin(31) value(NERR_BASE+537);
     /* Adapter record was not found.*/
 dcl NERR_RplVendorNotFound        fixed bin(31) value(NERR_BASE+538);
     /* Vendor record was not found.*/
 dcl NERR_RplVendorNameUnavailable fixed bin(31) value(NERR_BASE+539);
     /* Vendor name is in use by some other vendor record.*/
 dcl NERR_RplBootNameUnavailable   fixed bin(31) value(NERR_BASE+540);
     /* (boot name, vendor id) is in use by some other */
     /* boot block record.                             */
 dcl NERR_RplConfigNameUnavailable fixed bin(31) value(NERR_BASE+541);
     /* Configuration name is in use by some other configuration.*/

 /** INTERNAL_ONLY **/

 /*  Dfs API error codes.  */
 /*  NERR_BASE + (560-590) */

 dcl NERR_DfsInternalCorruption      fixed bin(31) value(NERR_BASE+560);
     /* The internal database maintained by the Dfs service is corrupt*/
 dcl NERR_DfsVolumeDataCorrupt       fixed bin(31) value(NERR_BASE+561);
     /* One of the records in the internal Dfs database is corrupt */
 dcl NERR_DfsNoSuchVolume            fixed bin(31) value(NERR_BASE+562);
     /* There is no volume whose entry path matches the input */
     /* Entry Path                                            */
 dcl NERR_DfsVolumeAlreadyExists     fixed bin(31) value(NERR_BASE+563);
     /* A volume with the given name already exists */
 dcl NERR_DfsAlreadyShared           fixed bin(31) value(NERR_BASE+564);
     /* The server share specified is already shared in the Dfs */
 dcl NERR_DfsNoSuchShare             fixed bin(31) value(NERR_BASE+565);
     /* The indicated server share does not support the indicated */
     /* Dfs volume                                                */
 dcl NERR_DfsNotALeafVolume          fixed bin(31) value(NERR_BASE+566);
     /* The operation is not valid on a non-leaf volume */
 dcl NERR_DfsLeafVolume              fixed bin(31) value(NERR_BASE+567);
     /* The operation is not valid on a leaf volume */
 dcl NERR_DfsVolumeHasMultipleServers
                                     fixed bin(31) value(NERR_BASE+568);
     /* The operation is ambiguous because the volume has */
     /* multiple servers                                  */
 dcl NERR_DfsCantCreateJunctionPoint fixed bin(31) value(NERR_BASE+569);
     /* Unable to create a junction point */
 dcl NERR_DfsServerNotDfsAware       fixed bin(31) value(NERR_BASE+570);
     /* The server is not Dfs Aware */
 dcl NERR_DfsBadRenamePath           fixed bin(31) value(NERR_BASE+571);
     /* The specified rename target path is invalid */
 dcl NERR_DfsVolumeIsOffline         fixed bin(31) value(NERR_BASE+572);
     /* The specified Dfs volume is offline */
 dcl NERR_DfsNoSuchServer            fixed bin(31) value(NERR_BASE+573);
     /* The specified server is not a server for this volume */
 dcl NERR_DfsCyclicalName            fixed bin(31) value(NERR_BASE+574);
     /* A cycle in the Dfs name was detected */
 dcl NERR_DfsNotSupportedInServerDfs fixed bin(31) value(NERR_BASE+575);
     /* The operation is not supported on a server-based Dfs */
 dcl NERR_DfsDuplicateService        fixed bin(31) value(NERR_BASE+576);
     /* This volume is already supported by the specified server-share*/
 dcl NERR_DfsCantRemoveLastServerShare
                                     fixed bin(31) value(NERR_BASE+577);
     /* Can't remove the last server-share supporting this volume */
 dcl NERR_DfsVolumeIsInterDfs        fixed bin(31) value(NERR_BASE+578);
     /* The operation is not supported for an Inter-Dfs volume */
 dcl NERR_DfsInconsistent            fixed bin(31) value(NERR_BASE+579);
     /* The internal state of the Dfs Service has become inconsistent */
 dcl NERR_DfsServerUpgraded          fixed bin(31) value(NERR_BASE+580);
     /* The Dfs Service has been installed on the specified server */
 dcl NERR_DfsDataIsIdentical         fixed bin(31) value(NERR_BASE+581);
     /* The Dfs data being reconciled is identical */
 dcl NERR_DfsCantRemoveDfsRoot       fixed bin(31) value(NERR_BASE+582);
     /* The Dfs root volume cannot be deleted */
     /* - Uninstall Dfs if required           */
 dcl NERR_DfsChildOrParentInDfs      fixed bin(31) value(NERR_BASE+583);
     /* A child or parent directory of the share is already in a Dfs */
 dcl NERR_DfsInternalError           fixed bin(31) value(NERR_BASE+590);
     /* Dfs internal error */

 /* Net setup error codes. */
 /* NERR_BASE + (591-600)  */

 dcl NERR_SetupAlreadyJoined       fixed bin(31) value(NERR_BASE+591);
     /* This machine is already joined to a domain. */
 dcl NERR_SetupNotJoined           fixed bin(31) value(NERR_BASE+592);
     /* This machine is not currently joined to a domain. */
 dcl NERR_SetupDomainController    fixed bin(31) value(NERR_BASE+593);
     /* This machine is a domain controller and cannot be unjoined */
     /* from a domain.                                             */
 dcl NERR_DefaultJoinRequired      fixed bin(31) value(NERR_BASE+594);
     /* The destination domain controller does not support */
     /* creating machine accounts in OUs.                  */
 dcl NERR_InvalidWorkgroupName     fixed bin(31) value(NERR_BASE+595);
     /* The specified workgroup name is invalid */

 /********** WARNING *****************/
 /* The range 2750-2799 has been     */
 /* allocated to the IBM LAN Server  */
 /************************************/

 /********** WARNING *****************/
 /* The range 2900-2999 has been     */
 /* reserved for Microsoft OEMs      */
 /************************************/

 /** END_INTERNAL **/

 dcl MAX_NERR                      fixed bin(31) value(NERR_BASE+899);
     /* This is the last error in NERR range. */

 /* end of list */

 /* WARNING:  Do not exceed MAX_NERR; values above this are used by   */
 /*           other error code ranges (errlog.h, service.h, apperr.h).*/

 %end; /* NETERR_INCLUDED */

