 /* ++ BUILD Version: 0001                                            */
 /*    -- Increment this if a change has global effects               */
 /*                                                                   */
 /* Copyright 1991-1998 Microsoft Corporation                         */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*   lmstats.cpy                                                     */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*   This module defines the API function prototypes and data        */
 /*   structures for the following groups of NT API functions:        */
 /*       NetStatistics                                               */
 /*                                                                   */
 /* Environment:                                                      */
 /*                                                                   */
 /*   User Mode - Win32                                               */
 /*                                                                   */
 /* Notes:                                                            */
 /*                                                                   */
 /*   You must include NETCONS.CPY before this file, since this file  */
 /*   depends on values defined in NETCONS.CPY.                       */
 /*                                                                   */
 /* --                                                                */

 %dcl #LMSTATS_ char ext;
 %if #LMSTATS_ = '' %then %do;
 %#LMSTATS_ = 'Y';

 /* Function Prototypes - Statistics */

 dcl NetStatisticsGet
     entry (TCHAR(*) varz byaddr optional,
            TCHAR(*) varz byaddr,
            type DWORD,
            type DWORD,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external ('NetStatisticsGet');


 /* Data Structures - Statistics */

 %dcl LM20_WORKSTATION_STATISTICS char ext;
 %if LM20_WORKSTATION_STATISTICS ^= '' %then %do;
 define structure
   1 STAT_WORKSTATION_0,
     2 stw0_start          type DWORD,
     2 stw0_numNCB_r       type DWORD,
     2 stw0_numNCB_s       type DWORD,
     2 stw0_numNCB_a       type DWORD,
     2 stw0_fiNCB_r        type DWORD,
     2 stw0_fiNCB_s        type DWORD,
     2 stw0_fiNCB_a        type DWORD,
     2 stw0_fcNCB_r        type DWORD,
     2 stw0_fcNCB_s        type DWORD,
     2 stw0_fcNCB_a        type DWORD,
     2 stw0_sesstart       type DWORD,
     2 stw0_sessfailcon    type DWORD,
     2 stw0_sessbroke      type DWORD,
     2 stw0_uses           type DWORD,
     2 stw0_usefail        type DWORD,
     2 stw0_autorec        type DWORD,
     2 stw0_bytessent_r_lo type DWORD,
     2 stw0_bytessent_r_hi type DWORD,
     2 stw0_bytesrcvd_r_lo type DWORD,
     2 stw0_bytesrcvd_r_hi type DWORD,
     2 stw0_bytessent_s_lo type DWORD,
     2 stw0_bytessent_s_hi type DWORD,
     2 stw0_bytesrcvd_s_lo type DWORD,
     2 stw0_bytesrcvd_s_hi type DWORD,
     2 stw0_bytessent_a_lo type DWORD,
     2 stw0_bytessent_a_hi type DWORD,
     2 stw0_bytesrcvd_a_lo type DWORD,
     2 stw0_bytesrcvd_a_hi type DWORD,
     2 stw0_reqbufneed     type DWORD,
     2 stw0_bigbufneed     type DWORD;
 define alias  PSTAT_WORKSTATION_0 handle STAT_WORKSTATION_0;
 define alias LPSTAT_WORKSTATION_0 handle STAT_WORKSTATION_0;

 %end; %else %do;

 /* NB: The following structure is REDIR_STATISTICS       */
 /*     in sdk\inc\ntddnfs.h.                             */
 /* If you change the structure, change it in both places */

 define structure
   1 STAT_WORKSTATION_0,
     2 StatisticsStartTime          type LARGE_INTEGER,
     2 BytesReceived                type LARGE_INTEGER,
     2 SmbsReceived                 type LARGE_INTEGER,
     2 PagingReadBytesRequested     type LARGE_INTEGER,
     2 NonPagingReadBytesRequested  type LARGE_INTEGER,
     2 CacheReadBytesRequested      type LARGE_INTEGER,
     2 NetworkReadBytesRequested    type LARGE_INTEGER,
     2 BytesTransmitted             type LARGE_INTEGER,
     2 SmbsTransmitted              type LARGE_INTEGER,
     2 PagingWriteBytesRequested    type LARGE_INTEGER,
     2 NonPagingWriteBytesRequested type LARGE_INTEGER,
     2 CacheWriteBytesRequested     type LARGE_INTEGER,
     2 NetworkWriteBytesRequested   type LARGE_INTEGER,
     2 InitiallyFailedOperations    type DWORD,
     2 FailedCompletionOperations   type DWORD,
     2 ReadOperations               type DWORD,
     2 RandomReadOperations         type DWORD,
     2 ReadSmbs                     type DWORD,
     2 LargeReadSmbs                type DWORD,
     2 SmallReadSmbs                type DWORD,
     2 WriteOperations              type DWORD,
     2 RandomWriteOperations        type DWORD,
     2 WriteSmbs                    type DWORD,
     2 LargeWriteSmbs               type DWORD,
     2 SmallWriteSmbs               type DWORD,
     2 RawReadsDenied               type DWORD,
     2 RawWritesDenied              type DWORD,
     2 NetworkErrors                type DWORD,
     /* Connection/Session counts */
     2 Sessions                     type DWORD,
     2 FailedSessions               type DWORD,
     2 Reconnects                   type DWORD,
     2 CoreConnects                 type DWORD,
     2 Lanman20Connects             type DWORD,
     2 Lanman21Connects             type DWORD,
     2 LanmanNtConnects             type DWORD,
     2 ServerDisconnects            type DWORD,
     2 HungSessions                 type DWORD,
     2 UseCount                     type DWORD,
     2 FailedUseCount               type DWORD,
     /* Queue Lengths (updates protected by RdrMpxTableSpinLock NOT */
     /* RdrStatisticsSpinlock) */
     2 CurrentCommands              type DWORD;
 define alias  PSTAT_WORKSTATION_0 handle STAT_WORKSTATION_0;
 define alias LPSTAT_WORKSTATION_0 handle STAT_WORKSTATION_0;
 %end;

 define structure
   1 STAT_SERVER_0,
     2 sts0_start          type DWORD,
     2 sts0_fopens         type DWORD,
     2 sts0_devopens       type DWORD,
     2 sts0_jobsqueued     type DWORD,
     2 sts0_sopens         type DWORD,
     2 sts0_stimedout      type DWORD,
     2 sts0_serrorout      type DWORD,
     2 sts0_pwerrors       type DWORD,
     2 sts0_permerrors     type DWORD,
     2 sts0_syserrors      type DWORD,
     2 sts0_bytessent_low  type DWORD,
     2 sts0_bytessent_high type DWORD,
     2 sts0_bytesrcvd_low  type DWORD,
     2 sts0_bytesrcvd_high type DWORD,
     2 sts0_avresponse     type DWORD,
     2 sts0_reqbufneed     type DWORD,
     2 sts0_bigbufneed     type DWORD;
 define alias  PSTAT_SERVER_0 handle STAT_SERVER_0;
 define alias LPSTAT_SERVER_0 handle STAT_SERVER_0;


 /* Special Values and Constants */

 dcl STATSOPT_CLR   fixed bin(31) value(1);
 dcl STATS_NO_VALUE fixed bin(31) value(-1);
 dcl STATS_OVERFLOW fixed bin(31) value(-2);

 %end; /* _LMSTATS.H */
