 /* ++                                                                */
 /*                                                                   */
 /* Copyright 1991-1998 Microsoft Corporation                         */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*     mmreg.cpy                                                     */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*     Multimedia Registration                                       */
 /*                                                                   */
 /* Revision History:                                                 */
 /*                                                                   */
 /* --                                                                */

 /* Define the following to skip definitions                          */
 /*                                                                   */
 /* NOMMIDS     Multimedia IDs are not defined                        */
 /* NONEWWAVE   No new waveform types are defined except WAVEFORMATEX */
 /* NONEWRIFF   No new RIFF forms are defined                         */
 /* NOJPEGDIB   No JPEG DIB definitions                               */
 /* NONEWIC     No new Image Compressor types are defined             */
 /* NOBITMAP    No extended bitmap info header definition             */

 %dcl #INC_MMREG fixed;
 %if #INC_MMREG = 0 %then %do;
 /* use version number to verify compatibility */
 %#INC_MMREG = 146; /* version * 100 + revision */

 %dcl #WINGDI_ char ext;
 %if #WINGDI_ = '' %then %do;
 %include WinGDI;
 %end;

 %dcl #INC_MMSYSTEM char ext;
 %if #INC_MMSYSTEM = '' %then %do;
 %include MMSystem;
 %end;

 %dcl NOMMIDS char ext;
 %if NOMMIDS = '' %then %do;


 dcl  /* manufacturer IDs */
 ( MM_MICROSOFT           value(  1) /* Microsoft Corporation */

 , MM_CREATIVE            value(  2) /* Creative Labs, Inc */
 , MM_MEDIAVISION         value(  3) /* Media Vision, Inc. */
 , MM_FUJITSU             value(  4) /* Fujitsu Corp. */
 , MM_ARTISOFT            value( 20) /* Artisoft, Inc. */
 , MM_TURTLE_BEACH        value( 21) /* Turtle Beach, Inc. */
 , MM_IBM                 value( 22) /* IBM Corporation */
 , MM_VOCALTEC            value( 23) /* Vocaltec LTD. */
 , MM_ROLAND              value( 24) /* Roland */
 , MM_DSP_SOLUTIONS       value( 25) /* DSP Solutions, Inc. */
 , MM_NEC                 value( 26) /* NEC */
 , MM_ATI                 value( 27) /* ATI */
 , MM_WANGLABS            value( 28) /* Wang Laboratories, Inc */
 , MM_TANDY               value( 29) /* Tandy Corporation */
 , MM_VOYETRA             value( 30) /* Voyetra */
 , MM_ANTEX               value( 31) /* Antex Electronics Corporation */
 , MM_ICL_PS              value( 32) /* ICL Personal Systems*/
 , MM_INTEL               value( 33) /* Intel Corporation */
 , MM_GRAVIS              value( 34) /* Advanced Gravis */
 , MM_VAL                 value( 35) /* Video Associates Labs, Inc. */
 , MM_INTERACTIVE         value( 36) /* InterActive Inc */
 , MM_YAMAHA              value( 37) /* Yamaha Corporation of America */
 , MM_EVEREX              value( 38) /* Everex Systems, Inc */
 , MM_ECHO                value( 39) /* Echo Speech Corporation */
 , MM_SIERRA              value( 40) /* Sierra Semiconductor Corp */
 , MM_CAT                 value( 41) /* Computer Aided Technologies */
 , MM_APPS                value( 42) /* APPS Software International */
 , MM_DSP_GROUP           value( 43) /* DSP Group, Inc */
 , MM_MELABS              value( 44) /* microEngineering Labs */
 , MM_COMPUTER_FRIENDS    value( 45) /* Computer Friends, Inc. */
 , MM_ESS                 value( 46) /* ESS Technology */
 , MM_AUDIOFILE           value( 47) /* Audio, Inc. */
 , MM_MOTOROLA            value( 48) /* Motorola, Inc. */
 , MM_CANOPUS             value( 49) /* Canopus, co., Ltd. */
 , MM_EPSON               value( 50) /* Seiko Epson Corporation */
 , MM_TRUEVISION          value( 51) /* Truevision */
 , MM_AZTECH              value( 52) /* Aztech Labs, Inc. */
 , MM_VIDEOLOGIC          value( 53) /* Videologic */
 , MM_SCALACS             value( 54) /* SCALACS */
 , MM_KORG                value( 55) /* Korg Inc. */
 , MM_APT                 value( 56) /* Audio Processing Technology */
 , MM_ICS                 value( 57)
   /* Integrated Circuit Systems, Inc. */
 , MM_ITERATEDSYS         value( 58) /* Iterated Systems, Inc. */
 , MM_METHEUS             value( 59) /* Metheus */
 , MM_LOGITECH            value( 60) /* Logitech, Inc. */
 , MM_WINNOV              value( 61) /* Winnov, Inc. */
 , MM_NCR                 value( 62) /* NCR Corporation */
 , MM_EXAN                value( 63) /* EXAN */
 , MM_AST                 value( 64) /* AST Research Inc. */
 , MM_WILLOWPOND          value( 65) /* Willow Pond Corporation */
 , MM_SONICFOUNDRY        value( 66) /* Sonic Foundry */
 , MM_VITEC               value( 67) /* Vitec Multimedia */
 , MM_MOSCOM              value( 68) /* MOSCOM Corporation */
 , MM_SILICONSOFT         value( 69) /* Silicon Soft, Inc. */
 , MM_SUPERMAC            value( 73) /* Supermac */
 , MM_AUDIOPT             value( 74) /* Audio Processing Technology */
 , MM_SPEECHCOMP          value( 76) /* Speech Compression */
 , MM_AHEAD               value( 77) /* Ahead, Inc. */
 , MM_DOLBY               value( 78) /* Dolby Laboratories */
 , MM_OKI                 value( 79) /* OKI */
 , MM_AURAVISION          value( 80) /* AuraVision Corporation */
 , MM_OLIVETTI            value( 81) /* Ing C. Olivetti & C., S.p.A. */
 , MM_IOMAGIC             value( 82) /* I/O Magic Corporation*/
 , MM_MATSUSHITA          value( 83)
   /* Matsushita Electric Industrial Co., LTD. */
 , MM_CONTROLRES          value( 84) /* Control Resources Limited */
 , MM_XEBEC               value( 85)
   /* Xebec Multimedia Solutions Limited */
 , MM_NEWMEDIA            value( 86) /* New Media Corporation*/
 , MM_NMS                 value( 87) /* Natural MicroSystems */
 , MM_LYRRUS              value( 88) /* Lyrrus Inc. */
 , MM_COMPUSIC            value( 89) /* Compusic */
 , MM_OPTI                value( 90) /* OPTi Computers Inc. */
 , MM_ADLACC              value( 91) /* Adlib Accessories Inc. */
 , MM_COMPAQ              value( 92) /* Compaq Computer Corp.*/
 , MM_DIALOGIC            value( 93) /* Dialogic Corporation */
 , MM_INSOFT              value( 94) /* InSoft, Inc. */
 , MM_MPTUS               value( 95) /* M.P. Technologies, Inc. */
 , MM_WEITEK              value( 96) /* Weitek */
 , MM_LERNOUT_AND_HAUSPIE value( 97) /* Lernout & Hauspie */
 , MM_QCIAR               value( 98) /* Quanta Computer Inc. */
 , MM_APPLE               value( 99) /* Apple Computer, Inc. */
 , MM_DIGITAL             value(100) /* Digital Equipment Corporation */
 , MM_MOTU                value(101) /* Mark of the Unicorn */
 , MM_WORKBIT             value(102) /* Workbit Corporation */
 , MM_OSITECH             value(103) /* Ositech Communications Inc. */
 , MM_MIRO                value(104) /* miro Computer Products AG */
 , MM_CIRRUSLOGIC         value(105) /* Cirrus Logic */
 , MM_ISOLUTION           value(106) /* ISOLUTION  B.V. */
 , MM_HORIZONS            value(107) /* Horizons Technology, Inc */
 , MM_CONCEPTS            value(108) /* Computer Concepts Ltd */
 , MM_VTG                 value(109) /* Voice Technologies Group, Inc.*/
 , MM_RADIUS              value(110) /* Radius */
 , MM_ROCKWELL            value(111) /* Rockwell International */
 , MM_XYz                 value(112) /* Co. XYZ for testing */
 , MM_OPCODE              value(113) /* Opcode Systems */
 , MM_VOXWARE             value(114) /* Voxware Inc */
 , MM_NORTHERN_TELECOM    value(115) /* Northern Telecom Limited */
 , MM_APICOM              value(116) /* APICOM */
 , MM_GRANDE              value(117) /* Grande Software */
 , MM_ADDX                value(118) /* ADDX */
 , MM_WILDCAT             value(119) /* Wildcat Canyon Software */
 , MM_RHETOREX            value(120) /* Rhetorex Inc */
 , MM_BROOKTREE           value(121) /* Brooktree Corporation */
 , MM_ENSONIQ             value(125) /* ENSONIQ Corporation */
 , MM_FAST                value(126) /* FAST Multimedia AG */
 , MM_NVIDIA              value(127) /* NVidia Corporation */
 , MM_OKSORI              value(128) /* OKSORI Co., Ltd. */
 , MM_DIACOUSTICS         value(129) /* DiAcoustics, Inc. */
 , MM_GULBRANSEN          value(130) /* Gulbransen, Inc. */
 , MM_KAY_ELEMETRICS      value(131) /* Kay Elemetrics, Inc. */
 , MM_CRYSTAL             value(132)
   /* Crystal Semiconductor Corporation */
 , MM_SPLASH_STUDIOS      value(133) /* Splash Studios */
 , MM_QUARTERDECK         value(134) /* Quarterdeck Corporation */
 , MM_TDK                 value(135) /* TDK Corporation */
 , MM_DIGITAL_AUDIO_LABS  value(136) /* Digital Audio Labs, Inc. */
 , MM_SEERSYS             value(137) /* Seer Systems, Inc. */
 , MM_PICTURETEL          value(138) /* PictureTel Corporation */
 , MM_ATT_MICROELECTRONICS value(139) /* AT&T Microelectronics */
 , MM_OSPREY              value(140) /*  Osprey Technologies, Inc. */
 , MM_MEDIATRIX           value(141) /*  Mediatrix Peripherals */
 , MM_SOUNDESIGNS         value(142) /* SounDesignS M.C.S. Ltd. */
 , MM_ALDIGITAL           value(143) /* A.L. Digital Ltd. */
 , MM_SPECTRUM_SIGNAL_PROCESSING value(144)
   /* Spectrum Signal Processing, Inc. */
 , MM_ECS                 value(145)
   /* Electronic Courseware Systems, Inc. */
 , MM_AMD                 value(146) /* AMD */
 , MM_COREDYNAMICS        value(147) /* Core Dynamics */
 , MM_CANAM               value(148) /* CANAM Computers */
 , MM_SOFTSOUND           value(149) /* Softsound, Ltd. */
 , MM_NORRIS              value(150) /* Norris Communications, Inc. */
 , MM_DDD                 value(151) /* Danka Data Devices */
 , MM_EUPHONICS           value(152) /* EuPhonics */
 , MM_PRECEPT             value(153) /* Precept Software, Inc. */
 , MM_CRYSTAL_NET         value(154) /* Crystal Net Corporation */
 , MM_CHROMATIC           value(155) /* Chromatic Research, Inc */
 , MM_VOICEINFO           value(156) /* Voice Information Systems, Inc*/
 , MM_VIENNASYS           value(157) /* Vienna Systems */
 , MM_CONNECTIX           value(158) /* Connectix Corporation */
 , MM_GADGETLABS          value(159) /* Gadget Labs LLC */
 , MM_FRONTIER            value(160) /* Frontier Design Group LLC */
 , MM_VIONA               value(161) /* Viona Development GmbH */
 , MM_CASIO               value(162) /* Casio Computer Co., LTD */
 , MM_DIAMONDMM           value(163) /* Diamond Multimedia */
 , MM_S3                  value(164) /* S3 */
 , MM_FRAUNHOFER_IIS      value(172) /* Fraunhofer */
 ) fixed bin (31);

 dcl /* MM_MICROSOFT product IDs */
 ( MM_MIDI_MAPPER             value( 1) /* MIDI Mapper */
 , MM_WAVE_MAPPER             value( 2) /* Wave Mapper */
 , MM_SNDBLST_MIDIOUT         value( 3)
   /* Sound Blaster MIDI output port */
 , MM_SNDBLST_MIDIIN          value( 4)
   /* Sound Blaster MIDI input port */
 , MM_SNDBLST_SYNTH           value( 5)
   /* Sound Blaster internal synthesizer */
 , MM_SNDBLST_WAVEOUT         value( 6)
   /* Sound Blaster waveform output */
 , MM_SNDBLST_WAVEIN          value( 7)
   /* Sound Blaster waveform input */
 , MM_ADLIB                   value( 9)
   /* Ad Lib-compatible synthesizer */
 , MM_MPU401_MIDIOUT          value(10)
   /* MPU401-compatible MIDI output port */
 , MM_MPU401_MIDIIN           value(11)
   /* MPU401-compatible MIDI input port */
 , MM_PC_JOYSTICK             value(12) /* Joystick adapter */

 , MM_PCSPEAKER_WAVEOUT       value(13)
   /* PC speaker waveform output  */
 , MM_MSFT_WSS_WAVEIN         value(14)
   /* MS Audio Board waveform input */
 , MM_MSFT_WSS_WAVEOUT        value(15)
   /* MS Audio Board waveform output */
 , MM_MSFT_WSS_FMSYNTH_STEREO value(16)
   /* MS Audio Board Stereo FM synth  */
 , MM_MSFT_WSS_MIXER          value(17) /* MS Audio Board Mixer Driver*/
 , MM_MSFT_WSS_OEM_WAVEIN     value(18)
   /* MS OEM Audio Board waveform input */
 , MM_MSFT_WSS_OEM_WAVEOUT    value(19)
   /* MS OEM Audio Board waveform output */
 , MM_MSFT_WSS_OEM_FMSYNTH_STEREO value(20)
   /* MS OEM Audio Board Stereo FM Synth */
 , MM_MSFT_WSS_AUX            value(21)
   /* MS Audio Board Aux. Port */
 , MM_MSFT_WSS_OEM_AUX        value(22) /* MS OEM Audio Aux Port */
 , MM_MSFT_GENERIC_WAVEIN     value(23)
   /* MS Vanilla driver waveform input */
 , MM_MSFT_GENERIC_WAVEOUT    value(24)
   /* MS Vanilla driver wavefrom output */
 , MM_MSFT_GENERIC_MIDIIN     value(25)
   /* MS Vanilla driver MIDI in */
 , MM_MSFT_GENERIC_MIDIOUT    value(26)
   /* MS Vanilla driver MIDI  external out */
 , MM_MSFT_GENERIC_MIDISYNTH  value(27)
   /* MS Vanilla driver MIDI synthesizer */
 , MM_MSFT_GENERIC_AUX_LINE   value(28)
   /* MS Vanilla driver aux (line in) */
 , MM_MSFT_GENERIC_AUX_MIC    value(29)
   /* MS Vanilla driver aux (mic) */
 , MM_MSFT_GENERIC_AUX_CD     value(30)
   /* MS Vanilla driver aux (CD) */
 , MM_MSFT_WSS_OEM_MIXER      value(31)
   /* MS OEM Audio Board Mixer Driver */
 , MM_MSFT_MSACM              value(32)
   /* MS Audio Compression Manager */
 , MM_MSFT_ACM_MSADPCM        value(33) /* MS ADPCM Codec */
 , MM_MSFT_ACM_IMAADPCM       value(34) /* IMA ADPCM Codec */
 , MM_MSFT_ACM_MSFILTER       value(35) /* MS Filter */
 , MM_MSFT_ACM_GSM610         value(36) /* GSM 610 codec */
 , MM_MSFT_ACM_G711           value(37) /* G.711 codec */
 , MM_MSFT_ACM_PCM            value(38) /* PCM converter */

 /* Microsoft Windows Sound System drivers */

 , MM_WSS_SB16_WAVEIN         value(39)
   /* Sound Blaster 16 waveform input */
 , MM_WSS_SB16_WAVEOUT        value(40)
   /* Sound Blaster 16  waveform output */
 , MM_WSS_SB16_MIDIIN         value(41)
   /* Sound Blaster 16 midi-in */
 , MM_WSS_SB16_MIDIOUT        value(42)
   /* Sound Blaster 16 midi out */
 , MM_WSS_SB16_SYNTH          value(43)
   /* Sound Blaster 16 FM Synthesis */
 , MM_WSS_SB16_AUX_LINE       value(44)
   /* Sound Blaster 16 aux (line in) */
 , MM_WSS_SB16_AUX_CD         value(45)
   /* Sound Blaster 16 aux (CD) */
 , MM_WSS_SB16_MIXER          value(46)
   /* Sound Blaster 16 mixer device */
 , MM_WSS_SBPRO_WAVEIN        value(47)
   /* Sound Blaster Pro waveform input */
 , MM_WSS_SBPRO_WAVEOUT       value(48)
   /* Sound Blaster Pro waveform output */
 , MM_WSS_SBPRO_MIDIIN        value(49)
   /* Sound Blaster Pro midi in */
 , MM_WSS_SBPRO_MIDIOUT       value(50)
   /* Sound Blaster Pro midi out */
 , MM_WSS_SBPRO_SYNTH         value(51)
   /* Sound Blaster Pro FM synthesis */
 , MM_WSS_SBPRO_AUX_LINE      value(52)
   /* Sound Blaster Pro aux (line in ) */
 , MM_WSS_SBPRO_AUX_CD        value(53)
   /* Sound Blaster Pro aux (CD) */
 , MM_WSS_SBPRO_MIXER         value(54)
   /* Sound Blaster Pro mixer */

 , MM_MSFT_WSS_NT_WAVEIN      value(55)
 /*  WSS NT wave in  */
 , MM_MSFT_WSS_NT_WAVEOUT     value(56)
 /*  WSS NT wave out  */
 , MM_MSFT_WSS_NT_FMSYNTH_STEREO value(57) /* WSS NT FM synth */
 , MM_MSFT_WSS_NT_MIXER       value(58) /* WSS NT mixer */
 , MM_MSFT_WSS_NT_AUX         value(59) /* WSS NT aux */

 , MM_MSFT_SB16_WAVEIN        value(60)
   /* Sound Blaster 16 waveform input */
 , MM_MSFT_SB16_WAVEOUT       value(61)
   /* Sound Blaster 16  waveform output */
 , MM_MSFT_SB16_MIDIIN        value(62)
   /* Sound Blaster 16 midi-in */
 , MM_MSFT_SB16_MIDIOUT       value(63)
   /* Sound Blaster 16 midi out */
 , MM_MSFT_SB16_SYNTH         value(64)
   /* Sound Blaster 16 FM Synthesis */
 , MM_MSFT_SB16_AUX_LINE      value(65)
   /* Sound Blaster 16 aux (line in) */
 , MM_MSFT_SB16_AUX_CD        value(66)
   /* Sound Blaster 16 aux (CD) */
 , MM_MSFT_SB16_MIXER         value(67)
   /* Sound Blaster 16 mixer device */
 , MM_MSFT_SBPRO_WAVEIN       value(68)
   /* Sound Blaster Pro waveform input */
 , MM_MSFT_SBPRO_WAVEOUT      value(69)
   /* Sound Blaster Pro waveform output */
 , MM_MSFT_SBPRO_MIDIIN       value(70)
   /* Sound Blaster Pro midi in */
 , MM_MSFT_SBPRO_MIDIOUT      value(71)
   /* Sound Blaster Pro midi out */
 , MM_MSFT_SBPRO_SYNTH        value(72)
   /* Sound Blaster Pro FM synthesis */
 , MM_MSFT_SBPRO_AUX_LINE     value(73)
   /* Sound Blaster Pro aux (line in) */
 , MM_MSFT_SBPRO_AUX_CD       value(74)
   /* Sound Blaster Pro aux (CD) */
 , MM_MSFT_SBPRO_MIXER        value(75)
   /* Sound Blaster Pro mixer */

 , MM_MSFT_MSOPL_SYNTH        value(76)
   /* Yamaha OPL2/OPL3 compatible FM synthesis */

 , MM_MSFT_VMDMS_LINE_WAVEIN     value(80)
   /* Voice Modem Serial Line Wave Input */
 , MM_MSFT_VMDMS_LINE_WAVEOUT    value(81)
   /* Voice Modem Serial Line Wave Output */
 , MM_MSFT_VMDMS_HANDSET_WAVEIN  value(82)
   /* Voice Modem Serial Handset Wave Input */
 , MM_MSFT_VMDMS_HANDSET_WAVEOUT value(83)
   /* Voice Modem Serial Handset Wave Output */
 , MM_MSFT_VMDMW_LINE_WAVEIN     value(84)
   /* Voice Modem Wrapper Line Wave Input */
 , MM_MSFT_VMDMW_LINE_WAVEOUT    value(85)
   /* Voice Modem Wrapper Line Wave Output */
 , MM_MSFT_VMDMW_HANDSET_WAVEIN  value(86)
   /* Voice Modem Wrapper Handset Wave Input */
 , MM_MSFT_VMDMW_HANDSET_WAVEOUT value(87)
   /* Voice Modem Wrapper Handset Wave Output */
 , MM_MSFT_VMDMW_MIXER           value(88)
   /* Voice Modem Wrapper Mixer */
 , MM_MSFT_VMDM_GAME_WAVEOUT     value(89)
   /* Voice Modem Game Compatible Wave Device */
 , MM_MSFT_VMDM_GAME_WAVEIN      value(90)
   /* Voice Modem Game Compatible Wave Device */

 , MM_MSFT_ACM_MSNAUDIO          value(91)
 , MM_MSFT_ACM_MSG723            value(92)

 , MM_MSFT_WDMAUDIO_WAVEOUT      value(100)
   /* Generic id for WDM Audio drivers */
 , MM_MSFT_WDMAUDIO_WAVEIN       value(101)
   /* Generic id for WDM Audio drivers */
 , MM_MSFT_WDMAUDIO_MIDIOUT      value(102)
   /* Generic id for WDM Audio drivers */
 , MM_MSFT_WDMAUDIO_MIDIIN       value(103)
   /* Generic id for WDM Audio drivers */
 , MM_MSFT_WDMAUDIO_MIXER        value(104)
   /* Generic id for WDM Audio drivers */
 ) fixed bin (31);

 dcl /* MM_CREATIVE product IDs */
 ( MM_CREATIVE_SB15_WAVEIN     value(1) /* SB (r) 1.5 waveform input */
 , MM_CREATIVE_SB20_WAVEIN     value(2)
 , MM_CREATIVE_SBPRO_WAVEIN    value(3)
 , MM_CREATIVE_SBP16_WAVEIN    value(4)
 , MM_CREATIVE_PHNBLST_WAVEIN  value(5)
 , MM_CREATIVE_SB15_WAVEOUT    value(101)
 , MM_CREATIVE_SB20_WAVEOUT    value(102)
 , MM_CREATIVE_SBPRO_WAVEOUT   value(103)
 , MM_CREATIVE_SBP16_WAVEOUT   value(104)
 , MM_CREATIVE_PHNBLST_WAVEOUT value(105)
 , MM_CREATIVE_MIDIOUT         value(201) /* SB (r) */
 , MM_CREATIVE_MIDIIN          value(202) /* SB (r) */
 , MM_CREATIVE_FMSYNTH_MONO    value(301) /* SB (r) */
 , MM_CREATIVE_FMSYNTH_STEREO  value(302)
   /*  SB Pro (r) stereo synthesizer  */
 , MM_CREATIVE_MIDI_AWE32      value(303)
 , MM_CREATIVE_AUX_CD          value(401) /* SB Pro (r) aux (CD) */
 , MM_CREATIVE_AUX_LINE        value(402) /* SB Pro (r) aux (Line in) */
 , MM_CREATIVE_AUX_MIC         value(403) /* SB Pro (r) aux (mic) */
 , MM_CREATIVE_AUX_MASTER      value(404)
 , MM_CREATIVE_AUX_PCSPK       value(405)
 , MM_CREATIVE_AUX_WAVE        value(406)
 , MM_CREATIVE_AUX_MIDI        value(407)
 , MM_CREATIVE_SBPRO_MIXER     value(408)
 , MM_CREATIVE_SB16_MIXER      value(409)
 ) fixed bin (31);

 dcl /* MM_MEDIAVISION product IDs */

 /* Pro Audio Spectrum */
 ( MM_MEDIAVISION_PROAUDIO      value('10'xn)
 , MM_PROAUD_MIDIOUT            value(MM_MEDIAVISION_PROAUDIO+1)
 , MM_PROAUD_MIDIIN             value(MM_MEDIAVISION_PROAUDIO+2)
 , MM_PROAUD_SYNTH              value(MM_MEDIAVISION_PROAUDIO+3)
 , MM_PROAUD_WAVEOUT            value(MM_MEDIAVISION_PROAUDIO+4)
 , MM_PROAUD_WAVEIN             value(MM_MEDIAVISION_PROAUDIO+5)
 , MM_PROAUD_MIXER              value(MM_MEDIAVISION_PROAUDIO+6)
 , MM_PROAUD_AUX                value(MM_MEDIAVISION_PROAUDIO+7)

 /* Thunder Board */
 , MM_MEDIAVISION_THUNDER       value('20'xn)
 , MM_THUNDER_SYNTH             value(MM_MEDIAVISION_THUNDER+3)
 , MM_THUNDER_WAVEOUT           value(MM_MEDIAVISION_THUNDER+4)
 , MM_THUNDER_WAVEIN            value(MM_MEDIAVISION_THUNDER+5)
 , MM_THUNDER_AUX               value(MM_MEDIAVISION_THUNDER+7)

 /* Audio Port */
 , MM_MEDIAVISION_TPORT         value('40'xn)
 , MM_TPORT_WAVEOUT             value(MM_MEDIAVISION_TPORT+1)
 , MM_TPORT_WAVEIN              value(MM_MEDIAVISION_TPORT+2)
 , MM_TPORT_SYNTH               value(MM_MEDIAVISION_TPORT+3)

 /* Pro Audio Spectrum Plus */
 , MM_MEDIAVISION_PROAUDIO_PLUS value('50'xn)
 , MM_PROAUD_PLUS_MIDIOUT       value(MM_MEDIAVISION_PROAUDIO_PLUS+1)
 , MM_PROAUD_PLUS_MIDIIN        value(MM_MEDIAVISION_PROAUDIO_PLUS+2)
 , MM_PROAUD_PLUS_SYNTH         value(MM_MEDIAVISION_PROAUDIO_PLUS+3)
 , MM_PROAUD_PLUS_WAVEOUT       value(MM_MEDIAVISION_PROAUDIO_PLUS+4)
 , MM_PROAUD_PLUS_WAVEIN        value(MM_MEDIAVISION_PROAUDIO_PLUS+5)
 , MM_PROAUD_PLUS_MIXER         value(MM_MEDIAVISION_PROAUDIO_PLUS+6)
 , MM_PROAUD_PLUS_AUX           value(MM_MEDIAVISION_PROAUDIO_PLUS+7)

 /* Pro Audio Spectrum 16 */
 , MM_MEDIAVISION_PROAUDIO_16   value('60'xn)
 , MM_PROAUD_16_MIDIOUT         value(MM_MEDIAVISION_PROAUDIO_16+1)
 , MM_PROAUD_16_MIDIIN          value(MM_MEDIAVISION_PROAUDIO_16+2)
 , MM_PROAUD_16_SYNTH           value(MM_MEDIAVISION_PROAUDIO_16+3)
 , MM_PROAUD_16_WAVEOUT         value(MM_MEDIAVISION_PROAUDIO_16+4)
 , MM_PROAUD_16_WAVEIN          value(MM_MEDIAVISION_PROAUDIO_16+5)
 , MM_PROAUD_16_MIXER           value(MM_MEDIAVISION_PROAUDIO_16+6)
 , MM_PROAUD_16_AUX             value(MM_MEDIAVISION_PROAUDIO_16+7)

 /* Pro Audio Studio 16 */
 , MM_MEDIAVISION_PROSTUDIO_16  value('60'xn)
 , MM_STUDIO_16_MIDIOUT         value(MM_MEDIAVISION_PROSTUDIO_16+1)
 , MM_STUDIO_16_MIDIIN          value(MM_MEDIAVISION_PROSTUDIO_16+2)
 , MM_STUDIO_16_SYNTH           value(MM_MEDIAVISION_PROSTUDIO_16+3)
 , MM_STUDIO_16_WAVEOUT         value(MM_MEDIAVISION_PROSTUDIO_16+4)
 , MM_STUDIO_16_WAVEIN          value(MM_MEDIAVISION_PROSTUDIO_16+5)
 , MM_STUDIO_16_MIXER           value(MM_MEDIAVISION_PROSTUDIO_16+6)
 , MM_STUDIO_16_AUX             value(MM_MEDIAVISION_PROSTUDIO_16+7)


 /* CDPC */
 , MM_MEDIAVISION_CDPC          value('70'xn)
 , MM_CDPC_MIDIOUT              value(MM_MEDIAVISION_CDPC+1)
 , MM_CDPC_MIDIIN               value(MM_MEDIAVISION_CDPC+2)
 , MM_CDPC_SYNTH                value(MM_MEDIAVISION_CDPC+3)
 , MM_CDPC_WAVEOUT              value(MM_MEDIAVISION_CDPC+4)
 , MM_CDPC_WAVEIN               value(MM_MEDIAVISION_CDPC+5)
 , MM_CDPC_MIXER                value(MM_MEDIAVISION_CDPC+6)
 , MM_CDPC_AUX                  value(MM_MEDIAVISION_CDPC+7)

 /* Opus MV 1208 Chipsent */
 , MM_MEDIAVISION_OPUS1208      value('80'xn)
 , MM_OPUS401_MIDIOUT           value(MM_MEDIAVISION_OPUS1208+1)
 , MM_OPUS401_MIDIIN            value(MM_MEDIAVISION_OPUS1208+2)
 , MM_OPUS1208_SYNTH            value(MM_MEDIAVISION_OPUS1208+3)
 , MM_OPUS1208_WAVEOUT          value(MM_MEDIAVISION_OPUS1208+4)
 , MM_OPUS1208_WAVEIN           value(MM_MEDIAVISION_OPUS1208+5)
 , MM_OPUS1208_MIXER            value(MM_MEDIAVISION_OPUS1208+6)
 , MM_OPUS1208_AUX              value(MM_MEDIAVISION_OPUS1208+7)

 /* Opus MV 1216 chipset */
 , MM_MEDIAVISION_OPUS1216      value('90'xn)
 , MM_OPUS1216_MIDIOUT          value(MM_MEDIAVISION_OPUS1216+1)
 , MM_OPUS1216_MIDIIN           value(MM_MEDIAVISION_OPUS1216+2)
 , MM_OPUS1216_SYNTH            value(MM_MEDIAVISION_OPUS1216+3)
 , MM_OPUS1216_WAVEOUT          value(MM_MEDIAVISION_OPUS1216+4)
 , MM_OPUS1216_WAVEIN           value(MM_MEDIAVISION_OPUS1216+5)
 , MM_OPUS1216_MIXER            value(MM_MEDIAVISION_OPUS1216+6)
 , MM_OPUS1216_AUX              value(MM_MEDIAVISION_OPUS1216+7)
 ) fixed bin (31);

 dcl /* MM_ARTISOFT product IDs */
 ( MM_ARTISOFT_SBWAVEIN      value(1)
   /* Artisoft sounding Board waveform input  */
 , MM_ARTISOFT_SBWAVEOUT     value(2)
   /* Artisoft sounding Board waveform output */
 ) fixed bin (31);

 dcl /* MM_IBM product IDs */
 ( MM_MMOTION_WAVEAUX     value( 1) /* IBM M-Motion Auxiliary Device */
 , MM_MMOTION_WAVEOUT     value( 2) /* IBM M-Motion Waveform output  */
 , MM_MMOTION_WAVEIN      value( 3) /* IBM M-Motion  Waveform Input  */
 , MM_IBM_PCMCIA_WAVEIN   value(11) /* IBM waveform input */
 , MM_IBM_PCMCIA_WAVEOUT  value(12) /* IBM Waveform output */
 , MM_IBM_PCMCIA_SYNTH    value(13) /* IBM Midi Synthesis */
 , MM_IBM_PCMCIA_MIDIIN   value(14) /* IBM external MIDI in  */
 , MM_IBM_PCMCIA_MIDIOUT  value(15) /* IBM external MIDI out */
 , MM_IBM_PCMCIA_AUX      value(16) /* IBM auxiliary control */
 , MM_IBM_THINKPAD200     value(17)
 , MM_IBM_MWAVE_WAVEIN    value(18)
 , MM_IBM_MWAVE_WAVEOUT   value(19)
 , MM_IBM_MWAVE_MIXER     value(20)
 , MM_IBM_MWAVE_MIDIIN    value(21)
 , MM_IBM_MWAVE_MIDIOUT   value(22)
 , MM_IBM_MWAVE_AUX       value(23)
 , MM_IBM_WC_MIDIOUT      value(30)
 , MM_IBM_WC_WAVEOUT      value(31)
 , MM_IBM_WC_MIXEROUT     value(33)
 ) fixed bin (31);

 dcl /* MM_VOCALTEC product IDs */
 ( MM_VOCALTEC_WAVEOUT       value(1)
 , MM_VOCALTEC_WAVEIN        value(2)
 ) fixed bin (31);

 dcl /* MM_ROLAND product IDs */
 ( MM_ROLAND_RAP10_MIDIOUT   value(10) /* MM_ROLAND_RAP10 */
 , MM_ROLAND_RAP10_MIDIIN    value(11) /* MM_ROLAND_RAP10 */
 , MM_ROLAND_RAP10_SYNTH     value(12) /* MM_ROLAND_RAP10 */
 , MM_ROLAND_RAP10_WAVEOUT   value(13) /* MM_ROLAND_RAP10 */
 , MM_ROLAND_RAP10_WAVEIN    value(14) /* MM_ROLAND_RAP10 */
 , MM_ROLAND_MPU401_MIDIOUT  value(15)
 , MM_ROLAND_MPU401_MIDIIN   value(16)
 , MM_ROLAND_SMPU_MIDIOUTA   value(17)
 , MM_ROLAND_SMPU_MIDIOUTB   value(18)
 , MM_ROLAND_SMPU_MIDIINA    value(19)
 , MM_ROLAND_SMPU_MIDIINB    value(20)
 , MM_ROLAND_SC7_MIDIOUT     value(21)
 , MM_ROLAND_SC7_MIDIIN      value(22)
 , MM_ROLAND_SERIAL_MIDIOUT  value(23)
 , MM_ROLAND_SERIAL_MIDIIN   value(24)
 , MM_ROLAND_SCP_MIDIOUT     value(38)
 , MM_ROLAND_SCP_MIDIIN      value(39)
 , MM_ROLAND_SCP_WAVEOUT     value(40)
 , MM_ROLAND_SCP_WAVEIN      value(41)
 , MM_ROLAND_SCP_MIXER       value(42)
 , MM_ROLAND_SCP_AUX         value(48)
 ) fixed bin (31);

 dcl /* MM_DSP_SOLUTIONS product IDs */
 ( MM_DSP_SOLUTIONS_WAVEOUT  value(1)
 , MM_DSP_SOLUTIONS_WAVEIN   value(2)
 , MM_DSP_SOLUTIONS_SYNTH    value(3)
 , MM_DSP_SOLUTIONS_AUX      value(4)
 ) fixed bin (31);

 dcl /* MM_WANGLABS product IDs */
 ( MM_WANGLABS_WAVEIN1       value(1)
   /* Input audio wave on CPU board models: */
   /* Exec 4010, 4030, 3450 PC 251/25c, pc 461/25s , pc 461/33c  */
 , MM_WANGLABS_WAVEOUT1      value(2)
 ) fixed bin (31);

 dcl /* MM_TANDY product IDs */
 ( MM_TANDY_VISWAVEIN        value(1)
 , MM_TANDY_VISWAVEOUT       value(2)
 , MM_TANDY_VISBIOSSYNTH     value(3)
 , MM_TANDY_SENS_MMAWAVEIN   value(4)
 , MM_TANDY_SENS_MMAWAVEOUT  value(5)
 , MM_TANDY_SENS_MMAMIDIIN   value(6)
 , MM_TANDY_SENS_MMAMIDIOUT  value(7)
 , MM_TANDY_SENS_VISWAVEOUT  value(8)
 , MM_TANDY_PSSJWAVEIN       value(9)
 , MM_TANDY_PSSJWAVEOUT      value(10)
 ) fixed bin (31);

 dcl /* product IDs */
 ( MM_INTELOPD_WAVEIN        value(  1) /* HID2 WaveAudio Driver */
 , MM_INTELOPD_WAVEOUT       value(101) /* HID2 */
 , MM_INTELOPD_AUX           value(401) /* HID2 for mixing */
 , MM_INTEL_NSPMODEMLINE     value(501)
 ) fixed bin (31);

 dcl /* MM_INTERACTIVE product IDs */
 ( MM_INTERACTIVE_WAVEIN     value('45'xn)
 , MM_INTERACTIVE_WAVEOUT    value('45'xn)
 ) fixed bin (31);

 dcl /* MM_YAMAHA product IDs */
 ( MM_YAMAHA_GSS_SYNTH       value('01'xn)
 , MM_YAMAHA_GSS_WAVEOUT     value('02'xn)
 , MM_YAMAHA_GSS_WAVEIN      value('03'xn)
 , MM_YAMAHA_GSS_MIDIOUT     value('04'xn)
 , MM_YAMAHA_GSS_MIDIIN      value('05'xn)
 , MM_YAMAHA_GSS_AUX         value('06'xn)
 , MM_YAMAHA_SERIAL_MIDIOUT  value('07'xn)
 , MM_YAMAHA_SERIAL_MIDIIN   value('08'xn)
 , MM_YAMAHA_OPL3SA_WAVEOUT  value('10'xn)
 , MM_YAMAHA_OPL3SA_WAVEIN   value('11'xn)
 , MM_YAMAHA_OPL3SA_FMSYNTH  value('12'xn)
 , MM_YAMAHA_OPL3SA_YSYNTH   value('13'xn)
 , MM_YAMAHA_OPL3SA_MIDIOUT  value('14'xn)
 , MM_YAMAHA_OPL3SA_MIDIIN   value('15'xn)
 , MM_YAMAHA_OPL3SA_MIXER    value('17'xn)
 , MM_YAMAHA_OPL3SA_JOYSTICK value('18'xn)
 ) fixed bin (31);

 dcl /* MM_EVEREX product IDs */
 ( MM_EVEREX_CARRIER         value('01'xn)
 ) fixed bin (31);

 dcl /* MM_ECHO product IDs */
 ( MM_ECHO_SYNTH             value('01'xn)
 , MM_ECHO_WAVEOUT           value('02'xn)
 , MM_ECHO_WAVEIN            value('03'xn)
 , MM_ECHO_MIDIOUT           value('04'xn)
 , MM_ECHO_MIDIIN            value('05'xn)
 , MM_ECHO_AUX               value('06'xn)
 ) fixed bin (31);

 dcl /* MM_SIERRA product IDs */
 ( MM_SIERRA_ARIA_MIDIOUT      value('14'xn)
 , MM_SIERRA_ARIA_MIDIIN       value('15'xn)
 , MM_SIERRA_ARIA_SYNTH        value('16'xn)
 , MM_SIERRA_ARIA_WAVEOUT      value('17'xn)
 , MM_SIERRA_ARIA_WAVEIN       value('18'xn)
 , MM_SIERRA_ARIA_AUX          value('19'xn)
 , MM_SIERRA_ARIA_AUX2         value('20'xn)
 , MM_SIERRA_QUARTET_WAVEIN    value('50'xn)
 , MM_SIERRA_QUARTET_WAVEOUT   value('51'xn)
 , MM_SIERRA_QUARTET_MIDIIN    value('52'xn)
 , MM_SIERRA_QUARTET_MIDIOUT   value('53'xn)
 , MM_SIERRA_QUARTET_SYNTH     value('54'xn)
 , MM_SIERRA_QUARTET_AUX_CD    value('55'xn)
 , MM_SIERRA_QUARTET_AUX_LINE  value('56'xn)
 , MM_SIERRA_QUARTET_AUX_MODEM value('57'xn)
 , MM_SIERRA_QUARTET_MIXER     value('58'xn)
 ) fixed bin (31);

 dcl /* MM_CAT product IDs */
 ( MM_CAT_WAVEOUT              value(1)
 ) fixed bin (31);

 dcl /* MM_DSP_GROUP product IDs */
 ( MM_DSP_GROUP_TRUESPEECH     value('01'xn)
 ) fixed bin (31);

 dcl /* MM_MELABS product IDs */
 ( MM_MELABS_MIDI2GO           value('01'xn)
 ) fixed bin (31);

 dcl /* MM_ESS product IDs */
 ( MM_ESS_AMWAVEOUT            value('01'xn)
 , MM_ESS_AMWAVEIN             value('02'xn)
 , MM_ESS_AMAUX                value('03'xn)
 , MM_ESS_AMSYNTH              value('04'xn)
 , MM_ESS_AMMIDIOUT            value('05'xn)
 , MM_ESS_AMMIDIIN             value('06'xn)
 , MM_ESS_MIXER                value('07'xn)
 , MM_ESS_AUX_CD               value('08'xn)
 , MM_ESS_MPU401_MIDIOUT       value('09'xn)
 , MM_ESS_MPU401_MIDIIN        value('0A'xn)
 , MM_ESS_ES488_WAVEOUT        value('10'xn)
 , MM_ESS_ES488_WAVEIN         value('11'xn)
 , MM_ESS_ES488_MIXER          value('12'xn)
 , MM_ESS_ES688_WAVEOUT        value('13'xn)
 , MM_ESS_ES688_WAVEIN         value('14'xn)
 , MM_ESS_ES688_MIXER          value('15'xn)
 , MM_ESS_ES1488_WAVEOUT       value('16'xn)
 , MM_ESS_ES1488_WAVEIN        value('17'xn)
 , MM_ESS_ES1488_MIXER         value('18'xn)
 , MM_ESS_ES1688_WAVEOUT       value('19'xn)
 , MM_ESS_ES1688_WAVEIN        value('1A'xn)
 , MM_ESS_ES1688_MIXER         value('1B'xn)
 , MM_ESS_ES1788_WAVEOUT       value('1C'xn)
 , MM_ESS_ES1788_WAVEIN        value('1D'xn)
 , MM_ESS_ES1788_MIXER         value('1E'xn)
 , MM_ESS_ES1888_WAVEOUT       value('1F'xn)
 , MM_ESS_ES1888_WAVEIN        value('20'xn)
 , MM_ESS_ES1888_MIXER         value('21'xn)
 , MM_ESS_ES1868_WAVEOUT       value('22'xn)
 , MM_ESS_ES1868_WAVEIN        value('23'xn)
 , MM_ESS_ES1868_MIXER         value('24'xn)
 , MM_ESS_ES1878_WAVEOUT       value('25'xn)
 , MM_ESS_ES1878_WAVEIN        value('26'xn)
 , MM_ESS_ES1878_MIXER         value('27'xn)
 ) fixed bin (31);

 dcl /* product IDs */
 ( MM_EPS_FMSND                value(1)
 ) fixed bin (31);

 dcl /* MM_TRUEVISION product IDs */
 ( MM_TRUEVISION_WAVEIN1       value(1)
 , MM_TRUEVISION_WAVEOUT1      value(2)
 ) fixed bin (31);

 dcl /* MM_AZTECH product IDs */
 ( MM_AZTECH_MIDIOUT           value(3)
 , MM_AZTECH_MIDIIN            value(4)
 , MM_AZTECH_WAVEIN            value(17)
 , MM_AZTECH_WAVEOUT           value(18)
 , MM_AZTECH_FMSYNTH           value(20)
 , MM_AZTECH_MIXER             value(21)
 , MM_AZTECH_PRO16_WAVEIN      value(33)
 , MM_AZTECH_PRO16_WAVEOUT     value(34)
 , MM_AZTECH_PRO16_FMSYNTH     value(38)
 , MM_AZTECH_DSP16_WAVEIN      value(65)
 , MM_AZTECH_DSP16_WAVEOUT     value(66)
 , MM_AZTECH_DSP16_FMSYNTH     value(68)
 , MM_AZTECH_DSP16_WAVESYNTH   value(70)
 , MM_AZTECH_NOVA16_WAVEIN     value(71)
 , MM_AZTECH_NOVA16_WAVEOUT    value(72)
 , MM_AZTECH_NOVA16_MIXER      value(73)
 , MM_AZTECH_WASH16_WAVEIN     value(74)
 , MM_AZTECH_WASH16_WAVEOUT    value(75)
 , MM_AZTECH_WASH16_MIXER      value(76)
 , MM_AZTECH_AUX_CD            value(401)
 , MM_AZTECH_AUX_LINE          value(402)
 , MM_AZTECH_AUX_MIC           value(403)
 , MM_AZTECH_AUX               value(404)
 ) fixed bin (31);

 dcl /* MM_VIDEOLOGIC product IDs */
 ( MM_VIDEOLOGIC_MSWAVEIN      value(1)
 , MM_VIDEOLOGIC_MSWAVEOUT     value(2)
 ) fixed bin (31);

 dcl /* MM_KORG product IDs */
 ( MM_KORG_PCIF_MIDIOUT        value(1)
 , MM_KORG_PCIF_MIDIIN         value(2)
 ) fixed bin (31);

 dcl /* MM_APT product IDs */
 ( MM_APT_ACE100CD             value(1)
 ) fixed bin (31);

 dcl /* MM_ICS product IDs */
 ( MM_ICS_WAVEDECK_WAVEOUT          value(1)
   /* MS WSS compatible card and driver */
 , MM_ICS_WAVEDECK_WAVEIN           value(2)
 , MM_ICS_WAVEDECK_MIXER            value(3)
 , MM_ICS_WAVEDECK_AUX              value(4)
 , MM_ICS_WAVEDECK_SYNTH            value(5)
 , MM_ICS_WAVEDEC_SB_WAVEOUT        value(6)
 , MM_ICS_WAVEDEC_SB_WAVEIN         value(7)
 , MM_ICS_WAVEDEC_SB_FM_MIDIOUT     value(8)
 , MM_ICS_WAVEDEC_SB_MPU401_MIDIOUT value(9)
 , MM_ICS_WAVEDEC_SB_MPU401_MIDIIN  value(10)
 , MM_ICS_WAVEDEC_SB_MIXER          value(11)
 , MM_ICS_WAVEDEC_SB_AUX            value(12)
 , MM_ICS_2115_LITE_MIDIOUT         value(13)
 , MM_ICS_2120_LITE_MIDIOUT         value(14)
 ) fixed bin (31);

 dcl /* MM_ITERATEDSYS product IDs */
 ( MM_ITERATEDSYS_FUFCODEC     value(1)
 ) fixed bin (31);

 dcl /* MM_METHEUS product IDs */
 ( MM_METHEUS_ZIPPER           value(1)
 ) fixed bin (31);

 dcl /* MM_WINNOV product IDs */
 ( MM_WINNOV_CAVIAR_WAVEIN     value(1)
 , MM_WINNOV_CAVIAR_WAVEOUT    value(2)
 , MM_WINNOV_CAVIAR_VIDC       value(3)
 , MM_WINNOV_CAVIAR_CHAMPAGNE  value(4) /* Fourcc is CHAM */
 , MM_WINNOV_CAVIAR_YUV8       value(5) /* Fourcc is YUV8 */
 ) fixed bin (31);

 dcl /* MM_NCR product IDs */
 ( MM_NCR_BA_WAVEIN            value(1)
 , MM_NCR_BA_WAVEOUT           value(2)
 , MM_NCR_BA_SYNTH             value(3)
 , MM_NCR_BA_AUX               value(4)
 , MM_NCR_BA_MIXER             value(5)
 ) fixed bin (31);

 dcl /* MM_VITEC product IDs */
 ( MM_VITEC_VMAKER             value(1)
 , MM_VITEC_VMPRO              value(2)
 ) fixed bin (31);

 dcl /* MM_MOSCOM product IDs */
 ( MM_MOSCOM_VPC2400_IN        value(1)
   /* Four Port Voice Processing / Voice Recognition Board */
 , MM_MOSCOM_VPC2400_OUT       value(2) /* VPC2400 */
 ) fixed bin (31);

 dcl /* MM_SILICONSOFT product IDs */
 ( MM_SILICONSOFT_SC1_WAVEIN         value(1)
   /* Waveform in , high sample rate */
 , MM_SILICONSOFT_SC1_WAVEOUT        value(2)
   /* Waveform out , high sample rate */
 , MM_SILICONSOFT_SC2_WAVEIN         value(3)
   /* Waveform in 2 channels, high sample rate */
 , MM_SILICONSOFT_SC2_WAVEOUT        value(4)
   /* Waveform out 2 channels, high sample rate */
 , MM_SILICONSOFT_SOUNDJR2_WAVEOUT   value(5)
   /* Waveform out, self powered, efficient */
 , MM_SILICONSOFT_SOUNDJR2PR_WAVEIN  value(6)
   /* Waveform in, self powered, efficient */
 , MM_SILICONSOFT_SOUNDJR2PR_WAVEOUT value(7)
   /* Waveform out 2 channels, self powered, efficient */
 , MM_SILICONSOFT_SOUNDJR3_WAVEOUT   value(8)
   /* Waveform in 2 channels, self powered, efficient */
 ) fixed bin (31);

 dcl /* MM_OLIVETTI product IDs */
 ( MM_OLIVETTI_WAVEIN          value(1)
 , MM_OLIVETTI_WAVEOUT         value(2)
 , MM_OLIVETTI_MIXER           value(3)
 , MM_OLIVETTI_AUX             value(4)
 , MM_OLIVETTI_MIDIIN          value(5)
 , MM_OLIVETTI_MIDIOUT         value(6)
 , MM_OLIVETTI_SYNTH           value(7)
 , MM_OLIVETTI_JOYSTICK        value(8)
 , MM_OLIVETTI_ACM_GSM         value(9)
 , MM_OLIVETTI_ACM_ADPCM       value(10)
 , MM_OLIVETTI_ACM_CELP        value(11)
 , MM_OLIVETTI_ACM_SBC         value(12)
 , MM_OLIVETTI_ACM_OPR         value(13)
 ) fixed bin (31);

 dcl /* MM_IOMAGIC product IDs */
 /* The I/O Magic Tempo is a PCMCIA Type 2 audio card featuring       */
 /* wave audio record and playback, FM synthesizer, and MIDI output.  */
 /* The I/O Magic Tempo WaveOut device supports mono and stereo PCM   */
 /* playback at rates of 7350, 11025, 22050, and  44100 samples       */
 ( MM_IOMAGIC_TEMPO_WAVEOUT    value(1)
 , MM_IOMAGIC_TEMPO_WAVEIN     value(2)
 , MM_IOMAGIC_TEMPO_SYNTH      value(3)
 , MM_IOMAGIC_TEMPO_MIDIOUT    value(4)
 , MM_IOMAGIC_TEMPO_MXDOUT     value(5)
 , MM_IOMAGIC_TEMPO_AUXOUT     value(6)
 ) fixed bin (31);

 dcl /* MM_MATSUSHITA product IDs */
 ( MM_MATSUSHITA_WAVEIN         value(1)
 , MM_MATSUSHITA_WAVEOUT        value(2)
 , MM_MATSUSHITA_FMSYNTH_STEREO value(3)
 , MM_MATSUSHITA_MIXER          value(4)
 , MM_MATSUSHITA_AUX            value(5)
 ) fixed bin (31);

 dcl /* MM_NEWMEDIA product IDs */
 ( MM_NEWMEDIA_WAVJAMMER       value(1) /* WSS Compatible sound card. */
 ) fixed bin (31);

 dcl /* MM_LYRRUS product IDs */
 /* Bridge is a MIDI driver that allows the the Lyrrus G-VOX hardware */
 /* to communicate with Windows base transcription and sequencer      */
 /* applications. The driver also provides a mechanism for the user   */
 /* to configure the system to their personal playing style.          */
 ( MM_LYRRUS_BRIDGE_GUITAR     value(1)
 ) fixed bin (31);

 dcl /* MM_OPTI product IDs */
 ( MM_OPTI_M16_FMSYNTH_STEREO  value('0001'xn)
 , MM_OPTI_M16_MIDIIN          value('0002'xn)
 , MM_OPTI_M16_MIDIOUT         value('0003'xn)
 , MM_OPTI_M16_WAVEIN          value('0004'xn)
 , MM_OPTI_M16_WAVEOUT         value('0005'xn)
 , MM_OPTI_M16_MIXER           value('0006'xn)
 , MM_OPTI_M16_AUX             value('0007'xn)
 , MM_OPTI_P16_FMSYNTH_STEREO  value('0010'xn)
 , MM_OPTI_P16_MIDIIN          value('0011'xn)
 , MM_OPTI_P16_MIDIOUT         value('0012'xn)
 , MM_OPTI_P16_WAVEIN          value('0013'xn)
 , MM_OPTI_P16_WAVEOUT         value('0014'xn)
 , MM_OPTI_P16_MIXER           value('0015'xn)
 , MM_OPTI_P16_AUX             value('0016'xn)
 , MM_OPTI_M32_WAVEIN          value('0020'xn)
 , MM_OPTI_M32_WAVEOUT         value('0021'xn)
 , MM_OPTI_M32_MIDIIN          value('0022'xn)
 , MM_OPTI_M32_MIDIOUT         value('0023'xn)
 , MM_OPTI_M32_SYNTH_STEREO    value('0024'xn)
 , MM_OPTI_M32_MIXER           value('0025'xn)
 , MM_OPTI_M32_AUX             value('0026'xn)
 ) fixed bin (31);

 dcl /* Product IDs for     MM_ADDX    -  ADDX    */
 ( MM_ADDX_PCTV_DIGITALMIX     value(1)
 , MM_ADDX_PCTV_WAVEIN         value(2)
 , MM_ADDX_PCTV_WAVEOUT        value(3)
 , MM_ADDX_PCTV_MIXER          value(4)
 , MM_ADDX_PCTV_AUX_CD         value(5)
 , MM_ADDX_PCTV_AUX_LINE       value(6)
 ) fixed bin (31);

 dcl /* Product IDs for     MM_AHEAD    -  Ahead, Inc.    */
 ( MM_AHEAD_MULTISOUND     value(1)
 , MM_AHEAD_SOUNDBLASTER     value(2)
 , MM_AHEAD_PROAUDIO     value(3)
 , MM_AHEAD_GENERIC     value(4)
 ) fixed bin (31);

 dcl /* Product IDs for     MM_AMD    -  AMD    */
 ( MM_AMD_INTERWAVE_WAVEIN          value(1)
 , MM_AMD_INTERWAVE_WAVEOUT         value(2)
 , MM_AMD_INTERWAVE_SYNTH           value(3)
 , MM_AMD_INTERWAVE_MIXER1          value(4)
 , MM_AMD_INTERWAVE_MIXER2          value(5)
 , MM_AMD_INTERWAVE_JOYSTICK        value(6)
 , MM_AMD_INTERWAVE_EX_CD           value(7)
 , MM_AMD_INTERWAVE_MIDIIN          value(8)
 , MM_AMD_INTERWAVE_MIDIOUT         value(9)
 , MM_AMD_INTERWAVE_AUX1            value(10)
 , MM_AMD_INTERWAVE_AUX2            value(11)
 , MM_AMD_INTERWAVE_AUX_MIC         value(12)
 , MM_AMD_INTERWAVE_AUX_CD          value(13)
 , MM_AMD_INTERWAVE_MONO_IN         value(14)
 , MM_AMD_INTERWAVE_MONO_OUT        value(15)
 , MM_AMD_INTERWAVE_EX_TELEPHONY    value(16)
 , MM_AMD_INTERWAVE_WAVEOUT_BASE    value(17)
 , MM_AMD_INTERWAVE_WAVEOUT_TREBLE  value(18)
 , MM_AMD_INTERWAVE_STEREO_ENHANCED value(19)
 ) fixed bin (31);

 dcl /* Product IDs for     MM_AST    -  AST Research Inc.    */
 ( MM_AST_MODEMWAVE_WAVEIN     value(13)
 , MM_AST_MODEMWAVE_WAVEOUT    value(14)

 ) fixed bin (31);

 dcl /* Product IDs for     MM_BROOKTREE    -  Brooktree Corporation  */
 ( MM_BTV_WAVEIN         value(1) /* Brooktree PCM Wave Audio In */
 , MM_BTV_WAVEOUT        value(2) /* Brooktree PCM Wave Audio Out */
 , MM_BTV_MIDIIN         value(3) /* Brooktree MIDI In */
 , MM_BTV_MIDIOUT        value(4) /* Brooktree MIDI out */
 , MM_BTV_MIDISYNTH      value(5) /* Brooktree MIDI FM synth */
 , MM_BTV_AUX_LINE       value(6) /* Brooktree Line Input */
 , MM_BTV_AUX_MIC        value(7) /* Brooktree Microphone Input */
 , MM_BTV_AUX_CD         value(8) /* Brooktree CD Input */
 , MM_BTV_DIGITALIN      value(9)
   /* Brooktree PCM Wave in with subcode information */
 , MM_BTV_DIGITALOUT     value(10)
   /* Brooktree PCM Wave out with subcode information */
 , MM_BTV_MIDIWAVESTREAM value(11) /* Brooktree WaveStream */
 , MM_BTV_MIXER          value(12) /* Brooktree WSS Mixer driver */

 ) fixed bin (31);

 dcl /* Product IDs for     MM_CANAM    -  CANAM Computers    */
 ( MM_CANAM_CBXWAVEOUT         value(1)
 , MM_CANAM_CBXWAVEIN          value(2)

 ) fixed bin (31);

 dcl /* Product IDs for     MM_CASIO    -  Casio Computer Co., LTD   */
 ( MM_CASIO_WP150_MIDIOUT      value(1) /* wp150 */
 , MM_CASIO_WP150_MIDIIN       value(2)
 ) fixed bin (31);

 dcl /* Product IDs for     MM_COMPAQ    -  Compaq Computer Corp.    */
 ( MM_COMPAQ_BB_WAVEIN         value(1)
 , MM_COMPAQ_BB_WAVEOUT        value(2)
 , MM_COMPAQ_BB_WAVEAUX        value(3)

 /*  Product IDs for     MM_COREDYNAMICS    -  Core Dynamics    */
 , MM_COREDYNAMICS_DYNAMIXHR           value(1) /* DynaMax Hi-Rez */
 , MM_COREDYNAMICS_DYNASONIX_SYNTH     value(2) /* DynaSonix */
 , MM_COREDYNAMICS_DYNASONIX_MIDI_IN   value(3)
 , MM_COREDYNAMICS_DYNASONIX_MIDI_OUT  value(4)
 , MM_COREDYNAMICS_DYNASONIX_WAVE_IN   value(5)
 , MM_COREDYNAMICS_DYNASONIX_WAVE_OUT  value(6)
 , MM_COREDYNAMICS_DYNASONIX_AUDIO_IN  value(7)
 , MM_COREDYNAMICS_DYNASONIX_AUDIO_OUT value(8)
 , MM_COREDYNAMICS_DYNAGRAFX_VGA       value(9) /* DynaGrfx */
 , MM_COREDYNAMICS_DYNAGRAFX_WAVE_IN   value(10)
 , MM_COREDYNAMICS_DYNAGRAFX_WAVE_OUT  value(11)
 ) fixed bin (31);

 dcl /* Product IDs for MM_CRYSTAL - Crystal Semiconductor Corporation*/
 ( MM_CRYSTAL_CS4232_WAVEIN         value(1)
 , MM_CRYSTAL_CS4232_WAVEOUT        value(2)
 , MM_CRYSTAL_CS4232_WAVEMIXER      value(3)
 , MM_CRYSTAL_CS4232_WAVEAUX_AUX1   value(4)
 , MM_CRYSTAL_CS4232_WAVEAUX_AUX2   value(5)
 , MM_CRYSTAL_CS4232_WAVEAUX_LINE   value(6)
 , MM_CRYSTAL_CS4232_WAVEAUX_MONO   value(7)
 , MM_CRYSTAL_CS4232_WAVEAUX_MASTER value(8)
 , MM_CRYSTAL_CS4232_MIDIIN         value(9)
 , MM_CRYSTAL_CS4232_MIDIOUT        value(10)
 , MM_CRYSTAL_CS4232_INPUTGAIN_AUX1 value(13)
 , MM_CRYSTAL_CS4232_INPUTGAIN_LOOP value(14)
 ) fixed bin (31);

 dcl /* Product IDs for     MM_DDD    -  Danka Data Devices    */
 ( MM_DDD_MIDILINK_MIDIIN      value(1)
 , MM_DDD_MIDILINK_MIDIOUT     value(2)
 ) fixed bin (31);

 dcl /* Product IDs for     MM_DIACOUSTICS    -  DiAcoustics, Inc.   */
 ( MM_DIACOUSTICS_DRUM_ACTION  value(1) /* Drum Action */
 ) fixed bin (31);

 dcl /*  Product IDs for     MM_DIAMONDMM    -  Diamond Multimedia    */
 ( MM_DIMD_PLATFORM            value(0) /* Freedom Audio */
 , MM_DIMD_DIRSOUND            value(1)
 , MM_DIMD_VIRTMPU             value(2)
 , MM_DIMD_VIRTSB              value(3)
 , MM_DIMD_VIRTJOY             value(4)
 , MM_DIMD_WAVEIN              value(5)
 , MM_DIMD_WAVEOUT             value(6)
 , MM_DIMD_MIDIIN              value(7)
 , MM_DIMD_MIDIOUT             value(8)
 , MM_DIMD_AUX_LINE            value(9)
 , MM_DIMD_MIXER               value(10)
 ) fixed bin (31);

 dcl /* Product IDs for MM_DIGITAL_AUDIO_LABS */
     /* - Digital Audio Labs, Inc. */
 ( MM_DIGITAL_AUDIO_LABS_V8    value('10'xn)
 , MM_DIGITAL_AUDIO_LABS_CPRO  value('11'xn)

 /*  Product IDs for    MM_DIGITAL   -  Digital Equipment Corporation */
 , MM_DIGITAL_AV320_WAVEIN     value(1)
   /* Digital Audio Video Compression Board */
 , MM_DIGITAL_AV320_WAVEOUT    value(2)
   /* Digital Audio Video Compression Board */
 ) fixed bin (31);

 dcl /* Product IDs for MM_ECS -  Electronic Courseware Systems, Inc. */
 ( MM_ECS_AADF_MIDI_IN         value(10)
 , MM_ECS_AADF_MIDI_OUT        value(11)
 , MM_ECS_AADF_WAVE2MIDI_IN    value(12)
 ) fixed bin (31);

 dcl /* Product IDs for     MM_ENSONIQ    -  ENSONIQ Corporation    */
 ( MM_ENSONIQ_SOUNDSCAPE       value('10'xn) /* ENSONIQ Soundscape */
 , MM_SOUNDSCAPE_WAVEOUT       value(MM_ENSONIQ_SOUNDSCAPE+1)
 , MM_SOUNDSCAPE_WAVEOUT_AUX   value(MM_ENSONIQ_SOUNDSCAPE+2)
 , MM_SOUNDSCAPE_WAVEIN        value(MM_ENSONIQ_SOUNDSCAPE+3)
 , MM_SOUNDSCAPE_MIDIOUT       value(MM_ENSONIQ_SOUNDSCAPE+4)
 , MM_SOUNDSCAPE_MIDIIN        value(MM_ENSONIQ_SOUNDSCAPE+5)
 , MM_SOUNDSCAPE_SYNTH         value(MM_ENSONIQ_SOUNDSCAPE+6)
 , MM_SOUNDSCAPE_MIXER         value(MM_ENSONIQ_SOUNDSCAPE+7)
 , MM_SOUNDSCAPE_AUX           value (MM_ENSONIQ_SOUNDSCAPE+8)
 ) fixed bin (31);

 dcl /* Product IDs for MM_FRONTIER - Frontier Design Group LLC */
 ( MM_FRONTIER_WAVECENTER_MIDIIN  value(1) /* WaveCenter */
 , MM_FRONTIER_WAVECENTER_MIDIOUT value(2)
 , MM_FRONTIER_WAVECENTER_WAVEIN  value(3)
 , MM_FRONTIER_WAVECENTER_WAVEOUT value(4)
 ) fixed bin (31);

 dcl /* Product IDs for MM_GADGETLABS - Gadget Labs LLC */
 ( MM_GADGETLABS_WAVE44_WAVEIN    value(1)
 , MM_GADGETLABS_WAVE44_WAVEOUT   value(2)
 , MM_GADGETLABS_WAVE42_WAVEIN    value(3)
 , MM_GADGETLABS_WAVE42_WAVEOUT   value(4)
 , MM_GADGETLABS_WAVE4_MIDIIN     value(5)
 , MM_GADGETLABS_WAVE4_MIDIOUT    value(6)
 ) fixed bin (31);

 dcl /* Product IDs for MM_KAY_ELEMETRICS -  Kay Elemetrics, Inc. */
 ( MM_KAY_ELEMETRICS_CSL          value('4300'xn)
 , MM_KAY_ELEMETRICS_CSL_DAT      value('4308'xn)
 , MM_KAY_ELEMETRICS_CSL_4CHANNEL value('4309'xn)
 ) fixed bin (31);

 dcl /* Product IDs for MM_LERNOUT_AND_HAUSPIE - Lernout & Hauspie */
 ( MM_LERNOUT_ANDHAUSPIE_LHCODECACM value(1)
 ) fixed bin (31);

 dcl /*  Product IDs for MM_MPTUS -  M.P. Technologies, Inc. */
 ( MM_MPTUS_SPWAVEOUT             value(1) /* Sound Pallette */
 ) fixed bin (31);

 dcl /*  Product IDs for     MM_MOTU    -  Mark of the Unicorn    */
 ( MM_MOTU_MTP_MIDIOUT_ALL        value(100)
 , MM_MOTU_MTP_MIDIIN_1           value(101)
 , MM_MOTU_MTP_MIDIOUT_1          value(101)
 , MM_MOTU_MTP_MIDIIN_2           value(102)
 , MM_MOTU_MTP_MIDIOUT_2          value(102)
 , MM_MOTU_MTP_MIDIIN_3           value(103)
 , MM_MOTU_MTP_MIDIOUT_3          value(103)
 , MM_MOTU_MTP_MIDIIN_4           value(104)
 , MM_MOTU_MTP_MIDIOUT_4          value(104)
 , MM_MOTU_MTP_MIDIIN_5           value(105)
 , MM_MOTU_MTP_MIDIOUT_5          value(105)
 , MM_MOTU_MTP_MIDIIN_6           value(106)
 , MM_MOTU_MTP_MIDIOUT_6          value(106)
 , MM_MOTU_MTP_MIDIIN_7           value(107)
 , MM_MOTU_MTP_MIDIOUT_7          value(107)
 , MM_MOTU_MTP_MIDIIN_8           value(108)
 , MM_MOTU_MTP_MIDIOUT_8          value(108)

 , MM_MOTU_MTPII_MIDIOUT_ALL      value(200)
 , MM_MOTU_MTPII_MIDIIN_SYNC      value(200)
 , MM_MOTU_MTPII_MIDIIN_1         value(201)
 , MM_MOTU_MTPII_MIDIOUT_1        value(201)
 , MM_MOTU_MTPII_MIDIIN_2         value(202)
 , MM_MOTU_MTPII_MIDIOUT_2        value(202)
 , MM_MOTU_MTPII_MIDIIN_3         value(203)
 , MM_MOTU_MTPII_MIDIOUT_3        value(203)
 , MM_MOTU_MTPII_MIDIIN_4         value(204)
 , MM_MOTU_MTPII_MIDIOUT_4        value(204)
 , MM_MOTU_MTPII_MIDIIN_5         value(205)
 , MM_MOTU_MTPII_MIDIOUT_5        value(205)
 , MM_MOTU_MTPII_MIDIIN_6         value(206)
 , MM_MOTU_MTPII_MIDIOUT_6        value(206)
 , MM_MOTU_MTPII_MIDIIN_7         value(207)
 , MM_MOTU_MTPII_MIDIOUT_7        value(207)
 , MM_MOTU_MTPII_MIDIIN_8         value(208)
 , MM_MOTU_MTPII_MIDIOUT_8        value(208)
 , MM_MOTU_MTPII_NET_MIDIIN_1     value(209)
 , MM_MOTU_MTPII_NET_MIDIOUT_1    value(209)
 , MM_MOTU_MTPII_NET_MIDIIN_2     value(210)
 , MM_MOTU_MTPII_NET_MIDIOUT_2    value(210)
 , MM_MOTU_MTPII_NET_MIDIIN_3     value(211)
 , MM_MOTU_MTPII_NET_MIDIOUT_3    value(211)
 , MM_MOTU_MTPII_NET_MIDIIN_4     value(212)
 , MM_MOTU_MTPII_NET_MIDIOUT_4    value(212)
 , MM_MOTU_MTPII_NET_MIDIIN_5     value(213)
 , MM_MOTU_MTPII_NET_MIDIOUT_5    value(213)
 , MM_MOTU_MTPII_NET_MIDIIN_6     value(214)
 , MM_MOTU_MTPII_NET_MIDIOUT_6    value(214)
 , MM_MOTU_MTPII_NET_MIDIIN_7     value(215)
 , MM_MOTU_MTPII_NET_MIDIOUT_7    value(215)
 , MM_MOTU_MTPII_NET_MIDIIN_8     value(216)
 , MM_MOTU_MTPII_NET_MIDIOUT_8    value(216)

 , MM_MOTU_MXP_MIDIIN_MIDIOUT_ALL value(300)
 , MM_MOTU_MXP_MIDIIN_SYNC        value(300)
 , MM_MOTU_MXP_MIDIIN_MIDIIN_1    value(301)
 , MM_MOTU_MXP_MIDIIN_MIDIOUT_1   value(301)
 , MM_MOTU_MXP_MIDIIN_MIDIIN_2    value(302)
 , MM_MOTU_MXP_MIDIIN_MIDIOUT_2   value(302)
 , MM_MOTU_MXP_MIDIIN_MIDIIN_3    value(303)
 , MM_MOTU_MXP_MIDIIN_MIDIOUT_3   value(303)
 , MM_MOTU_MXP_MIDIIN_MIDIIN_4    value(304)
 , MM_MOTU_MXP_MIDIIN_MIDIOUT_4   value(304)
 , MM_MOTU_MXP_MIDIIN_MIDIIN_5    value(305)
 , MM_MOTU_MXP_MIDIIN_MIDIOUT_5   value(305)
 , MM_MOTU_MXP_MIDIIN_MIDIIN_6    value(306)
 , MM_MOTU_MXP_MIDIIN_MIDIOUT_6   value(306)

 , MM_MOTU_MXPMPU_MIDIOUT_ALL     value(400)
 , MM_MOTU_MXPMPU_MIDIIN_SYNC     value(400)
 , MM_MOTU_MXPMPU_MIDIIN_1        value(401)
 , MM_MOTU_MXPMPU_MIDIOUT_1       value(401)
 , MM_MOTU_MXPMPU_MIDIIN_2        value(402)
 , MM_MOTU_MXPMPU_MIDIOUT_2       value(402)
 , MM_MOTU_MXPMPU_MIDIIN_3        value(403)
 , MM_MOTU_MXPMPU_MIDIOUT_3       value(403)
 , MM_MOTU_MXPMPU_MIDIIN_4        value(404)
 , MM_MOTU_MXPMPU_MIDIOUT_4       value(404)
 , MM_MOTU_MXPMPU_MIDIIN_5        value(405)
 , MM_MOTU_MXPMPU_MIDIOUT_5       value(405)
 , MM_MOTU_MXPMPU_MIDIIN_6        value(406)
 , MM_MOTU_MXPMPU_MIDIOUT_6       value(406)

 , MM_MOTU_MXN_MIDIOUT_ALL        value(500)
 , MM_MOTU_MXN_MIDIIN_SYNC        value(500)
 , MM_MOTU_MXN_MIDIIN_1           value(501)
 , MM_MOTU_MXN_MIDIOUT_1          value(501)
 , MM_MOTU_MXN_MIDIIN_2           value(502)
 , MM_MOTU_MXN_MIDIOUT_2          value(502)
 , MM_MOTU_MXN_MIDIIN_3           value(503)
 , MM_MOTU_MXN_MIDIOUT_3          value(503)
 , MM_MOTU_MXN_MIDIIN_4           value(504)
 , MM_MOTU_MXN_MIDIOUT_4          value(504)

 , MM_MOTU_FLYER_MIDI_IN_SYNC     value(600)
 , MM_MOTU_FLYER_MIDI_IN_A        value(601)
 , MM_MOTU_FLYER_MIDI_OUT_A       value(601)
 , MM_MOTU_FLYER_MIDI_IN_B        value(602)
 , MM_MOTU_FLYER_MIDI_OUT_B       value(602)

 , MM_MOTU_PKX_MIDI_IN_SYNC       value(700)
 , MM_MOTU_PKX_MIDI_IN_A          value(701)
 , MM_MOTU_PKX_MIDI_OUT_A         value(701)
 , MM_MOTU_PKX_MIDI_IN_B          value(702)
 , MM_MOTU_PKX_MIDI_OUT_B         value(702)

 , MM_MOTU_DTX_MIDI_IN_SYNC       value(800)
 , MM_MOTU_DTX_MIDI_IN_A          value(801)
 , MM_MOTU_DTX_MIDI_OUT_A         value(801)
 , MM_MOTU_DTX_MIDI_IN_B          value(802)
 , MM_MOTU_DTX_MIDI_OUT_B         value(802)

 , MM_MOTU_MTPAV_MIDIOUT_ALL      value(900)
 , MM_MOTU_MTPAV_MIDIIN_SYNC      value(900)
 , MM_MOTU_MTPAV_MIDIIN_1         value(901)
 , MM_MOTU_MTPAV_MIDIOUT_1        value(901)
 , MM_MOTU_MTPAV_MIDIIN_2         value(902)
 , MM_MOTU_MTPAV_MIDIOUT_2        value(902)
 , MM_MOTU_MTPAV_MIDIIN_3         value(903)
 , MM_MOTU_MTPAV_MIDIOUT_3        value(903)
 , MM_MOTU_MTPAV_MIDIIN_4         value(904)
 , MM_MOTU_MTPAV_MIDIOUT_4        value(904)
 , MM_MOTU_MTPAV_MIDIIN_5         value(905)
 , MM_MOTU_MTPAV_MIDIOUT_5        value(905)
 , MM_MOTU_MTPAV_MIDIIN_6         value(906)
 , MM_MOTU_MTPAV_MIDIOUT_6        value(906)
 , MM_MOTU_MTPAV_MIDIIN_7         value(907)
 , MM_MOTU_MTPAV_MIDIOUT_7        value(907)
 , MM_MOTU_MTPAV_MIDIIN_8         value(908)
 , MM_MOTU_MTPAV_MIDIOUT_8        value(908)
 , MM_MOTU_MTPAV_NET_MIDIIN_1     value(909)
 , MM_MOTU_MTPAV_NET_MIDIOUT_1    value(909)
 , MM_MOTU_MTPAV_NET_MIDIIN_2     value(910)
 , MM_MOTU_MTPAV_NET_MIDIOUT_2    value(910)
 , MM_MOTU_MTPAV_NET_MIDIIN_3     value(911)
 , MM_MOTU_MTPAV_NET_MIDIOUT_3    value(911)
 , MM_MOTU_MTPAV_NET_MIDIIN_4     value(912)
 , MM_MOTU_MTPAV_NET_MIDIOUT_4    value(912)
 , MM_MOTU_MTPAV_NET_MIDIIN_5     value(913)
 , MM_MOTU_MTPAV_NET_MIDIOUT_5    value(913)
 , MM_MOTU_MTPAV_NET_MIDIIN_6     value(914)
 , MM_MOTU_MTPAV_NET_MIDIOUT_6    value(914)
 , MM_MOTU_MTPAV_NET_MIDIIN_7     value(915)
 , MM_MOTU_MTPAV_NET_MIDIOUT_7    value(915)
 , MM_MOTU_MTPAV_NET_MIDIIN_8     value(916)
 , MM_MOTU_MTPAV_NET_MIDIOUT_8    value(916)
 , MM_MOTU_MTPAV_MIDIIN_ADAT      value(917)
 , MM_MOTU_MTPAV_MIDIOUT_ADAT     value(917)
 ) fixed bin (31);

 dcl /* Product IDs for     MM_MIRO    -  miro Computer Products AG   */
 ( MM_MIRO_MOVIEPRO            value(1) /* miroMOVIE pro */
 , MM_MIRO_VIDEOD1             value(2) /* miroVIDEO D1 */
 , MM_MIRO_VIDEODC1TV          value(3) /* miroVIDEO DC1 tv */
 , MM_MIRO_VIDEOTD             value(4) /* miroVIDEO 10/20 TD */
 , MM_MIRO_DC30_WAVEOUT        value(5)
 , MM_MIRO_DC30_WAVEIN         value(6)
 , MM_MIRO_DC30_MIX            value(7)
 ) fixed bin (31);

 dcl /*  Product IDs for   MM_NEC    -  NEC    */
 ( MM_NEC_73_86_SYNTH          value(5)
 , MM_NEC_73_86_WAVEOUT        value(6)
 , MM_NEC_73_86_WAVEIN         value(7)
 , MM_NEC_26_SYNTH             value(9)
 , MM_NEC_MPU401_MIDIOUT       value(10)
 , MM_NEC_MPU401_MIDIIN        value(11)
 , MM_NEC_JOYSTICK             value(12)
 ) fixed bin (31);

 dcl /* Product IDs for MM_NORRIS    -  Norris Communications, Inc.*/
 ( MM_NORRIS_VOICELINK         value(1)
 ) fixed bin (31);

 dcl /* Product IDs for MM_NORTHERN_TELECOM - Northern Telecom Limited*/
 ( MM_NORTEL_MPXAC_WAVEIN      value(1)
   /*  MPX Audio Card Wave Input Device */
 , MM_NORTEL_MPXAC_WAVEOUT     value(2)
   /* MPX Audio Card Wave Output Device */

 ) fixed bin (31);

 dcl /*  Product IDs for     MM_NVIDIA    -  NVidia Corporation    */
 ( MM_NVIDIA_WAVEOUT           value(1)
 , MM_NVIDIA_WAVEIN            value(2)
 , MM_NVIDIA_MIDIOUT           value(3)
 , MM_NVIDIA_MIDIIN            value(4)
 , MM_NVIDIA_GAMEPORT          value(5)
 , MM_NVIDIA_MIXER             value(6)
 , MM_NVIDIA_AUX               value(7)
 ) fixed bin (31);

 dcl /*  Product IDs for     MM_OKSORI    -  OKSORI Co., Ltd.    */
 ( MM_OKSORI_BASE              value(0)
   /* Oksori Base */
 , MM_OKSORI_OSR8_WAVEOUT      value(MM_OKSORI_BASE+1)
   /* Oksori 8bit Wave out */
 , MM_OKSORI_OSR8_WAVEIN       value(MM_OKSORI_BASE+2)
   /* Oksori 8bit Wave in */
 , MM_OKSORI_OSR16_WAVEOUT     value(MM_OKSORI_BASE+3)
   /* Oksori 16 bit Wave out */
 , MM_OKSORI_OSR16_WAVEIN      value(MM_OKSORI_BASE+4)
   /* Oksori 16 bit Wave in */
 , MM_OKSORI_FM_OPL4           value(MM_OKSORI_BASE+5)
   /* Oksori FM Synth Yamaha OPL4 */
 , MM_OKSORI_MIX_MASTER        value(MM_OKSORI_BASE+6)
   /* Oksori DSP Mixer - Master Volume */
 , MM_OKSORI_MIX_WAVE          value(MM_OKSORI_BASE+7)
   /* Oksori DSP Mixer - Wave Volume */
 , MM_OKSORI_MIX_FM            value(MM_OKSORI_BASE+8)
   /* Oksori DSP Mixer - FM Volume */
 , MM_OKSORI_MIX_LINE          value(MM_OKSORI_BASE+9)
   /* Oksori DSP Mixer - Line Volume */
 , MM_OKSORI_MIX_CD            value(MM_OKSORI_BASE+10)
   /* Oksori DSP Mixer - CD Volume */
 , MM_OKSORI_MIX_MIC           value(MM_OKSORI_BASE+11)
   /* Oksori DSP Mixer - MIC Volume */
 , MM_OKSORI_MIX_ECHO          value(MM_OKSORI_BASE+12)
   /* Oksori DSP Mixer - Echo Volume */
 , MM_OKSORI_MIX_AUX1          value(MM_OKSORI_BASE+13)
   /* Oksori AD1848 - AUX1 Volume */
 , MM_OKSORI_MIX_LINE1         value(MM_OKSORI_BASE+14)
   /* Oksori AD1848 - LINE1 Volume */
 , MM_OKSORI_EXT_MIC1          value(MM_OKSORI_BASE+15)
   /* Oksori External - One Mic Connect */
 , MM_OKSORI_EXT_MIC2          value(MM_OKSORI_BASE+16)
   /* Oksori External - Two Mic Connect */
 , MM_OKSORI_MIDIOUT           value(MM_OKSORI_BASE+17)
   /* Oksori MIDI Out Device */
 , MM_OKSORI_MIDIIN            value(MM_OKSORI_BASE+18)
   /* Oksori MIDI In Device */
 , MM_OKSORI_MPEG_CDVISION     value(MM_OKSORI_BASE+19)
   /* Oksori CD-Vision MPEG Decoder */
 ) fixed bin (31);

 dcl /* Product IDs for MM_OSITECH    -  Ositech Communications Inc. */
 ( MM_OSITECH_TRUMPCARD        value(1) /* Trumpcard */
 ) fixed bin (31);

 dcl /* Product IDs for MM_OSPREY     -  Osprey Technologies, Inc.   */
 ( MM_OSPREY_1000WAVEIN        value(1)
 , MM_OSPREY_1000WAVEOUT       value(2)
 ) fixed bin (31);

 dcl /* Product IDs for  MM_QUARTERDECK -  Quarterdeck Corporation */
 ( MM_QUARTERDECK_LHWAVEIN     value(0)
 /* Quarterdeck L&H Codec Wave In */
 , MM_QUARTERDECK_LHWAVEOUT    value(1)
 /* Quarterdeck L&H Codec Wave Out */
 ) fixed bin (31);

 dcl /*  Product IDs for MM_RHETOREX    -  Rhetorex Inc    */
 ( MM_RHETOREX_WAVEIN          value(1)
 , MM_RHETOREX_WAVEOUT         value(2)
 ) fixed bin (31);

 dcl /*  Product IDs for MM_ROCKWELL    -  Rockwell International    */
 ( MM_VOICEMIXER               value(1)
 , ROCKWELL_WA1_WAVEIN         value(100)
 , ROCKWELL_WA1_WAVEOUT        value(101)
 , ROCKWELL_WA1_SYNTH          value(102)
 , ROCKWELL_WA1_MIXER          value(103)
 , ROCKWELL_WA1_MPU401_IN      value(104)
 , ROCKWELL_WA1_MPU401_OUT     value(105)
 , ROCKWELL_WA2_WAVEIN         value(200)
 , ROCKWELL_WA2_WAVEOUT        value(201)
 , ROCKWELL_WA2_SYNTH          value(202)
 , ROCKWELL_WA2_MIXER          value(203)
 , ROCKWELL_WA2_MPU401_IN      value(204)
 , ROCKWELL_WA2_MPU401_OUT     value(205)
 ) fixed bin (31);

 dcl /*  Product IDs for     MM_S3    -  S3    */
 ( MM_S3_WAVEOUT               value('1'xn)
 , MM_S3_WAVEIN                value('2'xn)
 , MM_S3_MIDIOUT               value('3'xn)
 , MM_S3_MIDIIN                value('4'xn)
 , MM_S3_FMSYNTH               value('5'xn)
 , MM_S3_MIXER                 value('6'xn)
 , MM_S3_AUX                   value('7'xn)
 ) fixed bin (31);

 dcl /*  Product IDs for     MM_SEERSYS    -  Seer Systems, Inc.    */
 ( MM_SEERSYS_SEERSYNTH        value(1)
 , MM_SEERSYS_SEERWAVE         value(2)
 , MM_SEERSYS_SEERMIX          value(3)
 ) fixed bin (31);

 dcl /*  Product IDs for     MM_SOFTSOUND    -  Softsound, Ltd.    */
 ( MM_SOFTSOUND_CODEC          value(1)
 ) fixed bin (31);

 dcl /*  Product IDs for     MM_SOUNDESIGNS - SounDesignS M.C.S. Ltd. */
 ( MM_SOUNDESIGNS_WAVEIN       value(1)
 , MM_SOUNDESIGNS_WAVEOUT      value(2)
 ) fixed bin (31);

 dcl /*  Product IDs for MM_SPECTRUM_SIGNAL_PROCESSING */
     /* - Spectrum Signal Processing, Inc.    */
 ( MM_SSP_SNDFESWAVEIN     value(1) /* Sound Festa Wave In Device */
 , MM_SSP_SNDFESWAVEOUT    value(2) /* Sound Festa Wave Out Device */
 , MM_SSP_SNDFESMIDIIN     value(3) /* Sound Festa MIDI In Device */
 , MM_SSP_SNDFESMIDIOUT    value(4) /* Sound Festa MIDI Out Device */
 , MM_SSP_SNDFESSYNTH      value(5) /* Sound Festa MIDI Synth Device */
 , MM_SSP_SNDFESMIX        value(6) /* Sound Festa Mixer Device */
 , MM_SSP_SNDFESAUX        value(7) /* Sound Festa Auxilliary Device */
 ) fixed bin (31);

 dcl /*  Product IDs for     MM_TDK    -  TDK Corporation    */
 ( MM_TDK_MW_MIDI_SYNTH        value(1)
 , MM_TDK_MW_MIDI_IN           value(2)
 , MM_TDK_MW_MIDI_OUT          value(3)
 , MM_TDK_MW_WAVE_IN           value(4)
 , MM_TDK_MW_WAVE_OUT          value(5)
 , MM_TDK_MW_AUX               value(6)
 , MM_TDK_MW_MIXER             value(10)
 , MM_TDK_MW_AUX_MASTER        value(100)
 , MM_TDK_MW_AUX_BASS          value(101)
 , MM_TDK_MW_AUX_TREBLE        value(102)
 , MM_TDK_MW_AUX_MIDI_VOL      value(103)
 , MM_TDK_MW_AUX_WAVE_VOL      value(104)
 , MM_TDK_MW_AUX_WAVE_RVB      value(105)
 , MM_TDK_MW_AUX_WAVE_CHR      value(106)
 , MM_TDK_MW_AUX_VOL           value(107)
 , MM_TDK_MW_AUX_RVB           value(108)
 , MM_TDK_MW_AUX_CHR           value(109)
 ) fixed bin (31);

 dcl /*  Product IDs for     MM_TURTLE_BEACH    -  Turtle Beach, Inc. */
 ( MM_TBS_TROPEZ_WAVEIN        value(37)
 , MM_TBS_TROPEZ_WAVEOUT       value(38)
 , MM_TBS_TROPEZ_AUX1          value(39)
 , MM_TBS_TROPEZ_AUX2          value(40)
 , MM_TBS_TROPEZ_LINE          value(41)
 ) fixed bin (31);

 dcl /*  Product IDs for     MM_VIENNASYS    -  Vienna Systems    */
 ( MM_VIENNASYS_TSP_WAVE_DRIVER value(1)
 ) fixed bin (31);

 dcl /*  Product IDs for     MM_VIONA    -  Viona Development GmbH    */
 ( MM_VIONA_QVINPCI_MIXER     value(1) /* Q-Motion PCI II/Bravado 2000*/
 , MM_VIONA_QVINPCI_WAVEIN    value(2)
 , MM_VIONAQVINPCI_WAVEOUT    value(3)
 , MM_VIONA_BUSTER_MIXER      value(4) /* Buster */
 , MM_VIONA_CINEMASTER_MIXER  value(5) /* Cinemaster */
 , MM_VIONA_CONCERTO_MIXER    value(6) /* Concerto */
 ) fixed bin (31);

 dcl /* Product IDs for     MM_WILDCAT    -  Wildcat Canyon Software  */
 ( MM_WILDCAT_AUTOSCOREMIDIIN  value(1) /* Autoscore */
 ) fixed bin (31);

 dcl /* Product IDs for     MM_WILLOWPOND -  Willow Pond Corporation */
 ( MM_WILLOWPOND_FMSYNTH_STEREO  value(20)
 , MM_WILLOWPOND_SNDPORT_WAVEIN  value(100)
 , MM_WILLOWPOND_SNDPORT_WAVEOUT value(101)
 , MM_WILLOWPOND_SNDPORT_MIXER   value(102)
 , MM_WILLOWPOND_SNDPORT_AUX     value(103)
 , MM_WILLOWPOND_PH_WAVEIN       value(104)
 , MM_WILLOWPOND_PH_WAVEOUT      value(105)
 , MM_WILLOWPOND_PH_MIXER        value(106)
 , MM_WILLOWPOND_PH_AUX          value(107)
 ) fixed bin (31);

 dcl /* Product IDs for     MM_WORKBIT    -  Workbit Corporation    */
 ( MM_WORKBIT_MIXER            value(1) /* Harmony Mixer */
 , MM_WORKBIT_WAVEOUT          value(2) /* Harmony Mixer */
 , MM_WORKBIT_WAVEIN           value(3) /* Harmony Mixer */
 , MM_WORKBIT_MIDIIN           value(4) /* Harmony Mixer */
 , MM_WORKBIT_MIDIOUT          value(5) /* Harmony Mixer */
 , MM_WORKBIT_FMSYNTH          value(6) /* Harmony Mixer */
 , MM_WORKBIT_AUX              value(7) /* Harmony Mixer */
 , MM_WORKBIT_JOYSTICK         value(8)
 ) fixed bin (31);

 dcl /*  Product IDs for     MM_FRAUNHOFER_IIS -  Fraunhofer */
 ( MM_FHGIIS_MPEGLAYER3        value(10)
 ) fixed bin (31);

 %end; /* !NOMMIDS */

 /* **************************************************************** */

 /* INFO LIST CHUNKS (from the Multimedia Programmer's Reference */
 /*                   plus new ones)                             */

 dcl RIFFINFO_IARL type FOURCC value(mmioFOURCC('I', 'A', 'R', 'L'));
    /*Archival location  */
 dcl RIFFINFO_IART type FOURCC value(mmioFOURCC('I', 'A', 'R', 'T'));
    /*Artist  */
 dcl RIFFINFO_ICMS type FOURCC value(mmioFOURCC('I', 'C', 'M', 'S'));
     /*Commissioned  */
 dcl RIFFINFO_ICMT type FOURCC value(mmioFOURCC('I', 'C', 'M', 'T'));
    /*Comments  */
 dcl RIFFINFO_ICOP type FOURCC value(mmioFOURCC('I', 'C', 'O', 'P'));
     /*Copyright  */
 dcl RIFFINFO_ICRD type FOURCC value(mmioFOURCC('I', 'C', 'R', 'D'));
     /*Creation date of subject  */
 dcl RIFFINFO_ICRP type FOURCC value(mmioFOURCC('I', 'C', 'R', 'P'));
    /*Cropped  */
 dcl RIFFINFO_IDIM type FOURCC value(mmioFOURCC('I', 'D', 'I', 'M'));
    /*Dimensions  */
 dcl RIFFINFO_IDPI type FOURCC value(mmioFOURCC('I', 'D', 'P', 'I'));
    /*Dots per inch  */
 dcl RIFFINFO_IENG type FOURCC value(mmioFOURCC('I', 'E', 'N', 'G'));
    /*Engineer  */
 dcl RIFFINFO_IGNR type FOURCC value(mmioFOURCC('I', 'G', 'N', 'R'));
    /*Genre  */
 dcl RIFFINFO_IKEY type FOURCC value(mmioFOURCC('I', 'K', 'E', 'Y'));
    /*Keywords  */
 dcl RIFFINFO_ILGT type FOURCC value(mmioFOURCC('I', 'L', 'G', 'T'));
    /*Lightness settings  */
 dcl RIFFINFO_IMED type FOURCC value(mmioFOURCC('I', 'M', 'E', 'D'));
    /*Medium  */
 dcl RIFFINFO_INAM type FOURCC value(mmioFOURCC('I', 'N', 'A', 'M'));
    /*Name of subject  */
 dcl RIFFINFO_IPLT type FOURCC value(mmioFOURCC('I', 'P', 'L', 'T'));
    /*Palette Settings. No. of colors requested.   */
 dcl RIFFINFO_IPRD type FOURCC value(mmioFOURCC('I', 'P', 'R', 'D'));
    /*Product  */
 dcl RIFFINFO_ISBJ type FOURCC value(mmioFOURCC('I', 'S', 'B', 'J'));
    /*Subject description  */
 dcl RIFFINFO_ISFT type FOURCC value(mmioFOURCC('I', 'S', 'F', 'T'));
    /*Software. Name of package used to create file.  */
 dcl RIFFINFO_ISHP type FOURCC value(mmioFOURCC('I', 'S', 'H', 'P'));
    /*Sharpness.  */
 dcl RIFFINFO_ISRC type FOURCC value(mmioFOURCC('I', 'S', 'R', 'C'));
    /*Source.   */
 dcl RIFFINFO_ISRF type FOURCC value(mmioFOURCC('I', 'S', 'R', 'F'));
    /*Source Form. ie slide, paper  */
 dcl RIFFINFO_ITCH type FOURCC value(mmioFOURCC('I', 'T', 'C', 'H'));
    /*Technician who digitized the subject.  */

 /* New INFO Chunks as of August 30, 1993: */
 dcl RIFFINFO_ISMP type FOURCC value(mmioFOURCC('I', 'S', 'M', 'P'));
 /* SMPTE time code */
 /* ISMP: SMPTE time code of digitization start point expressed as a  */
 /* NULL terminated text string "HH:MM:SS:FF". If performing MCI      */
 /* capture in AVICAP, this chunk will be automatically set based on  */
 /* the MCI start time.                                               */
 dcl RIFFINFO_IDIT type FOURCC value(mmioFOURCC('I', 'D', 'I', 'T'));
 /* Digitization Time */
 /* IDIT: "Digitization Time" Specifies the time and date that the    */
 /* digitization commenced. The digitization time is contained in an  */
 /* ASCII string which contains exactly 26 characters and is in the   */
 /* format "Wed Jan 02 02:03:55 1990\n\0". The ctime(), asctime(),    */
 /* functions can be used to create strings in this format.           */
 /* This chunk is automatically added to the capture file based on    */
 /* the current system time at the moment capture is initiated.       */

 /* Template line for new additions                                   */
 /* dcl RIFFINFO_I type FOURCC value(mmioFOURCC ('I', '', '', ''))    */

 /* ***************************************************************** */

 %dcl NONEWWAVE char ext;
 %if NONEWWAVE = '' %then %do;

 dcl /* WAVE form wFormatTag IDs */
 ( WAVE_FORMAT_UNKNOWN               value('0000'xn)
   /* Microsoft Corporation  */
 , WAVE_FORMAT_ADPCM                 value('0002'xn)
   /* Microsoft Corporation  */
 , WAVE_FORMAT_IEEE_FLOAT            value('0003'xn)
   /* Microsoft Corporation IEEE754: range (+1, -1] */
   /* 32-bit/64-bit format as defined by MSVC++ float/double type */
 , WAVE_FORMAT_IBM_CVSD              value('0005'xn)
   /* IBM Corporation  */
 , WAVE_FORMAT_ALAW                  value('0006'xn)
   /* Microsoft Corporation  */
 , WAVE_FORMAT_MULAW                 value('0007'xn)
   /* Microsoft Corporation  */
 , WAVE_FORMAT_OKI_ADPCM             value('0010'xn)
   /* OKI  */
 , WAVE_FORMAT_DVI_ADPCM             value('0011'xn)
   /* Intel Corporation  */
 , WAVE_FORMAT_IMA_ADPCM             value(WAVE_FORMAT_DVI_ADPCM)
   /* Intel Corporation  */
 , WAVE_FORMAT_MEDIASPACE_ADPCM      value('0012'xn)
   /* Videologic  */
 , WAVE_FORMAT_SIERRA_ADPCM          value('0013'xn)
   /* Sierra Semiconductor Corp  */
 , WAVE_FORMAT_G723_ADPCM            value('0014'xn)
   /* Antex Electronics Corporation  */
 , WAVE_FORMAT_DIGISTD               value('0015'xn)
   /* DSP Solutions, Inc.  */
 , WAVE_FORMAT_DIGIFIX               value('0016'xn)
   /* DSP Solutions, Inc.  */
 , WAVE_FORMAT_DIALOGIC_OKI_ADPCM    value('0017'xn)
   /* Dialogic Corporation  */
 , WAVE_FORMAT_MEDIAVISION_ADPCM     value('0018'xn)
   /* Media Vision, Inc. */
 , WAVE_FORMAT_YAMAHA_ADPCM          value('0020'xn)
   /* Yamaha Corporation of America  */
 , WAVE_FORMAT_SONARC                value('0021'xn)
   /* Speech Compression  */
 , WAVE_FORMAT_DSPGROUP_TRUESPEECH   value('0022'xn)
   /* DSP Group, Inc  */
 , WAVE_FORMAT_ECHOSC1               value('0023'xn)
   /* Echo Speech Corporation  */
 , WAVE_FORMAT_AUDIOFILE_AF36        value('0024'xn)
   /*    */
 , WAVE_FORMAT_APTX                  value('0025'xn)
   /*  Audio Processing Technology  */
 , WAVE_FORMAT_AUDIOFILE_AF10        value('0026'xn)
   /*    */
 , WAVE_FORMAT_DOLBY_AC2             value('0030'xn)
   /* Dolby Laboratories  */
 , WAVE_FORMAT_GSM610                value('0031'xn)
   /* Microsoft Corporation  */
 , WAVE_FORMAT_MSNAUDIO              value('0032'xn)
   /* Microsoft Corporation  */
 , WAVE_FORMAT_ANTEX_ADPCME          value('0033'xn)
   /* Antex Electronics Corporation  */
 , WAVE_FORMAT_CONTROL_RES_VQLPC     value('0034'xn)
   /* Control Resources Limited  */
 , WAVE_FORMAT_DIGIREAL              value('0035'xn)
   /* DSP Solutions, Inc.  */
 , WAVE_FORMAT_DIGIADPCM             value('0036'xn)
   /*  DSP Solutions, Inc.  */
 , WAVE_FORMAT_CONTROL_RES_CR10      value('0037'xn)
   /*  Control Resources Limited  */
 , WAVE_FORMAT_NMS_VBXADPCM          value('0038'xn)
   /*  Natural MicroSystems  */
 , WAVE_FORMAT_CS_IMAADPCM           value('0039'xn)
   /* Crystal Semiconductor IMA ADPCM */
 , WAVE_FORMAT_ECHOSC3               value('003A'xn)
   /* Echo Speech Corporation */
 , WAVE_FORMAT_ROCKWELL_ADPCM        value('003B'xn)
   /* Rockwell International */
 , WAVE_FORMAT_ROCKWELL_DIGITALK     value('003C'xn)
   /* Rockwell International */
 , WAVE_FORMAT_XEBEC                 value('003D'xn)
   /* Xebec Multimedia Solutions Limited */
 , WAVE_FORMAT_G721_ADPCM            value('0040'xn)
   /* Antex Electronics Corporation  */
 , WAVE_FORMAT_G728_CELP             value('0041'xn)
   /* Antex Electronics Corporation  */
 , WAVE_FORMAT_MPEG                  value('0050'xn)
   /* Microsoft Corporation  */
 , WAVE_FORMAT_MPEGLAYER3            value('0055'xn)
   /* ISO/MPEG Layer3 Format Tag */
 , WAVE_FORMAT_CIRRUS                value('0060'xn)
   /* Cirrus Logic  */
 , WAVE_FORMAT_ESPCM                 value('0061'xn)
   /* ESS Technology  */
 , WAVE_FORMAT_VOXWARE               value('0062'xn)
   /* Voxware Inc  */
 , WAVEFORMAT_CANOPUS_ATRAC          value('0063'xn)
   /* Canopus, co., Ltd.  */
 , WAVE_FORMAT_G726_ADPCM            value('0064'xn)
   /* APICOM  */
 , WAVE_FORMAT_G722_ADPCM            value('0065'xn)
   /* APICOM      */
 , WAVE_FORMAT_DSAT                  value('0066'xn)
   /* Microsoft Corporation  */
 , WAVE_FORMAT_DSAT_DISPLAY          value('0067'xn)
   /* Microsoft Corporation  */
 , WAVE_FORMAT_SOFTSOUND             value('0080'xn)
   /* Softsound, Ltd.      */
 , WAVE_FORMAT_RHETOREX_ADPCM        value('0100'xn)
   /* Rhetorex Inc  */
 , WAVE_FORMAT_CREATIVE_ADPCM        value('0200'xn)
   /* Creative Labs, Inc  */
 , WAVE_FORMAT_CREATIVE_FASTSPEECH8  value('0202'xn)
   /* Creative Labs, Inc  */
 , WAVE_FORMAT_CREATIVE_FASTSPEECH10 value('0203'xn)
   /* Creative Labs, Inc  */
 , WAVE_FORMAT_QUARTERDECK           value('0220'xn)
   /* Quarterdeck Corporation  */
 , WAVE_FORMAT_FM_TOWNS_SND          value('0300'xn)
   /* Fujitsu Corp.  */
 , WAVE_FORMAT_BTV_DIGITAL           value('0400'xn)
   /* Brooktree Corporation  */
 , WAVE_FORMAT_OLIGSM                value('1000'xn)
   /* Ing C. Olivetti & C., S.p.A.  */
 , WAVE_FORMAT_OLIADPCM              value('1001'xn)
   /* Ing C. Olivetti & C., S.p.A.  */
 , WAVE_FORMAT_OLICELP               value('1002'xn)
   /* Ing C. Olivetti & C., S.p.A.  */
 , WAVE_FORMAT_OLISBC                value('1003'xn)
   /* Ing C. Olivetti & C., S.p.A.  */
 , WAVE_FORMAT_OLIOPR                value('1004'xn)
   /* Ing C. Olivetti & C., S.p.A.  */
 , WAVE_FORMAT_LH_CODEC              value('1100'xn)
   /* Lernout & Hauspie  */
 , WAVE_FORMAT_NORRIS                value('1400'xn)
   /* Norris Communications, Inc.  */

   /* the WAVE_FORMAT_DEVELOPMENT format tag can be used during the */
   /* development phase of a new wave format. Before shipping, you  */
   /* MUST acquire an official format tag from Microsoft.           */
 , WAVE_FORMAT_DEVELOPMENT value('FFFF'xn)
 ) type WORD;

 %end;
 /* NONEWWAVE */

 %dcl #WAVE_FORMAT_PCM char ext;
 %if #WAVE_FORMAT_PCM = '' %then %do;
 %#WAVE_FORMAT_PCM = 'Y';
 /* general waveform format structure   */
 /* (information common to all formats) */
 define structure
   1 WAVEFORMAT,
     2 wFormatTag      type WORD, /* format type */
     2 nChannels       type WORD,
                       /* number of channels (i.e. mono, stereo...) */
     2 nSamplesPerSec  type DWORD,/* sample rate */
     2 nAvgBytesPerSec type DWORD,/* for buffer estimation */
     2 nBlockAlign     type WORD; /* block size of data */
 define alias  PWAVEFORMAT handle WAVEFORMAT;
 define alias NPWAVEFORMAT handle WAVEFORMAT;
 define alias LPWAVEFORMAT handle WAVEFORMAT;

 /* flags for wFormatTag field of WAVEFORMAT */
 dcl WAVE_FORMAT_PCM   fixed bin(31) value(1);

 /* specific waveform format structure for PCM data */
 define structure
   1 PCMWAVEFORMAT,
     2 wf              type WAVEFORMAT,
     2 wBitsPerSample  type WORD;
 define alias  PPCMWAVEFORMAT handle PCMWAVEFORMAT;
 define alias NPPCMWAVEFORMAT handle PCMWAVEFORMAT;
 define alias LPPCMWAVEFORMAT handle PCMWAVEFORMAT;

 %end; /* #WAVE_FORMAT_PCM */

 /* general extended waveform format structure */
 /* Use this for all NON PCM formats           */
 /* (information common to all formats)        */
 %dcl #WAVEFORMATEX_ char ext;
 %if #WAVEFORMATEX_ = '' %then %do;
 %#WAVEFORMATEX_ = 'Y';
 define structure
   1 WAVEFORMATEX,
     2 wFormatTag      type WORD,/* format type */
     2 nChannels       type WORD,
                       /* number of channels (i.e. mono, stereo...) */
     2 nSamplesPerSec  type DWORD,/* sample rate */
     2 nAvgBytesPerSec type DWORD,/* for buffer estimation */
     2 nBlockAlign     type WORD, /* block size of data */
     2 wBitsPerSample  type WORD,
                       /* Number of bits per sample of mono data */
     2 cbSize          type WORD; /* The count in bytes of the size of*/
                                  /* extra information (after cbSize) */
 define alias  PWAVEFORMATEX handle WAVEFORMATEX;
 define alias NPWAVEFORMATEX handle WAVEFORMATEX;
 define alias LPWAVEFORMATEX handle WAVEFORMATEX;
 %end; /* _WAVEFORMATEX_ */

 %dcl NONEWWAVE char ext;
 %if NONEWWAVE = '' %then %do;

 /* Define data for MS ADPCM */

 define structure
   1 ADPCMCOEFSET,
     2 iCoef1 fixed bin(15),
     2 iCoef2 fixed bin(15);
 define alias  PADPCMCOEFSET handle ADPCMCOEFSET;
 define alias NPADPCMCOEFSET handle ADPCMCOEFSET;
 define alias LPADPCMCOEFSET handle ADPCMCOEFSET;

 define structure
   1 ADPCMWAVEFORMAT,
     2 wfx              type WAVEFORMATEX,
     2 wSamplesPerBlock type WORD,
     2 wNumCoef         type WORD,
     2 aCoef (1)        type ADPCMCOEFSET; /* actual size is wNumCoef */
 define alias  PADPCMWAVEFORMAT handle ADPCMWAVEFORMAT;
 define alias NPADPCMWAVEFORMAT handle ADPCMWAVEFORMAT;
 define alias LPADPCMWAVEFORMAT handle ADPCMWAVEFORMAT;

 /* Intel's DVI ADPCM structure definitions */
 /*  for WAVE_FORMAT_DVI_ADPCM   (0x0011) */

 define structure
   1 DVIADPCMWAVEFORMAT,
     2 wfx              type WAVEFORMATEX,
     2 wSamplesPerBlock type WORD;
 define alias  PDVIADPCMWAVEFORMAT handle DVIADPCMWAVEFORMAT;
 define alias NPDVIADPCMWAVEFORMAT handle DVIADPCMWAVEFORMAT;
 define alias LPDVIADPCMWAVEFORMAT handle DVIADPCMWAVEFORMAT;

 /* IMA endorsed ADPCM structure definitions -- note that this is */
 /* exactly the same format as Intel's DVI ADPCM. */
 /*  for WAVE_FORMAT_IMA_ADPCM   (0x0011) */

 define structure
   1 IMAADPCMWAVEFORMAT,
     2 wfx              type WAVEFORMATEX,
     2 wSamplesPerBlock type WORD;
 define alias  PIMAADPCMWAVEFORMAT handle IMAADPCMWAVEFORMAT;
 define alias NPIMAADPCMWAVEFORMAT handle IMAADPCMWAVEFORMAT;
 define alias LPIMAADPCMWAVEFORMAT handle IMAADPCMWAVEFORMAT;

 /* VideoLogic's Media Space ADPCM Structure definitions */
 /*  for  WAVE_FORMAT_MEDIASPACE_ADPCM    (0x0012) */

 define structure
   1 MEDIASPACEADPCMWAVEFORMAT,
     2 wfx       type WAVEFORMATEX,
     2 wRevision type WORD;
 define alias  PMEDIASPACEADPCMWAVEFORMAT
        handle MEDIASPACEADPCMWAVEFORMAT;
 define alias NPMEDIASPACEADPCMWAVEFORMAT
        handle MEDIASPACEADPCMWAVEFORMAT;
 define alias LPMEDIASPACEADPCMWAVEFORMAT
        handle MEDIASPACEADPCMWAVEFORMAT;

 /* Sierra Semiconductor */
 /*  for WAVE_FORMAT_SIERRA_ADPCM   (0x0013) */

 define structure
   1 SIERRAADPCMWAVEFORMAT,
     2 wfx       type WAVEFORMATEX,
     2 wRevision type WORD;
 define alias  PSIERRAADPCMWAVEFORMAT handle SIERRAADPCMWAVEFORMAT;
 define alias NPSIERRAADPCMWAVEFORMAT handle SIERRAADPCMWAVEFORMAT;
 define alias LPSIERRAADPCMWAVEFORMAT handle SIERRAADPCMWAVEFORMAT;

 /* Antex Electronics  structure definitions */
 /*  for WAVE_FORMAT_G723_ADPCM   (0x0014) */

 define structure
   1 G723_ADPCMWAVEFORMAT,
     2 wfx           type WAVEFORMATEX,
     2 cbExtraSize   type WORD,
     2 nAuxBlockSize type WORD;
 define alias  PG723_ADPCMWAVEFORMAT handle G723_ADPCMWAVEFORMAT;
 define alias NPG723_ADPCMWAVEFORMAT handle G723_ADPCMWAVEFORMAT;
 define alias LPG723_ADPCMWAVEFORMAT handle G723_ADPCMWAVEFORMAT;

 /* DSP Solutions (formerly DIGISPEECH) structure definitions */
 /*  for WAVE_FORMAT_DIGISTD   (0x0015) */

 define structure
   1 DIGISTDWAVEFORMAT,
     2 wfx type WAVEFORMATEX;
 define alias  PDIGISTDWAVEFORMAT handle DIGISTDWAVEFORMAT;
 define alias NPDIGISTDWAVEFORMAT handle DIGISTDWAVEFORMAT;
 define alias LPDIGISTDWAVEFORMAT handle DIGISTDWAVEFORMAT;

 /* DSP Solutions (formerly DIGISPEECH) structure definitions */
 /*  for WAVE_FORMAT_DIGIFIX   (0x0016) */

 define structure
   1 DIGIFIXWAVEFORMAT,
     2 wfx type WAVEFORMATEX;
 define alias  PDIGIFIXWAVEFORMAT handle DIGIFIXWAVEFORMAT;
 define alias NPDIGIFIXWAVEFORMAT handle DIGIFIXWAVEFORMAT;
 define alias LPDIGIFIXWAVEFORMAT handle DIGIFIXWAVEFORMAT;

 /* Dialogic Corporation */
 /*  WAVEFORMAT_DIALOGIC_OKI_ADPCM   (0x0017) */

 define structure
   1 DIALOGICOKIADPCMWAVEFORMAT,
     2 ewf type WAVEFORMATEX;
 define alias  PDIALOGICOKIADPCMWAVEFORMAT
        handle DIALOGICOKIADPCMWAVEFORMAT;
 define alias NPDIALOGICOKIADPCMWAVEFORMAT
        handle DIALOGICOKIADPCMWAVEFORMAT;
 define alias LPDIALOGICOKIADPCMWAVEFORMAT
        handle DIALOGICOKIADPCMWAVEFORMAT;

 /* Yamaha Compression's ADPCM structure definitions */
 /*  for WAVE_FORMAT_YAMAHA_ADPCM   (0x0020) */

 define structure
   1 YAMAHA_ADPCMWAVEFORMAT,
     2 wfx type WAVEFORMATEX;
 define alias  PYAMAHA_ADPCMWAVEFORMAT handle YAMAHA_ADPCMWAVEFORMAT;
 define alias NPYAMAHA_ADPCMWAVEFORMAT handle YAMAHA_ADPCMWAVEFORMAT;
 define alias LPYAMAHA_ADPCMWAVEFORMAT handle YAMAHA_ADPCMWAVEFORMAT;

 /* Speech Compression's Sonarc structure definitions */
 /*  for WAVE_FORMAT_SONARC   (0x0021) */

 define structure
   1 SONARCWAVEFORMAT,
     2 wfx       type WAVEFORMATEX,
     2 wCompType type WORD;
 define alias  PSONARCWAVEFORMAT handle SONARCWAVEFORMAT;
 define alias NPSONARCWAVEFORMAT handle SONARCWAVEFORMAT;
 define alias LPSONARCWAVEFORMAT handle SONARCWAVEFORMAT;

 /* DSP Groups's TRUESPEECH structure definitions */
 /*  for WAVE_FORMAT_DSPGROUP_TRUESPEECH   (0x0022) */

 define structure
   1 TRUESPEECHWAVEFORMAT,
     2 wfx              type WAVEFORMATEX,
     2 wRevision        type WORD,
     2 nSamplesPerBlock type WORD,
     2 abReserved (28)  type BYTE;
 define alias  PTRUESPEECHWAVEFORMAT handle TRUESPEECHWAVEFORMAT;
 define alias NPTRUESPEECHWAVEFORMAT handle TRUESPEECHWAVEFORMAT;
 define alias LPTRUESPEECHWAVEFORMAT handle TRUESPEECHWAVEFORMAT;

 /* Echo Speech Corp structure definitions */
 /*  for WAVE_FORMAT_ECHOSC1   (0x0023) */

 define structure
   1 ECHOSC1WAVEFORMAT,
     2 wfx type WAVEFORMATEX;
 define alias  PECHOSC1WAVEFORMAT handle ECHOSC1WAVEFORMAT;
 define alias NPECHOSC1WAVEFORMAT handle ECHOSC1WAVEFORMAT;
 define alias LPECHOSC1WAVEFORMAT handle ECHOSC1WAVEFORMAT;

 /* Audiofile Inc.structure definitions */
 /*  for WAVE_FORMAT_AUDIOFILE_AF36   (0x0024) */

 define structure
   1 AUDIOFILE_AF36WAVEFORMAT,
     2 wfx type WAVEFORMATEX;
 define alias  PAUDIOFILE_AF36WAVEFORMAT
        handle AUDIOFILE_AF36WAVEFORMAT;
 define alias NPAUDIOFILE_AF36WAVEFORMAT
        handle AUDIOFILE_AF36WAVEFORMAT;
 define alias LPAUDIOFILE_AF36WAVEFORMAT
        handle AUDIOFILE_AF36WAVEFORMAT;

 /* Audio Processing Technology structure definitions */
 /*  for WAVE_FORMAT_APTX   (0x0025) */

 define structure
   1 APTXWAVEFORMAT,
     2 wfx type WAVEFORMATEX;
 define alias  PAPTXWAVEFORMAT handle APTXWAVEFORMAT;
 define alias NPAPTXWAVEFORMAT handle APTXWAVEFORMAT;
 define alias LPAPTXWAVEFORMAT handle APTXWAVEFORMAT;

 /* Audiofile Inc.structure definitions */
 /*  for WAVE_FORMAT_AUDIOFILE_AF10   (0x0026) */

 define structure
   1 AUDIOFILE_AF10WAVEFORMAT,
     2 wfx type WAVEFORMATEX;
 define alias  PAUDIOFILE_AF10WAVEFORMAT
        handle  AUDIOFILE_AF10WAVEFORMAT;
 define alias NPAUDIOFILE_AF10WAVEFORMAT
        handle  AUDIOFILE_AF10WAVEFORMAT;
 define alias LPAUDIOFILE_AF10WAVEFORMAT
        handle  AUDIOFILE_AF10WAVEFORMAT;

 /* Dolby's AC-2 wave format structure definition */
 /*  WAVE_FORMAT_DOLBY_AC2    (0x0030)*/

 define structure
   1 DOLBYAC2WAVEFORMAT,
     2 wfx          type WAVEFORMATEX,
     2 nAuxBitsCode type WORD;

 /* Microsoft's */
 /*  WAVE_FORMAT_GSM 610           0x0031 */

 define structure
   1 GSM610WAVEFORMAT,
     2 wfx              type WAVEFORMATEX,
     2 wSamplesPerBlock type WORD;
 define alias  PGSM610WAVEFORMAT handle GSM610WAVEFORMAT;
 define alias NPGSM610WAVEFORMAT handle GSM610WAVEFORMAT;
 define alias LPGSM610WAVEFORMAT handle GSM610WAVEFORMAT;

 /* Antex Electronics Corp */
 /*  for WAVE_FORMAT_ADPCME                  (0x0033) */

 define structure
   1 ADPCMEWAVEFORMAT,
     2 wfx              type WAVEFORMATEX,
     2 wSamplesPerBlock type WORD;
 define alias  PADPCMEWAVEFORMAT handle ADPCMEWAVEFORMAT;
 define alias NPADPCMEWAVEFORMAT handle ADPCMEWAVEFORMAT;
 define alias LPADPCMEWAVEFORMAT handle ADPCMEWAVEFORMAT;

 /* Control Resources Limited */
 /*  WAVE_FORMAT_CONTROL_RES_VQLPC                 0x0034 */

 define structure
   1 CONTRESVQLPCWAVEFORMAT,
     2 wfx              type WAVEFORMATEX,
     2 wSamplesPerBlock type WORD;
 define alias  PCONTRESVQLPCWAVEFORMAT handle CONTRESVQLPCWAVEFORMAT;
 define alias NPCONTRESVQLPCWAVEFORMAT handle CONTRESVQLPCWAVEFORMAT;
 define alias LPCONTRESVQLPCWAVEFORMAT handle CONTRESVQLPCWAVEFORMAT;

 /*  for WAVE_FORMAT_DIGIREAL                   (0x0035) */

 define structure
   1 DIGIREALWAVEFORMAT,
     2 wfx              type WAVEFORMATEX,
     2 wSamplesPerBlock type WORD;
 define alias  PDIGIREALWAVEFORMAT handle DIGIREALWAVEFORMAT;
 define alias NPDIGIREALWAVEFORMAT handle DIGIREALWAVEFORMAT;
 define alias LPDIGIREALWAVEFORMAT handle DIGIREALWAVEFORMAT;

 /* DSP Solutions */
 /*  for WAVE_FORMAT_DIGIADPCM   (0x0036) */

 define structure
   1 DIGIADPCMWAVEFORMAT,
     2 wfx              type WAVEFORMATEX,
     2 wSamplesPerBlock type WORD;
 define alias  PDIGIADPCMWAVEFORMAT handle DIGIADPCMWAVEFORMAT;
 define alias NPDIGIADPCMWAVEFORMAT handle DIGIADPCMWAVEFORMAT;
 define alias LPDIGIADPCMWAVEFORMAT handle DIGIADPCMWAVEFORMAT;

 /* Control Resources Limited */
 /*  WAVE_FORMAT_CONTROL_RES_CR10          0x0037 */

 define structure
   1 CONTRESCR10WAVEFORMAT,
     2 wfx              type WAVEFORMATEX,
     2 wSamplesPerBlock type WORD;
 define alias  PCONTRESCR10WAVEFORMAT handle CONTRESCR10WAVEFORMAT;
 define alias NPCONTRESCR10WAVEFORMAT handle CONTRESCR10WAVEFORMAT;
 define alias LPCONTRESCR10WAVEFORMAT handle CONTRESCR10WAVEFORMAT;

 /* Natural Microsystems */
 /*  for WAVE_FORMAT_NMS_VBXADPCM   (0x0038) */

 define structure
   1 NMS_VBXADPCMWAVEFORMAT,
     2 wfx              type WAVEFORMATEX,
     2 wSamplesPerBlock type WORD;
 define alias  PNMS_VBXADPCMWAVEFORMAT handle NMS_VBXADPCMWAVEFORMAT;
 define alias NPNMS_VBXADPCMWAVEFORMAT handle NMS_VBXADPCMWAVEFORMAT;
 define alias LPNMS_VBXADPCMWAVEFORMAT handle NMS_VBXADPCMWAVEFORMAT;


 /* Antex Electronics  structure definitions */
 /*  for WAVE_FORMAT_G721_ADPCM   (0x0040) */

 define structure
   1 G721_ADPCMWAVEFORMAT,
     2 wfx           type WAVEFORMATEX,
     2 nAuxBlockSize type WORD;
 define alias  PG721_ADPCMWAVEFORMAT handle G721_ADPCMWAVEFORMAT;
 define alias NPG721_ADPCMWAVEFORMAT handle G721_ADPCMWAVEFORMAT;
 define alias LPG721_ADPCMWAVEFORMAT handle G721_ADPCMWAVEFORMAT;

 /* Microsoft MPEG audio WAV definition */
 /*  MPEG-1 audio wave format (audio layer only).   (0x0050)   */
 define structure
   1 MPEG1WAVEFORMAT,
     2 wfx           type WAVEFORMATEX,
     2 fwHeadLayer   type WORD,
     2 dwHeadBitrate type DWORD,
     2 fwHeadMode    type WORD,
     2 fwHeadModeExt type WORD,
     2 wHeadEmphasis type WORD,
     2 fwHeadFlags   type WORD,
     2 dwPTSLow      type DWORD,
     2 dwPTSHigh     type DWORD;
 define alias  PMPEG1WAVEFORMAT handle MPEG1WAVEFORMAT;
 define alias NPMPEG1WAVEFORMAT handle MPEG1WAVEFORMAT;
 define alias LPMPEG1WAVEFORMAT handle MPEG1WAVEFORMAT;

 dcl ACM_MPEG_LAYER1        fixed bin(15) value('0001'xn);
 dcl ACM_MPEG_LAYER2        fixed bin(15) value('0002'xn);
 dcl ACM_MPEG_LAYER3        fixed bin(15) value('0004'xn);
 dcl ACM_MPEG_STEREO        fixed bin(15) value('0001'xn);
 dcl ACM_MPEG_JOINTSTEREO   fixed bin(15) value('0002'xn);
 dcl ACM_MPEG_DUALCHANNEL   fixed bin(15) value('0004'xn);
 dcl ACM_MPEG_SINGLECHANNEL fixed bin(15) value('0008'xn);
 dcl ACM_MPEG_PRIVATEBIT    fixed bin(15) value('0001'xn);
 dcl ACM_MPEG_COPYRIGHT     fixed bin(15) value('0002'xn);
 dcl ACM_MPEG_ORIGINALHOME  fixed bin(15) value('0004'xn);
 dcl ACM_MPEG_PROTECTIONBIT fixed bin(15) value('0008'xn);
 dcl ACM_MPEG_ID_MPEG1      fixed bin(15) value('0010'xn);


 /* MPEG Layer3 WAVEFORMATEX structure */
 /*  for WAVE_FORMAT_MPEGLAYER3 (0x0055) */

 dcl MPEGLAYER3_WFX_EXTRA_BYTES fixed bin(31) value(12);

 /* WAVE_FORMAT_MPEGLAYER3 format structure */

 define structure
   1 MPEGLAYER3WAVEFORMAT,
     2 wfx             type WAVEFORMATEX,
     2 wID             type WORD,
     2 fdwFlags        type DWORD,
     2 nBlockSize      type WORD,
     2 nFramesPerBlock type WORD,
     2 nCodecDelay     type WORD;
 define alias  PMPEGLAYER3WAVEFORMAT handle MPEGLAYER3WAVEFORMAT;
 define alias NPMPEGLAYER3WAVEFORMAT handle MPEGLAYER3WAVEFORMAT;
 define alias LPMPEGLAYER3WAVEFORMAT handle MPEGLAYER3WAVEFORMAT;

 /* ================================================================= */

 dcl MPEGLAYER3_ID_UNKNOWN           fixed bin(31) value(0);
 dcl MPEGLAYER3_ID_MPEG              fixed bin(31) value(1);
 dcl MPEGLAYER3_ID_CONSTANTFRAMESIZE fixed bin(31) value(2);

 dcl MPEGLAYER3_FLAG_PADDING_ISO     type DWORD value('00000000'xu);
 dcl MPEGLAYER3_FLAG_PADDING_ON      type DWORD value('00000001'xu);
 dcl MPEGLAYER3_FLAG_PADDING_OFF     type DWORD value('00000002'xu);

 /* Creative's ADPCM structure definitions */
 /*  for WAVE_FORMAT_CREATIVE_ADPCM   (0x0200) */

 define structure
   1 CREATIVEADPCMWAVEFORMAT,
     2 wfx       type WAVEFORMATEX,
     2 wRevision type WORD;

 define alias  PCREATIVEADPCMWAVEFORMAT handle CREATIVEADPCMWAVEFORMAT;
 define alias NPCREATIVEADPCMWAVEFORMAT handle CREATIVEADPCMWAVEFORMAT;
 define alias LPCREATIVEADPCMWAVEFORMAT handle CREATIVEADPCMWAVEFORMAT;


 /* Creative FASTSPEECH */
 /*  WAVEFORMAT_CREATIVE_FASTSPEECH8   (0x0202) */

 define structure
   1 CREATIVEFASTSPEECH8WAVEFORMAT,
     2 wfx       type WAVEFORMATEX,
     2 wRevision type WORD;
 define alias  PCREATIVEFASTSPEECH8WAVEFORMAT
        handle CREATIVEFASTSPEECH8WAVEFORMAT;
 define alias NPCREATIVEFASTSPEECH8WAVEFORMAT
        handle CREATIVEFASTSPEECH8WAVEFORMAT;
 define alias LPCREATIVEFASTSPEECH8WAVEFORMAT
        handle CREATIVEFASTSPEECH8WAVEFORMAT;

 /* Creative FASTSPEECH */
 /*  WAVEFORMAT_CREATIVE_FASTSPEECH10   (0x0203) */

 define structure
   1 CREATIVEFASTSPEECH10WAVEFORMAT,
     2 wfx       type WAVEFORMATEX,
     2 wRevision type WORD;
 define alias  PCREATIVEFASTSPEECH10WAVEFORMAT
        handle CREATIVEFASTSPEECH10WAVEFORMAT;
 define alias NPCREATIVEFASTSPEECH10WAVEFORMAT
        handle CREATIVEFASTSPEECH10WAVEFORMAT;
 define alias LPCREATIVEFASTSPEECH10WAVEFORMAT
        handle CREATIVEFASTSPEECH10WAVEFORMAT;

 /* Fujitsu FM Towns 'SND' structure */
 /*  for WAVE_FORMAT_FMMTOWNS_SND   (0x0300) */

 define structure
   1 FMTOWNS_SND_WAVEFORMAT,
     2 wfx       type WAVEFORMATEX,
     2 wRevision type WORD;
 define alias  PFMTOWNS_SND_WAVEFORMAT handle FMTOWNS_SND_WAVEFORMAT;
 define alias NPFMTOWNS_SND_WAVEFORMAT handle FMTOWNS_SND_WAVEFORMAT;
 define alias LPFMTOWNS_SND_WAVEFORMAT handle FMTOWNS_SND_WAVEFORMAT;

 /* Olivetti structure */
 /*  for WAVE_FORMAT_OLIGSM   (0x1000) */

 define structure
   1 OLIGSMWAVEFORMAT,
     2 wfx type WAVEFORMATEX;
 define alias  POLIGSMWAVEFORMAT handle OLIGSMWAVEFORMAT;
 define alias NPOLIGSMWAVEFORMAT handle OLIGSMWAVEFORMAT;
 define alias LPOLIGSMWAVEFORMAT handle OLIGSMWAVEFORMAT;

 /* Olivetti structure */
 /*  for WAVE_FORMAT_OLIADPCM   (0x1001) */

 define structure
   1 OLIADPCMWAVEFORMAT,
     2 wfx type WAVEFORMATEX;
 define alias  POLIADPCMWAVEFORMAT handle OLIADPCMWAVEFORMAT;
 define alias NPOLIADPCMWAVEFORMAT handle OLIADPCMWAVEFORMAT;
 define alias LPOLIADPCMWAVEFORMAT handle OLIADPCMWAVEFORMAT;

 /* Olivetti structure */
 /*  for WAVE_FORMAT_OLICELP   (0x1002) */

 define structure
   1 OLICELPWAVEFORMAT,
     2 wfx type WAVEFORMATEX;
 define alias  POLICELPWAVEFORMAT handle OLICELPWAVEFORMAT;
 define alias NPOLICELPWAVEFORMAT handle OLICELPWAVEFORMAT;
 define alias LPOLICELPWAVEFORMAT handle OLICELPWAVEFORMAT;


 /* Olivetti structure */
 /*  for WAVE_FORMAT_OLISBC   (0x1003) */

 define structure
   1 OLISBCWAVEFORMAT,
     2 wfx type WAVEFORMATEX;
 define alias  POLISBCWAVEFORMAT handle OLISBCWAVEFORMAT;
 define alias NPOLISBCWAVEFORMAT handle OLISBCWAVEFORMAT;
 define alias LPOLISBCWAVEFORMAT handle OLISBCWAVEFORMAT;

 /* Olivetti structure */
 /*  for WAVE_FORMAT_OLIOPR   (0x1004) */

 define structure
   1 OLIOPRWAVEFORMAT,
     2 wfx type WAVEFORMATEX;
 define alias  POLIOPRWAVEFORMAT handle OLIOPRWAVEFORMAT;
 define alias NPOLIOPRWAVEFORMAT handle OLIOPRWAVEFORMAT;
 define alias LPOLIOPRWAVEFORMAT handle OLIOPRWAVEFORMAT;


 /* Crystal Semiconductor IMA ADPCM format */
 /*  for WAVE_FORMAT_CS_IMAADPCM   (0x0039) */

 define structure
   1 CSIMAADPCMWAVEFORMAT,
     2 wfx type WAVEFORMATEX;
 define alias  PCSIMAADPCMWAVEFORMAT handle CSIMAADPCMWAVEFORMAT;
 define alias NPCSIMAADPCMWAVEFORMAT handle CSIMAADPCMWAVEFORMAT;
 define alias LPCSIMAADPCMWAVEFORMAT handle CSIMAADPCMWAVEFORMAT;

 /* ================================================================= */
 /*                                                                   */
 /*  ACM Wave Filters                                                 */
 /*                                                                   */
 /* ================================================================= */

 %dcl #ACM_WAVEFILTER char ext;
 %if #ACM_WAVEFILTER = '' %then %do;
 %#ACM_WAVEFILTER = 'Y';

 dcl WAVE_FILTER_UNKNOWN     fixed bin(31) value('0000'xn);
 dcl WAVE_FILTER_DEVELOPMENT fixed bin(31) value('FFFF'xn);

 define structure
   1 WAVEFILTER,
     2 cbStruct    type DWORD,/* Size of the filter in bytes */
     2 dwFilterTag type DWORD,/* filter type */
     2 fdwFilter   type DWORD,/* Flags for the filter (Universal Dfns)*/
     2 dwReserved (5) type DWORD;/* Reserved for system use */
 define alias  PWAVEFILTER handle WAVEFILTER;
 define alias NPWAVEFILTER handle WAVEFILTER;
 define alias LPWAVEFILTER handle WAVEFILTER;

 %end; /* _ACM_WAVEFILTER */

 %dcl #WAVE_FILTER_VOLUME char ext;
 %if #WAVE_FILTER_VOLUME = '' %then %do;
 %#WAVE_FILTER_VOLUME = 'Y';
 dcl WAVE_FILTER_VOLUME fixed bin(15) value('0001'xn);

 define structure
   1 VOLUMEWAVEFILTER,
     2 wfltr    type WAVEFILTER,
     2 dwVolume type DWORD;
 define alias  PVOLUMEWAVEFILTER handle VOLUMEWAVEFILTER;
 define alias NPVOLUMEWAVEFILTER handle VOLUMEWAVEFILTER;
 define alias LPVOLUMEWAVEFILTER handle VOLUMEWAVEFILTER;

 %end; /* #WAVE_FILTER_VOLUME */

 %dcl #WAVE_FILTER_ECHO char ext;
 %if #WAVE_FILTER_ECHO = '' %then %do;
 %#WAVE_FILTER_ECHO = 'Y';
 dcl WAVE_FILTER_ECHO fixed bin(15) value('0002'xn);

 define structure
   1 ECHOWAVEFILTER,
     2 wfltr    type WAVEFILTER,
     2 dwVolume type DWORD,
     2 dwDelay  type DWORD;
 define alias  PECHOWAVEFILTER handle ECHOWAVEFILTER;
 define alias NPECHOWAVEFILTER handle ECHOWAVEFILTER;
 define alias LPECHOWAVEFILTER handle ECHOWAVEFILTER;

 %end; /* #WAVEFILTER_ECHO */

 /* ************************************************************* */

 /* New RIFF WAVE Chunks */

 dcl RIFFWAVE_inst type FOURCC value (mmioFOURCC('i','n','s','t'));

 define structure
   1 s_RIFFWAVE_inst,
     2 bUnshiftedNote type BYTE,
     2 chFineTune     char,
     2 chGain         char,
     2 bLowNote       type BYTE,
     2 bHighNote      type BYTE,
     2 bLowVelocity   type BYTE,
     2 bHighVelocity  type BYTE;

 %end;

 /* ************************************************************ */

 /* New RIFF Forms */

 %dcl NONEWRIFF char ext;
 %if NONEWRIFF = '' %then %do;

 /* RIFF AVI */

 /* AVI file format is specified in a seperate file (AVIFMT.H), */
 /* which is available in the VfW and Win 32 SDK */

 /* RIFF CPPO */

 dcl RIFFCPPO      type FOURCC value(mmioFOURCC('C','P','P','O'));

 dcl RIFFCPPO_objr type FOURCC value(mmioFOURCC('o','b','j','r'));
 dcl RIFFCPPO_obji type FOURCC value(mmioFOURCC('o','b','j','i'));

 dcl RIFFCPPO_clsr type FOURCC value(mmioFOURCC('c','l','s','r'));
 dcl RIFFCPPO_clsi type FOURCC value(mmioFOURCC('c','l','s','i'));

 dcl RIFFCPPO_mbr  type FOURCC value(mmioFOURCC('m','b','r',' '));

 dcl RIFFCPPO_char type FOURCC value(mmioFOURCC('c','h','a','r'));

 dcl RIFFCPPO_byte type FOURCC value(mmioFOURCC('b','y','t','e'));
 dcl RIFFCPPO_int  type FOURCC value(mmioFOURCC('i','n','t',' '));
 dcl RIFFCPPO_word type FOURCC value(mmioFOURCC('w','o','r','d'));
 dcl RIFFCPPO_long type FOURCC value(mmioFOURCC('l','o','n','g'));
 dcl RIFFCPPO_dwrd type FOURCC value(mmioFOURCC('d','w','r','d'));
 dcl RIFFCPPO_flt  type FOURCC value(mmioFOURCC('f','l','t',' '));
 dcl RIFFCPPO_dbl  type FOURCC value(mmioFOURCC('d','b','l',' '));
 dcl RIFFCPPO_str  type FOURCC value(mmioFOURCC('s','t','r',' '));

 %end;


 /* ***************************************************************** */

 /* DIB Compression Defines */

 /* Following are in WinGDI.cpy, which is automatically included */

 /* dcl BI_BITFIELDS    fixed bin(31) value(3)        */

 /* dcl QUERYDIBSUPPORT fixed bin(31) value(3073)     */
 /* dcl QDI_SETDIBITS   fixed bin(15) value('0001'xn) */
 /* dcl QDI_GETDIBITS   fixed bin(15) value('0002'xn) */
 /* dcl QDI_DIBTOSCREEN fixed bin(15) value('0004'xn) */
 /* dcl QDI_STRETCHDIB  fixed bin(15) value('0008'xn) */


 %dcl NOBITMAP char ext;
 %if NOBITMAP = '' %then %do;
 /* Structure definitions */

 define structure
   1 EXBMINFOHEADER,
     2 bmi             type BITMAPINFOHEADER,
     /* extended BITMAPINFOHEADER fields */
     2 biExtDataOffset type DWORD;
     /* Other stuff will go here */
     /* ... */
     /* Format-specific information */
     /* biExtDataOffset points here */

 %end; /*NOBITMAP */

 /* New DIB Compression Defines */

 dcl BICOMP_IBMULTIMOTION  type FOURCC
     value(mmioFOURCC('U', 'L', 'T', 'I'));
 dcl BICOMP_IBMPHOTOMOTION type FOURCC
     value(mmioFOURCC('P', 'H', 'M', 'O'));
 dcl BICOMP_CREATIVEYUV    type FOURCC
     value(mmioFOURCC('c', 'y', 'u', 'v'));

 %dcl NOJPEGDIB char ext;
 %if NOJPEGDIB = '' %then %do;

 /* New DIB Compression Defines */
 dcl JPEG_DIB type FOURCC value(mmioFOURCC('J','P','E','G'));
     /* Still image JPEG DIB biCompression */
 dcl MJPG_DIB type FOURCC value(mmioFOURCC('M','J','P','G'));
     /* Motion JPEG DIB biCompression     */

 /* JPEGProcess Definitions */
 dcl JPEG_PROCESS_BASELINE fixed bin(31) value(0);
     /* Baseline DCT */

 /* AVI File format extensions */
 dcl AVIIF_CONTROLFRAME fixed bin(31) value('00000200'xn);
     /* This is a control frame */

 /* JIF Marker byte pairs in JPEG Interchange Format sequence */
 dcl JIFMK_SOF0  type WORD value('FFC0'xu);
     /* SOF Huff  - Baseline DCT*/
 dcl JIFMK_SOF1  type WORD value('FFC1'xu);
     /* SOF Huff  - Extended sequential DCT*/
 dcl JIFMK_SOF2  type WORD value('FFC2'xu);
     /* SOF Huff  - Progressive DCT*/
 dcl JIFMK_SOF3  type WORD value('FFC3'xu);
     /* SOF Huff  - Spatial (sequential) lossless*/
 dcl JIFMK_SOF5  type WORD value('FFC5'xu);
     /* SOF Huff  - Differential sequential DCT*/
 dcl JIFMK_SOF6  type WORD value('FFC6'xu);
     /* SOF Huff  - Differential progressive DCT*/
 dcl JIFMK_SOF7  type WORD value('FFC7'xu);
     /* SOF Huff  - Differential spatial*/
 dcl JIFMK_JPG   type WORD value('FFC8'xu);
     /* SOF Arith - Reserved for JPEG extensions*/
 dcl JIFMK_SOF9  type WORD value('FFC9'xu);
     /* SOF Arith - Extended sequential DCT*/
 dcl JIFMK_SOF10 type WORD value('FFCA'xu);
     /* SOF Arith - Progressive DCT*/
 dcl JIFMK_SOF11 type WORD value('FFCB'xu);
     /* SOF Arith - Spatial (sequential) lossless*/
 dcl JIFMK_SOF13 type WORD value('FFCD'xu);
     /* SOF Arith - Differential sequential DCT*/
 dcl JIFMK_SOF14 type WORD value('FFCE'xu);
     /* SOF Arith - Differential progressive DCT*/
 dcl JIFMK_SOF15 type WORD value('FFCF'xu);
     /* SOF Arith - Differential spatial*/
 dcl JIFMK_DHT   type WORD value('FFC4'xu);
     /* Define Huffman Table(s) */
 dcl JIFMK_DAC   type WORD value('FFCC'xu);
     /* Define Arith metic coding conditioning(s) */
 dcl JIFMK_RST0  type WORD value('FFD0'xu);
     /* Restart with modulo 8 count 0 */
 dcl JIFMK_RST1  type WORD value('FFD1'xu);
     /* Restart with modulo 8 count 1 */
 dcl JIFMK_RST2  type WORD value('FFD2'xu);
     /* Restart with modulo 8 count 2 */
 dcl JIFMK_RST3  type WORD value('FFD3'xu);
     /* Restart with modulo 8 count 3 */
 dcl JIFMK_RST4  type WORD value('FFD4'xu);
     /* Restart with modulo 8 count 4 */
 dcl JIFMK_RST5  type WORD value('FFD5'xu);
     /* Restart with modulo 8 count 5 */
 dcl JIFMK_RST6  type WORD value('FFD6'xu);
     /* Restart with modulo 8 count 6 */
 dcl JIFMK_RST7  type WORD value('FFD7'xu);
     /* Restart with modulo 8 count 7 */
 dcl JIFMK_SOI   type WORD value('FFD8'xu);
     /* Start of Image */
 dcl JIFMK_EOI   type WORD value('FFD9'xu);
     /* End of Image */
 dcl JIFMK_SOS   type WORD value('FFDA'xu);
     /* Start of Scan */
 dcl JIFMK_DQT   type WORD value('FFDB'xu);
     /* Define quantization Table(s) */
 dcl JIFMK_DNL   type WORD value('FFDC'xu);
     /* Define Number of Lines */
 dcl JIFMK_DRI   type WORD value('FFDD'xu);
     /* Define Restart Interval */
 dcl JIFMK_DHP   type WORD value('FFDE'xu);
     /* Define Hierarchical progression */
 dcl JIFMK_EXP   type WORD value('FFDF'xu);
     /* Expand Reference Component(s) */
 dcl JIFMK_APP0  type WORD value('FFE0'xu);
     /* Application Field 0*/
 dcl JIFMK_APP1  type WORD value('FFE1'xu);
     /* Application Field 1*/
 dcl JIFMK_APP2  type WORD value('FFE2'xu);
     /* Application Field 2*/
 dcl JIFMK_APP3  type WORD value('FFE3'xu);
     /* Application Field 3*/
 dcl JIFMK_APP4  type WORD value('FFE4'xu);
     /* Application Field 4*/
 dcl JIFMK_APP5  type WORD value('FFE5'xu);
     /* Application Field 5*/
 dcl JIFMK_APP6  type WORD value('FFE6'xu);
     /* Application Field 6*/
 dcl JIFMK_APP7  type WORD value('FFE7'xu);
     /* Application Field 7*/
 dcl JIFMK_JPG0  type WORD value('FFF0'xu);
     /* Reserved for JPEG extensions */
 dcl JIFMK_JPG1  type WORD value('FFF1'xu);
     /* Reserved for JPEG extensions */
 dcl JIFMK_JPG2  type WORD value('FFF2'xu);
     /* Reserved for JPEG extensions */
 dcl JIFMK_JPG3  type WORD value('FFF3'xu);
     /* Reserved for JPEG extensions */
 dcl JIFMK_JPG4  type WORD value('FFF4'xu);
     /* Reserved for JPEG extensions */
 dcl JIFMK_JPG5  type WORD value('FFF5'xu);
     /* Reserved for JPEG extensions */
 dcl JIFMK_JPG6  type WORD value('FFF6'xu);
     /* Reserved for JPEG extensions */
 dcl JIFMK_JPG7  type WORD value('FFF7'xu);
     /* Reserved for JPEG extensions */
 dcl JIFMK_JPG8  type WORD value('FFF8'xu);
     /* Reserved for JPEG extensions */
 dcl JIFMK_JPG9  type WORD value('FFF9'xu);
     /* Reserved for JPEG extensions */
 dcl JIFMK_JPG10 type WORD value('FFFA'xu);
     /* Reserved for JPEG extensions */
 dcl JIFMK_JPG11 type WORD value('FFFB'xu);
     /* Reserved for JPEG extensions */
 dcl JIFMK_JPG12 type WORD value('FFFC'xu);
     /* Reserved for JPEG extensions */
 dcl JIFMK_JPG13 type WORD value('FFFD'xu);
     /* Reserved for JPEG extensions */
 dcl JIFMK_COM   type WORD value('FFFE'xu);
     /* Comment */
 dcl JIFMK_TEM   type WORD value('FF01'xu);
     /* for temp private use arith code */
 dcl JIFMK_RES   type WORD value('FF02'xu);
     /* Reserved */
 dcl JIFMK_00    type WORD value('FF00'xu);
     /* Zero stuffed byte - entropy data */
 dcl JIFMK_FF    type WORD value('FFFF'xu);
     /* Fill byte */

 /* JPEGColorSpaceID Definitions */
 dcl JPEG_Y      fixed bin(31) value(1);
     /* Y only component of YCbCr */
 dcl JPEG_YCbCr  fixed bin(31) value(2);
     /* YCbCr as define by CCIR 601 */
 dcl JPEG_RGB    fixed bin(31) value(3);
     /* 3 component RGB */

 /* Structure definitions */

 define structure
   1 JPEGINFOHEADER,
     /* compression-specific fields */
     /* these fields are defined for 'JPEG' and 'MJPG' */
     2 JPEGSize          type DWORD,
     2 JPEGProcess       type DWORD,
     /* Process specific fields */
     2 JPEGColorSpaceID  type DWORD,
     2 JPEGBitsPerSample type DWORD,
     2 JPEGHSubSampling  type DWORD,
     2 JPEGVSubSampling  type DWORD;

 %dcl #MJPGDHTSEG_STORAGE char ext;
 %if #MJPGDHTSEG_STORAGE ^= '' %then %do;
 /* Default DHT Segment */

 /* JPEG DHT Segment for YCrCb omitted from MJPG data */
 dcl MJPGDHTSeg ('1A4'xn) type BYTE static
 init ('FF'xn,'C4'xn,'01'xn,'A2'xn,
       '00'xn,'00'xn,'01'xn,'05'xn,'01'xn,'01'xn,'01'xn,'01'xn,'01'xn,
       '01'xn,'00'xn,'00'xn,'00'xn,'00'xn,'00'xn,'00'xn,'00'xn,'00'xn,
       '01'xn,'02'xn,'03'xn,'04'xn,'05'xn,'06'xn,'07'xn,'08'xn,'09'xn,
       '0A'xn,'0B'xn,'01'xn,'00'xn,'03'xn,'01'xn,'01'xn,'01'xn,'01'xn,
       '01'xn,'01'xn,'01'xn,'01'xn,'01'xn,'00'xn,'00'xn,'00'xn,'00'xn,
       '00'xn,'00'xn,'01'xn,'02'xn,'03'xn,'04'xn,'05'xn,'06'xn,'07'xn,
       '08'xn,'09'xn,'0A'xn,'0B'xn,'10'xn,'00'xn,'02'xn,'01'xn,'03'xn,
       '03'xn,'02'xn,'04'xn,'03'xn,'05'xn,'05'xn,'04'xn,'04'xn,'00'xn,
       '00'xn,'01'xn,'7D'xn,'01'xn,'02'xn,'03'xn,'00'xn,'04'xn,'11'xn,
       '05'xn,'12'xn,'21'xn,'31'xn,'41'xn,'06'xn,'13'xn,'51'xn,'61'xn,
       '07'xn,'22'xn,'71'xn,'14'xn,'32'xn,'81'xn,'91'xn,'A1'xn,'08'xn,
       '23'xn,'42'xn,'B1'xn,'C1'xn,'15'xn,'52'xn,'D1'xn,'F0'xn,'24'xn,
       '33'xn,'62'xn,'72'xn,'82'xn,'09'xn,'0A'xn,'16'xn,'17'xn,'18'xn,
       '19'xn,'1A'xn,'25'xn,'26'xn,'27'xn,'28'xn,'29'xn,'2A'xn,'34'xn,
       '35'xn,'36'xn,'37'xn,'38'xn,'39'xn,'3A'xn,'43'xn,'44'xn,'45'xn,
       '46'xn,'47'xn,'48'xn,'49'xn,'4A'xn,'53'xn,'54'xn,'55'xn,'56'xn,
       '57'xn,'58'xn,'59'xn,'5A'xn,'63'xn,'64'xn,'65'xn,'66'xn,'67'xn,
       '68'xn,'69'xn,'6A'xn,'73'xn,'74'xn,'75'xn,'76'xn,'77'xn,'78'xn,
       '79'xn,'7A'xn,'83'xn,'84'xn,'85'xn,'86'xn,'87'xn,'88'xn,'89'xn,
       '8A'xn,'92'xn,'93'xn,'94'xn,'95'xn,'96'xn,'97'xn,'98'xn,'99'xn,
       '9A'xn,'A2'xn,'A3'xn,'A4'xn,'A5'xn,'A6'xn,'A7'xn,'A8'xn,'A9'xn,
       'AA'xn,'B2'xn,'B3'xn,'B4'xn,'B5'xn,'B6'xn,'B7'xn,'B8'xn,'B9'xn,
       'BA'xn,'C2'xn,'C3'xn,'C4'xn,'C5'xn,'C6'xn,'C7'xn,'C8'xn,'C9'xn,
       'CA'xn,'D2'xn,'D3'xn,'D4'xn,'D5'xn,'D6'xn,'D7'xn,'D8'xn,'D9'xn,
       'DA'xn,'E1'xn,'E2'xn,'E3'xn,'E4'xn,'E5'xn,'E6'xn,'E7'xn,'E8'xn,
       'E9'xn,'EA'xn,'F1'xn,'F2'xn,'F3'xn,'F4'xn,'F5'xn,'F6'xn,'F7'xn,
       'F8'xn,'F9'xn,'FA'xn,'11'xn,'00'xn,'02'xn,'01'xn,'02'xn,'04'xn,
       '04'xn,'03'xn,'04'xn,'07'xn,'05'xn,'04'xn,'04'xn,'00'xn,'01'xn,
       '02'xn,'77'xn,'00'xn,'01'xn,'02'xn,'03'xn,'11'xn,'04'xn,'05'xn,
       '21'xn,'31'xn,'06'xn,'12'xn,'41'xn,'51'xn,'07'xn,'61'xn,'71'xn,
       '13'xn,'22'xn,'32'xn,'81'xn,'08'xn,'14'xn,'42'xn,'91'xn,'A1'xn,
       'B1'xn,'C1'xn,'09'xn,'23'xn,'33'xn,'52'xn,'F0'xn,'15'xn,'62'xn,
       '72'xn,'D1'xn,'0A'xn,'16'xn,'24'xn,'34'xn,'E1'xn,'25'xn,'F1'xn,
       '17'xn,'18'xn,'19'xn,'1A'xn,'26'xn,'27'xn,'28'xn,'29'xn,'2A'xn,
       '35'xn,'36'xn,'37'xn,'38'xn,'39'xn,'3A'xn,'43'xn,'44'xn,'45'xn,
       '46'xn,'47'xn,'48'xn,'49'xn,'4A'xn,'53'xn,'54'xn,'55'xn,'56'xn,
       '57'xn,'58'xn,'59'xn,'5A'xn,'63'xn,'64'xn,'65'xn,'66'xn,'67'xn,
       '68'xn,'69'xn,'6A'xn,'73'xn,'74'xn,'75'xn,'76'xn,'77'xn,'78'xn,
       '79'xn,'7A'xn,'82'xn,'83'xn,'84'xn,'85'xn,'86'xn,'87'xn,'88'xn,
       '89'xn,'8A'xn,'92'xn,'93'xn,'94'xn,'95'xn,'96'xn,'97'xn,'98'xn,
       '99'xn,'9A'xn,'A2'xn,'A3'xn,'A4'xn,'A5'xn,'A6'xn,'A7'xn,'A8'xn,
       'A9'xn,'AA'xn,'B2'xn,'B3'xn,'B4'xn,'B5'xn,'B6'xn,'B7'xn,'B8'xn,
       'B9'xn,'BA'xn,'C2'xn,'C3'xn,'C4'xn,'C5'xn,'C6'xn,'C7'xn,'C8'xn,
       'C9'xn,'CA'xn,'D2'xn,'D3'xn,'D4'xn,'D5'xn,'D6'xn,'D7'xn,'D8'xn,
       'D9'xn,'DA'xn,'E2'xn,'E3'xn,'E4'xn,'E5'xn,'E6'xn,'E7'xn,'E8'xn,
       'E9'xn,'EA'xn,'F2'xn,'F3'xn,'F4'xn,'F5'xn,'F6'xn,'F7'xn,'F8'xn,
       'F9'xn,'FA'xn);

 /* End DHT default */
 %end;

 /* End JPEG */
 %end;

 /* ************************************************************* */

 /* Defined IC types */

 %dcl NONEWIC char ext;
 %if NONEWIC = '' %then %do;
 %dcl #ICTYPE_VIDEO char ext;
 %if #ICTYPE_VIDEO = '' %then %do;
 %#ICTYPE_VIDEO = 'Y';
 dcl ICTYPE_VIDEO type FOURCC value(mmioFOURCC('v', 'i', 'd', 'c'));
 dcl ICTYPE_AUDIO type FOURCC value(mmioFOURCC('a', 'u', 'd', 'c'));
 %end;
 %end;

 /*  Misc. FOURCC registration */

 /* Sierra Semiconductor: RDSP- Confidential RIFF file format */
 /*       for the storage and downloading of DSP     */
 /*       code for Audio and communications devices. */
 dcl FOURCC_RDSP type FOURCC value( mmioFOURCC('R', 'D', 'S', 'P'));

 %dcl MMNOMIXER char ext;
 %if MMNOMIXER = '' %then %do;
 dcl MIXERCONTROL_CONTROLTYPE_SRS_MTS         fixed bin(31)
     value(MIXERCONTROL_CONTROLTYPE_BOOLEAN + 6);
 dcl MIXERCONTROL_CONTROLTYPE_SRS_ONOFF       fixed bin(31)
     value(MIXERCONTROL_CONTROLTYPE_BOOLEAN + 7);
 dcl MIXERCONTROL_CONTROLTYPE_SRS_SYNTHSELECT fixed bin(31)
     value(MIXERCONTROL_CONTROLTYPE_BOOLEAN + 8);
 %end;

 %end; /* _INC_MMREG */
