 /*********************************************************************/
 /* Copyright (c) 1989-1997  Microsoft Corporation                    */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*     mswsock.h                                                     */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*     This module contains the Microsoft-specific extensions to the */
 /*     Windows Sockets API.                                          */
 /*                                                                   */
 /* Author:                                                           */
 /*                                                                   */
 /*     Keith Moore (keithmo) 06-Oct-1995 (Separated from WINSOCK.H). */
 /*                                                                   */
 /* Revision History:                                                 */
 /*                                                                   */
 /*********************************************************************/


 %dcl #MSWSOCK_ char ext;
 %if #MSWSOCK_ = '' %then %do;
   %#MSWSOCK_ = 'Y';

 %dcl #WINSOCK2API_ char ext;
 %if #WINSOCK2API_ = '' %then %do;
   %include winsock2;
 %end;


 /* Options for connect and disconnect data and options.             */
 /* Used only by non-TCP/IP transports such as DECNet, OSI TP4, etc. */
 dcl SO_CONNDATA              fixed bin(15) value('7000'xn);
 dcl SO_CONNOPT               fixed bin(15) value('7001'xn);
 dcl SO_DISCDATA              fixed bin(15) value('7002'xn);
 dcl SO_DISCOPT               fixed bin(15) value('7003'xn);
 dcl SO_CONNDATALEN           fixed bin(15) value('7004'xn);
 dcl SO_CONNOPTLEN            fixed bin(15) value('7005'xn);
 dcl SO_DISCDATALEN           fixed bin(15) value('7006'xn);
 dcl SO_DISCOPTLEN            fixed bin(15) value('7007'xn);

 /* Option for opening sockets for synchronous access. */
 dcl SO_OPENTYPE              fixed bin(15) value('7008'xn);

 dcl SO_SYNCHRONOUS_ALERT     fixed bin(15) value('10'xn);
 dcl SO_SYNCHRONOUS_NONALERT  fixed bin(15) value('20'xn);

 /* Other NT-specific options.   */
 dcl SO_MAXDG                 fixed bin(15) value('7009'xn);
 dcl SO_MAXPATHDG             fixed bin(15) value('700A'xn);
 dcl SO_UPDATE_ACCEPT_CONTEXT fixed bin(15) value('700B'xn);
 dcl SO_CONNECT_TIME          fixed bin(15) value('700C'xn);

 /* TCP options. */
 dcl TCP_BSDURGENT            fixed bin(15) value('7000'xn);


 /* Microsoft extended APIs. */

 dcl WSARecvEx
     entry (type SOCKET,
            pointer,
            fixed bin(31),
            fixed bin(31) byaddr)
     returns (fixed bin(31) byvalue optional)
     PASCAL external('WSARecvEx');

 define structure
   1 TRANSMIT_FILE_BUFFERS,
     2 Head       type LPVOID,
     2 HeadLength type DWORD,
     2 Tail       type LPVOID,
     2 TailLength type DWORD;

 define alias  PTRANSMIT_FILE_BUFFERS handle TRANSMIT_FILE_BUFFERS;
 define alias LPTRANSMIT_FILE_BUFFERS handle TRANSMIT_FILE_BUFFERS;

 dcl TF_DISCONNECT   fixed bin(15) value('01'xn);
 dcl TF_REUSE_SOCKET fixed bin(15) value('02'xn);
 dcl TF_WRITE_BEHIND fixed bin(15) value('04'xn);

 dcl TransmitFile
     entry (type SOCKET,
            type HANDLE,
            type DWORD,
            type DWORD,
            type OVERLAPPED byaddr optional,
            type TRANSMIT_FILE_BUFFERS byaddr optional,
            type DWORD)
     returns (type BOOL byvalue optional)
     PASCAL external('TransmitFile');

 dcl AcceptEx
     entry (type SOCKET,
            type SOCKET,
            type PVOID,
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD byaddr,
            type OVERLAPPED byaddr)
     returns (type BOOL byvalue optional)
     PASCAL external('AcceptEx');

 dcl GetAcceptExSockaddrs
     entry (type PVOID,
            type DWORD,
            type DWORD,
            type DWORD,
            type LPSOCKADDR, /* to appropriate SOCKADDR */
            type INT byaddr,
            type LPSOCKADDR, /* to appropriate SOCKADDR */
            type INT byaddr)
     returns (type VOID byvalue optional)
     PASCAL external('GetAcceptExSockaddrs');

 /* "QueryInterface" versions of the above APIs. */

 define alias LPFN_TRANSMITFILE
        entry (type SOCKET,
               type HANDLE,
               type DWORD,
               type DWORD,
               type OVERLAPPED byaddr optional,
               type TRANSMIT_FILE_BUFFERS byaddr optional,
               type DWORD)
        returns (type BOOL byvalue optional)
        limited PASCAL;

 dcl 1 WSAID_TRANSMITFILE static,      /* type GUID */
       2 Data1 type DWORD init ('b5367df0'xu),
       2 Data2 type WORD  init ('cbac'xu),
       2 Data3 type WORD  init ('11cf'xu),
       2 Data4 (8) char   init ('95'x, 'ca'x, '00'x, '80'x,
                                '5f'x, '48'x, 'a1'x, '92'x);

 define alias LPFN_ACCEPTEX
        entry (type SOCKET,
               type SOCKET,
               type PVOID,
               type DWORD,
               type DWORD,
               type DWORD,
               type DWORD byaddr,
               type OVERLAPPED byaddr)
        returns (type BOOL byvalue optional)
        limited PASCAL;

 dcl 1 WSAID_ACCEPTEX static,      /* type GUID */
       2 Data1 type DWORD init ('b5367df1'xu),
       2 Data2 type WORD  init ('cbac'xu),
       2 Data3 type WORD  init ('11cf'xu),
       2 Data4 (8) char   init ('95'x, 'ca'x, '00'x, '80'x,
                                '5f'x, '48'x, 'a1'x, '92'x);

 define alias LPFN_GETACCEPTEXSOCKADDRS
        entry (type PVOID,
               type DWORD,
               type DWORD,
               type DWORD,
               type LPSOCKADDR, /* to appropriate SOCKADDR */
               type INT byaddr,
               type LPSOCKADDR, /* to appropriate SOCKADDR */
               type INT byaddr)
        limited PASCAL;

 dcl 1 WSAID_GETACCEPTEXSOCKADDRS static,      /* type GUID */
       2 Data1 type DWORD init ('b5367df2'xu),
       2 Data2 type WORD  init ('cbac'xu),
       2 Data3 type WORD  init ('11cf'xu),
       2 Data4 (8) char   init ('95'x, 'ca'x, '00'x, '80'x,
                                '5f'x, '48'x, 'a1'x, '92'x);

 %end; /* _MSWSOCK_ */

