 /*                                                                   */
 /* RICHEDIT.H                                                        */
 /*                                                                   */
 /* Purpose:                                                          */
 /*   RICHEDIT v2.0/3.0 public definitions. Note that there is        */
 /*   additional functionality available for v2.0 and v3.0 that is    */
 /*   not in the original Windows 95 release.                         */
 /*                                                                   */
 /* Copyright (c) 1985-1998, Microsoft Corporation                    */

 %dcl #RICHEDIT_ char ext;
 %if #RICHEDIT_ = '' %then %do;
 %#RICHEDIT_ = 'Y';


 /* To mimic older RichEdit behavior, simply set #RICHEDIT_VER to the */
 /* appropriate value */
 /*    Version 1.0    0x0100 = 256  */
 /*    Version 2.0    0x0200 = 512  */
 /*    Version 2.1    0x0210 = 518  */
 %dcl #RICHEDIT_VER fixed ext;
 %if #RICHEDIT_VER = 0 %then %do;
 %#RICHEDIT_VER = 768; /* 0x0300 */
 %end;

 %dcl #WIN32 char ext;
 %if #WIN32 = '' %then %#WIN32 = 'Y'; /* always */
 %dcl UNICODE char ext;

 dcl cchTextLimitDefault fixed bin(31) value(32767);

 /* Richedit2.0 Window Class. */

 dcl CERICHEDIT_CLASSA char  value('RichEditCEA');
 dcl CERICHEDIT_CLASSW WCHAR value('RichEditCEW');

 dcl RICHEDIT_CLASSA   char  value('RichEdit20A');
 dcl RICHEDIT_CLASS10A char  value('RICHEDIT'); /* Richedit 1.0 */

 dcl RICHEDIT_CLASSW   WCHAR value('RichEdit20W');

 %dcl RICHEDIT_CLASS char ext;

 %if #RICHEDIT_VER >= 512 %then %do;
 %if UNICODE ^= '' %then %do;
 %RICHEDIT_CLASS='RICHEDIT_CLASSW';
 %end; %else %do;
 %RICHEDIT_CLASS='RICHEDIT_CLASSA';
 %end; /* UNICODE */
 %end; %else %do;
 %RICHEDIT_CLASS='RICHEDIT_CLASS10A';
 %end; /* _RICHEDIT_VER >= 0x0200 */

 /* RichEdit messages */

 %dcl #WM_CONTEXTMENU char ext;
 %if #WM_CONTEXTMENU = '' %then %do;
 %#WM_CONTEXTMENU = 'Y';
 dcl WM_CONTEXTMENU           fixed bin(31) value('007B'xn);
 %end;

 %dcl #WM_PRINTCLIENT char ext;
 %if #WM_PRINTCLIENT = '' %then %do;
 %#WM_PRINTCLIENT = 'Y';
 dcl WM_PRINTCLIENT           fixed bin(31) value('0318'xn);
 %end;

 %dcl #EM_GETLIMITTEXT char ext;
 %if #EM_GETLIMITTEXT = '' %then %do;
 %#EM_GETLIMITTEXT = 'Y';
 dcl EM_GETLIMITTEXT         fixed bin(31) value(WM_USER + 37);
 %end;

 %dcl #EM_POSFROMCHAR char ext;
 %if #EM_POSFROMCHAR = '' %then %do;
 %#EM_POSFROMCHAR = 'Y';
 dcl EM_POSFROMCHAR          fixed bin(31) value(WM_USER + 38);
 dcl EM_CHARFROMPOS          fixed bin(31) value(WM_USER + 39);
 %end;

 %dcl #EM_SCROLLCARET char ext;
 %if #EM_SCROLLCARET = '' %then %do;
 %#EM_SCROLLCARET = 'Y';
 dcl EM_SCROLLCARET          fixed bin(31) value(WM_USER + 49);
 %end;
 dcl EM_CANPASTE             fixed bin(31) value(WM_USER + 50);
 dcl EM_DISPLAYBAND          fixed bin(31) value(WM_USER + 51);
 dcl EM_EXGETSEL             fixed bin(31) value(WM_USER + 52);
 dcl EM_EXLIMITTEXT          fixed bin(31) value(WM_USER + 53);
 dcl EM_EXLINEFROMCHAR       fixed bin(31) value(WM_USER + 54);
 dcl EM_EXSETSEL             fixed bin(31) value(WM_USER + 55);
 dcl EM_FINDTEXT             fixed bin(31) value(WM_USER + 56);
 dcl EM_FORMATRANGE          fixed bin(31) value(WM_USER + 57);
 dcl EM_GETCHARFORMAT        fixed bin(31) value(WM_USER + 58);
 dcl EM_GETEVENTMASK         fixed bin(31) value(WM_USER + 59);
 dcl EM_GETOLEINTERFACE      fixed bin(31) value(WM_USER + 60);
 dcl EM_GETPARAFORMAT        fixed bin(31) value(WM_USER + 61);
 dcl EM_GETSELTEXT           fixed bin(31) value(WM_USER + 62);
 dcl EM_HIDESELECTION        fixed bin(31) value(WM_USER + 63);
 dcl EM_PASTESPECIAL         fixed bin(31) value(WM_USER + 64);
 dcl EM_REQUESTRESIZE        fixed bin(31) value(WM_USER + 65);
 dcl EM_SELECTIONTYPE        fixed bin(31) value(WM_USER + 66);
 dcl EM_SETBKGNDCOLOR        fixed bin(31) value(WM_USER + 67);
 dcl EM_SETCHARFORMAT        fixed bin(31) value(WM_USER + 68);
 dcl EM_SETEVENTMASK         fixed bin(31) value(WM_USER + 69);
 dcl EM_SETOLECALLBACK       fixed bin(31) value(WM_USER + 70);
 dcl EM_SETPARAFORMAT        fixed bin(31) value(WM_USER + 71);
 dcl EM_SETTARGETDEVICE      fixed bin(31) value(WM_USER + 72);
 dcl EM_STREAMIN             fixed bin(31) value(WM_USER + 73);
 dcl EM_STREAMOUT            fixed bin(31) value(WM_USER + 74);
 dcl EM_GETTEXTRANGE         fixed bin(31) value(WM_USER + 75);
 dcl EM_FINDWORDBREAK        fixed bin(31) value(WM_USER + 76);
 dcl EM_SETOPTIONS           fixed bin(31) value(WM_USER + 77);
 dcl EM_GETOPTIONS           fixed bin(31) value(WM_USER + 78);
 dcl EM_FINDTEXTEX           fixed bin(31) value(WM_USER + 79);

 %if #WIN32 ^= '' %then %do;
 dcl EM_GETWORDBREAKPROCEX   fixed bin(31) value(WM_USER + 80);
 dcl EM_SETWORDBREAKPROCEX   fixed bin(31) value(WM_USER + 81);
 %end;

 /* Richedit v2.0 messages */
 dcl EM_SETUNDOLIMIT         fixed bin(31) value(WM_USER + 82);
 dcl EM_REDO                 fixed bin(31) value(WM_USER + 84);
 dcl EM_CANREDO              fixed bin(31) value(WM_USER + 85);
 dcl EM_GETUNDONAME          fixed bin(31) value(WM_USER + 86);
 dcl EM_GETREDONAME          fixed bin(31) value(WM_USER + 87);
 dcl EM_STOPGROUPTYPING      fixed bin(31) value(WM_USER + 88);

 dcl EM_SETTEXTMODE          fixed bin(31) value(WM_USER + 89);
 dcl EM_GETTEXTMODE          fixed bin(31) value(WM_USER + 90);

 /* enum for use with EM_GET/SETTEXTMODE */
 define ordinal
   TEXTMODE
     ( TM_PLAINTEXT       value(1),
       TM_RICHTEXT        value(2),/* default behavior */
       TM_SINGLELEVELUNDO value(4),
       TM_MULTILEVELUNDO  value(8),/* default behavior */
       TM_SINGLECODEPAGE  value(16),
       TM_MULTICODEPAGE   value(32)/* default behavior */
     ) precision (31);

 dcl EM_AUTOURLDETECT        fixed bin(31) value(WM_USER + 91);
 dcl EM_GETAUTOURLDETECT     fixed bin(31) value(WM_USER + 92);
 dcl EM_SETPALETTE           fixed bin(31) value(WM_USER + 93);
 dcl EM_GETTEXTEX            fixed bin(31) value(WM_USER + 94);
 dcl EM_GETTEXTLENGTHEX      fixed bin(31) value(WM_USER + 95);

 /* Far East specific messages */
 dcl EM_SETPUNCTUATION       fixed bin(31) value(WM_USER + 100);
 dcl EM_GETPUNCTUATION       fixed bin(31) value(WM_USER + 101);
 dcl EM_SETWORDWRAPMODE      fixed bin(31) value(WM_USER + 102);
 dcl EM_GETWORDWRAPMODE      fixed bin(31) value(WM_USER + 103);
 dcl EM_SETIMECOLOR          fixed bin(31) value(WM_USER + 104);
 dcl EM_GETIMECOLOR          fixed bin(31) value(WM_USER + 105);
 dcl EM_SETIMEOPTIONS        fixed bin(31) value(WM_USER + 106);
 dcl EM_GETIMEOPTIONS        fixed bin(31) value(WM_USER + 107);
 dcl EM_CONVPOSITION         fixed bin(31) value(WM_USER + 108);

 dcl EM_SETLANGOPTIONS       fixed bin(31) value(WM_USER + 120);
 dcl EM_GETLANGOPTIONS       fixed bin(31) value(WM_USER + 121);
 dcl EM_GETIMECOMPMODE       fixed bin(31) value(WM_USER + 122);

 dcl EM_FINDTEXTW            fixed bin(31) value(WM_USER + 123);
 dcl EM_FINDTEXTEXW          fixed bin(31) value(WM_USER + 124);

 /* BiDi specific messages */
 dcl EM_SETBIDIOPTIONS       fixed bin(31) value(WM_USER + 200);
 dcl EM_GETBIDIOPTIONS       fixed bin(31) value(WM_USER + 201);

 dcl EM_SETTYPOGRAPHYOPTIONS fixed bin(31) value(WM_USER + 202);
 dcl EM_GETTYPOGRAPHYOPTIONS fixed bin(31) value(WM_USER + 203);

 /* Extended edit style specific messages */
 dcl EM_SETEDITSTYLE         fixed bin(31) value(WM_USER + 204);
 dcl EM_GETEDITSTYLE         fixed bin(31) value(WM_USER + 205);

 /* Extended edit style masks */
 dcl SES_EMULATESYSEDIT      fixed bin(31) value(  1);
 dcl SES_BEEPONMAXTEXT       fixed bin(31) value(  2);
 dcl SES_EXTENDBACKCOLOR     fixed bin(31) value(  4);
 dcl SES_MAPCPS              fixed bin(31) value(  8);
 dcl SES_EMULATE10           fixed bin(31) value( 16);
 dcl SES_USECRLF             fixed bin(31) value( 32);
 dcl SES_USEAIMM             fixed bin(31) value( 64);

 dcl SES_ALLOWBEEPS          fixed bin(31) value(256);

 /* Options for EM_SETLANGOPTIONS and EM_GETLANGOPTIONS */
 dcl IMF_AUTOKEYBOARD        fixed bin(31) value('0001'xn);
 dcl IMF_AUTOFONT            fixed bin(31) value('0002'xn);
 dcl IMF_IMECANCELCOMPLETE   fixed bin(31) value('0004'xn);
 /* high completes the comp string when aborting, low cancels. */
 dcl IMF_IMEALWAYSSENDNOTIFY fixed bin(31) value('0008'xn);

 /* Values for EM_GETIMECOMPMODE */
 dcl ICM_NOTOPEN             fixed bin(31) value('0000'xn);
 dcl ICM_LEVEL3              fixed bin(31) value('0001'xn);
 dcl ICM_LEVEL2              fixed bin(31) value('0002'xn);
 dcl ICM_LEVEL2_5            fixed bin(31) value('0003'xn);
 dcl ICM_LEVEL2_SUI          fixed bin(31) value('0004'xn);

 /* Options for EM_SETTYPOGRAPHYOPTIONS */
 dcl TO_LINESERVICES         fixed bin(31) value(1);
 dcl TO_SIMPLELINEBREAK      fixed bin(31) value(2);

 /* Pegasus outline mode messages (RE 3.0) */

 /* Outline mode message */
 dcl EM_OUTLINE              fixed bin(31) value(WM_USER + 220);
 /* Message for getting and restoring scroll pos*/
 dcl EM_GETSCROLLPOS         fixed bin(31) value(WM_USER + 221);
 dcl EM_SETSCROLLPOS         fixed bin(31) value(WM_USER + 222);
 /* Change fontsize in current selection by wParam */
 dcl EM_SETFONTSIZE          fixed bin(31) value(WM_USER + 223);
 dcl EM_GETZOOM              fixed bin(31) value(WM_USER + 224);
 dcl EM_SETZOOM              fixed bin(31) value(WM_USER + 225);

 /* Outline mode wparam valies */
 dcl EMO_EXIT                fixed bin(31) value(0);
     /* enter normal mode,  lparam ignored */
 dcl EMO_ENTER               fixed bin(31) value(1);
     /* enter outline mode, lparam ignored */
 dcl EMO_PROMOTE             fixed bin(31) value(2);
     /* LOWORD(lparam) == 0 ==> promote  to body-text            */
     /* LOWORD(lparam) != 0 ==> promote/demote current selection */
     /*                         by indicated number of levels    */
 dcl EMO_EXPAND              fixed bin(31) value(3);
     /* HIWORD(lparam) = EMO_EXPANDSELECTION                         */
     /* -> expands selection to level indicated in LOWORD(lparam)    */
     /* LOWORD(lparam) = -1/+1 corresponds to collapse/expand button */
     /* presses in winword (other values are equivalent to having    */
     /* pressed these buttons more than once)                        */
     /* HIWORD(lparam) = EMO_EXPANDDOCUMENT                          */
     /* -> expands whole document to indicated level                 */
 dcl EMO_MOVESELECTION       fixed bin(31) value(4);
     /* LOWORD(lparam) != 0 -> move current selection up/down */
     /*                        by indicated amount            */
 dcl EMO_GETVIEWMODE         fixed bin(31) value(5);
     /* Returns VM_NORMAL or VM_OUTLINE */

 /* EMO_EXPAND options */
 dcl EMO_EXPANDSELECTION     fixed bin(31) value(0);
 dcl EMO_EXPANDDOCUMENT      fixed bin(31) value(1);
 dcl VM_NORMAL               fixed bin(31) value(4);
     /* Agrees with RTF \viewkindN */
 dcl VM_OUTLINE              fixed bin(31) value(2);

 /* New notifications */

 dcl EN_MSGFILTER            fixed bin(31) value('0700'xn);
 dcl EN_REQUESTRESIZE        fixed bin(31) value('0701'xn);
 dcl EN_SELCHANGE            fixed bin(31) value('0702'xn);
 dcl EN_DROPFILES            fixed bin(31) value('0703'xn);
 dcl EN_PROTECTED            fixed bin(31) value('0704'xn);
 dcl EN_CORRECTTEXT          fixed bin(31) value('0705'xn);
 /* PenWin specific */
 dcl EN_STOPNOUNDO           fixed bin(31) value('0706'xn);
 dcl EN_IMECHANGE            fixed bin(31) value('0707'xn);
 /* Far East specific */
 dcl EN_SAVECLIPBOARD        fixed bin(31) value('0708'xn);
 dcl EN_OLEOPFAILED          fixed bin(31) value('0709'xn);
 dcl EN_OBJECTPOSITIONS      fixed bin(31) value('070a'xn);
 dcl EN_LINK                 fixed bin(31) value('070b'xn);
 dcl EN_DRAGDROPDONE         fixed bin(31) value('070c'xn);

 /* BiDi specific notifications */

 dcl EN_ALIGNLTR             fixed bin(31) value('0710'xn);
 dcl EN_ALIGNRTL             fixed bin(31) value('0711'xn);

 /* Event notification masks */

 dcl ENM_NONE                fixed bin(31) value('00000000'xn);
 dcl ENM_CHANGE              fixed bin(31) value('00000001'xn);
 dcl ENM_UPDATE              fixed bin(31) value('00000002'xn);
 dcl ENM_SCROLL              fixed bin(31) value('00000004'xn);
 dcl ENM_KEYEVENTS           fixed bin(31) value('00010000'xn);
 dcl ENM_MOUSEEVENTS         fixed bin(31) value('00020000'xn);
 dcl ENM_REQUESTRESIZE       fixed bin(31) value('00040000'xn);
 dcl ENM_SELCHANGE           fixed bin(31) value('00080000'xn);
 dcl ENM_DROPFILES           fixed bin(31) value('00100000'xn);
 dcl ENM_PROTECTED           fixed bin(31) value('00200000'xn);
 dcl ENM_CORRECTTEXT         fixed bin(31) value('00400000'xn);
     /* PenWin specific */
 dcl ENM_SCROLLEVENTS        fixed bin(31) value('00000008'xn);
 dcl ENM_DRAGDROPDONE        fixed bin(31) value('00000010'xn);
 dcl ENM_PARAGRAPHEXPANDED   fixed bin(31) value('00000020'xn);

 /* Far East specific notification mask */
 dcl ENM_IMECHANGE           fixed bin(31) value('00800000'xn);
     /* unused by RE2.0 */
 dcl ENM_LANGCHANGE          fixed bin(31) value('01000000'xn);
 dcl ENM_OBJECTPOSITIONS     fixed bin(31) value('02000000'xn);
 dcl ENM_LINK                fixed bin(31) value('04000000'xn);

 /* New edit control styles */

 dcl ES_SAVESEL              type DWORD value('00008000'xu);
 dcl ES_SUNKEN               type DWORD value('00004000'xu);
 dcl ES_DISABLENOSCROLL      type DWORD value('00002000'xu);
     /* same as WS_MAXIMIZE, but that doesn't make sense */
     /* so we re-use the value                           */
 dcl ES_SELECTIONBAR         type DWORD value('01000000'xu);
     /* same as ES_UPPERCASE, but re-used to completely disable */
     /* OLE drag'n'drop */
 dcl ES_NOOLEDRAGDROP        type DWORD value('00000008'xu);

 /* New edit control extended style */

 %if #WIN32 ^= '' %then %do;
 dcl ES_EX_NOCALLOLEINIT     type DWORD value('01000000'xu);
 %end;

 /* These flags are used in FE Windows */
 dcl ES_VERTICAL             type DWORD value('00400000'xu);
 dcl ES_NOIME                type DWORD value('00080000'xu);
 dcl ES_SELFIME              type DWORD value('00040000'xu);

 /* Edit control options */
 dcl ECO_AUTOWORDSELECTION   type UINT value('00000001'xu);
 dcl ECO_AUTOVSCROLL         type UINT value('00000040'xu);
 dcl ECO_AUTOHSCROLL         type UINT value('00000080'xu);
 dcl ECO_NOHIDESEL           type UINT value('00000100'xu);
 dcl ECO_READONLY            type UINT value('00000800'xu);
 dcl ECO_WANTRETURN          type UINT value('00001000'xu);
 dcl ECO_SAVESEL             type UINT value('00008000'xu);
 dcl ECO_SELECTIONBAR        type UINT value('01000000'xu);
 dcl ECO_VERTICAL            type UINT value('00400000'xu);
 /* FE specific */


 /* ECO operations */
 dcl ECOOP_SET               type UINT value('0001'xu);
 dcl ECOOP_OR                type UINT value('0002'xu);
 dcl ECOOP_AND               type UINT value('0003'xu);
 dcl ECOOP_XOR               type UINT value('0004'xu);

 /* new word break function actions */
 dcl WB_CLASSIFY             fixed bin(31) value(3);
 dcl WB_MOVEWORDLEFT         fixed bin(31) value(4);
 dcl WB_MOVEWORDRIGHT        fixed bin(31) value(5);
 dcl WB_LEFTBREAK            fixed bin(31) value(6);
 dcl WB_RIGHTBREAK           fixed bin(31) value(7);

 /* Far East specific flags */
 dcl WB_MOVEWORDPREV         fixed bin(31) value(4);
 dcl WB_MOVEWORDNEXT         fixed bin(31) value(5);
 dcl WB_PREVBREAK            fixed bin(31) value(6);
 dcl WB_NEXTBREAK            fixed bin(31) value(7);

 dcl PC_FOLLOWING            fixed bin(31) value(1);
 dcl PC_LEADING              fixed bin(31) value(2);
 dcl PC_OVERFLOW             fixed bin(31) value(3);
 dcl PC_DELIMITER            fixed bin(31) value(4);
 dcl WBF_WORDWRAP            fixed bin(31) value('010'xn);
 dcl WBF_WORDBREAK           fixed bin(31) value('020'xn);
 dcl WBF_OVERFLOW            fixed bin(31) value('040'xn);
 dcl WBF_LEVEL1              fixed bin(31) value('080'xn);
 dcl WBF_LEVEL2              fixed bin(31) value('100'xn);
 dcl WBF_CUSTOM              fixed bin(31) value('200'xn);

 /* Far East specific flags */
 dcl IMF_FORCENONE           fixed bin(31) value('0001'xn);
 dcl IMF_FORCEENABLE         fixed bin(31) value('0002'xn);
 dcl IMF_FORCEDISABLE        fixed bin(31) value('0004'xn);
 dcl IMF_CLOSESTATUSWINDOW   fixed bin(31) value('0008'xn);
 dcl IMF_VERTICAL            fixed bin(31) value('0020'xn);
 dcl IMF_FORCEACTIVE         fixed bin(31) value('0040'xn);
 dcl IMF_FORCEINACTIVE       fixed bin(31) value('0080'xn);
 dcl IMF_FORCEREMEMBER       fixed bin(31) value('0100'xn);
 dcl IMF_MULTIPLEEDIT        fixed bin(31) value('0400'xn);

 /* Word break flags (used with WB_CLASSIFY) */
 dcl WBF_CLASS      type BYTE value('0F'xn);
 dcl WBF_ISWHITE    type BYTE value('10'xn);
 dcl WBF_BREAKLINE  type BYTE value('20'xn);
 dcl WBF_BREAKAFTER type BYTE value('40'xn);


 /* new data types */


 /* extended edit word break proc (character set aware) */
 define alias EDITWORDBREAKPROCEX
        entry (pointer, /* to char (*) varz */
               type LONG,
               type BYTE,
               type INT)
        returns (type LONG byvalue optional)
        limited CALLBACK;
 /* Microsoft does not specify linkage CALLBACK !!! */
 /* In crash: use "options (byvalue nodescriptor linkage(cdecl))" */

 /* all character format measurements are in twips */
 define structure
   1 CHARFORMATA,
     2 cbSize          type UINT,
     2 dwMask          type DWORD,
     2 dwEffects       type DWORD,
     2 yHeight         type LONG,
     2 yOffset         type LONG,
     2 crTextColor     type COLORREF,
     2 bCharSet        type BYTE,
     2 bPitchAndFamily type BYTE,
     2 szFaceName      char(LF_FACESIZE-1) varz;

 define structure
   1 CHARFORMATW,
     2 cbSize          type UINT,
     2 dwMask          type DWORD,
     2 dwEffects       type DWORD,
     2 yHeight         type LONG,
     2 yOffset         type LONG,
     2 crTextColor     type COLORREF,
     2 bCharSet        type BYTE,
     2 bPitchAndFamily type BYTE,
     2 szFaceName      WCHAR (LF_FACESIZE-1) varz;

 %if #RICHEDIT_VER >= 512 %then %do;
 %if UNICODE ^= '' %then %do;
 define alias CHARFORMAT type CHARFORMATW;
 %end; %else %do;
 define alias CHARFORMAT type CHARFORMATA;
 %end; /* UNICODE */
 %end; %else %do;
 define alias CHARFORMAT type CHARFORMATA;
 %end; /* _RICHEDIT_VER >= 0x0200 */

 /* CHARFORMAT masks */
 dcl CFM_BOLD      type DWORD value('00000001'xu);
 dcl CFM_ITALIC    type DWORD value('00000002'xu);
 dcl CFM_UNDERLINE type DWORD value('00000004'xu);
 dcl CFM_STRIKEOUT type DWORD value('00000008'xu);
 dcl CFM_PROTECTED type DWORD value('00000010'xu);
 dcl CFM_LINK      type DWORD value('00000020'xu);
     /* Exchange hyperlink extension */
 dcl CFM_SIZE      type DWORD value('80000000'xu);
 dcl CFM_COLOR     type DWORD value('40000000'xu);
 dcl CFM_FACE      type DWORD value('20000000'xu);
 dcl CFM_OFFSET    type DWORD value('10000000'xu);
 dcl CFM_CHARSET   type DWORD value('08000000'xu);

 /* CHARFORMAT effects */
 dcl CFE_BOLD      type DWORD value('0001'xu);
 dcl CFE_ITALIC    type DWORD value('0002'xu);
 dcl CFE_UNDERLINE type DWORD value('0004'xu);
 dcl CFE_STRIKEOUT type DWORD value('0008'xu);
 dcl CFE_PROTECTED type DWORD value('0010'xu);
 dcl CFE_LINK      type DWORD value('0020'xu);
 dcl CFE_AUTOCOLOR type DWORD value('40000000'xu);
 /* NOTE: this corresponds to CFM_COLOR, which controls it */
 dcl yHeightCharPtsMost fixed bin(31) value(1638);

 /* EM_SETCHARFORMAT wParam masks */
 dcl SCF_SELECTION     type UINT value('0001'xu);
 dcl SCF_WORD          type UINT value('0002'xu);
 dcl SCF_DEFAULT       type UINT value('0000'xu);
     /* set the default charformat or paraformat */
 dcl SCF_ALL           type UINT value('0004'xu);
     /* not valid with SCF_SELECTION or SCF_WORD */
 dcl SCF_USEUIRULES    type UINT value('0008'xu);
     /* modifier for SCF_SELECTION; says that the format came from a */
     /* toolbar, etc. and therefore UI formatting rules should be    */
     /* used instead of strictly formatting the selection.           */
 dcl SCF_ASSOCIATEFONT type UINT value('0010'xu);
     /* Associate fontname with bCharSet                 */
     /* (one possible for each of Western, ME, FE, Thai) */
 dcl SCF_NOKBUPDATE    type UINT value('0020'xu);
     /* Do not update the KB layout for this change */
     /* even if autokeyboard is on.                 */


 define structure
   1 CHARRANGE,
     2 cpMin type LONG,
     2 cpMax type LONG;

 define structure
   1 TEXTRANGEA,
     2 chrg      type CHARRANGE,
     2 lpstrText type LPSTR;
       /* allocated by caller, zero terminated by RichEdit */

 define structure
   1 TEXTRANGEW,
     2 chrg      type CHARRANGE,
     2 lpstrText type LPWSTR;
       /* allocated by caller, zero terminated by RichEdit */

 %if #RICHEDIT_VER >= 512 %then %do;

 %if UNICODE ^= '' %then %do;
 define alias TEXTRANGE type TEXTRANGEW;
 %end; %else %do;
 define alias TEXTRANGE type TEXTRANGEA;
 %end; /* UNICODE */
 %end; %else %do;
 define alias TEXTRANGE type TEXTRANGEA;
 %end; /* _RICHEDIT_VER >= 0x0200 */


 define alias EDITSTREAMCALLBACK
              entry (type DWORD,
                     type LPBYTE,
                     type LONG,
                     type LONG byaddr)
              returns (type DWORD byvalue optional)
              limited CALLBACK;

 define structure
   1 EDITSTREAM,
     2 dwCookie    type DWORD,
       /* user value passed to callback as first parameter */
     2 dwError     type DWORD,/* last error */
     2 pfnCallback type EDITSTREAMCALLBACK;

 /* stream formats */

 dcl SF_TEXT              type UINT value('0001'xu);
 dcl SF_RTF               type UINT value('0002'xu);
 dcl SF_RTFNOOBJS         type UINT value('0003'xu); /* Write only*/
 dcl SF_TEXTIZED          type UINT value('0004'xu); /* Write only*/
 dcl SF_UNICODE           type UINT value('0010'xu);
     /* Unicode file (UCS2 little endian) */
 dcl SF_USECODEPAGE       type UINT value('0020'xu);
     /* CodePage given by high word */

 /* Flag telling stream operations to operate on the selection only */
 /* EM_STREAMIN will replace the current selection                  */
 /* EM_STREAMOUT will stream out the current selection              */
 dcl SFF_SELECTION        type UINT value('8000'xu);

 /* Flag telling stream operations to operate on the common RTF */
 /* keyword only                                                */
 /* EM_STREAMIN will accept the only common RTF keyword         */
 /* EM_STREAMOUT will stream out the only common RTF keyword    */
 dcl SFF_PLAINRTF         type UINT value('4000'xu);

 /* Flag telling file stream output (SFF_SELECTION flag not set) */
 /* to persist \viewscaleN control word.                         */
 dcl SFF_PERSISTVIEWSCALE type UINT value('2000'xu);

 /* Flag telling file stream input with SFF_SELECTION flag not set */
 /* not to close the document                                      */
 dcl SFF_KEEPDOCINFO      type UINT value('1000'xu);

 /* Flag telling stream operations to output in Pocket Word format */
 dcl SFF_PWD              type UINT value('0800'xu);

 /* 3-bit field specifying the value of N-1 to use for \rtfN or \pwdN */
 dcl SF_RTFVAL            type UINT value('0700'xu);

 define structure
   1 FINDTEXTA,
     2 chrg      type CHARRANGE,
     2 lpstrText type LPSTR;

 define structure
   1 FINDTEXTW,
     2 chrg      type CHARRANGE,
     2 lpstrText type LPWSTR;

 %if #RICHEDIT_VER >= 512 %then %do;
 %if UNICODE ^= '' %then %do;
 define alias FINDTEXT type FINDTEXTW;
 %end; %else %do;
 define alias FINDTEXT type FINDTEXTA;
 %end; /* UNICODE */
 %end; %else %do;
 define alias FINDTEXT type FINDTEXTA;
 %end; /* _RICHEDIT_VER >= 0x0200 */

 define structure
   1 FINDTEXTEXA,
     2 chrg      type CHARRANGE,
     2 lpstrText type LPSTR,
     2 chrgText  type CHARRANGE;

 define structure
   1 FINDTEXTEXW,
     2 chrg      type CHARRANGE,
     2 lpstrText type LPWSTR,
     2 chrgText  type CHARRANGE;


 %if #RICHEDIT_VER >= 512 %then %do;
 %if UNICODE ^= '' %then %do;
 define alias FINDTEXTEX type FINDTEXTEXW;
 %end; %else %do;
 define alias FINDTEXTEX type FINDTEXTEXA;
 %end; /* UNICODE */
 %end; %else %do;
 define alias FINDTEXTEX type FINDTEXTEXA;
 %end; /* _RICHEDIT_VER >= 0x0200 */


 define structure
   1 FORMATRANGE,
     2 hdc       type HDC,
     2 hdcTarget type HDC,
     2 rc        type RECT,
     2 rcPage    type RECT,
     2 chrg      type CHARRANGE;

 /* all paragraph measurements are in twips */

 dcl MAX_TAB_STOPS fixed bin(31) value(32);
 dcl lDefaultTab   fixed bin(31) value(720);

 define structure
   1 PARAFORMAT,
     2 cbSize        type UINT,
     2 dwMask        type DWORD,
     2 wNumbering    type WORD,
     2 wEffects      type WORD,
     2 dxStartIndent type LONG,
     2 dxRightIndent type LONG,
     2 dxOffset      type LONG,
     2 wAlignment    type WORD,
     2 cTabCount     type SHORT,
     2 rgxTabs (MAX_TAB_STOPS) type LONG;

 /* PARAFORMAT mask values */
 dcl PFM_STARTINDENT  type DWORD value('00000001'xu);
 dcl PFM_RIGHTINDENT  type DWORD value('00000002'xu);
 dcl PFM_OFFSET       type DWORD value('00000004'xu);
 dcl PFM_ALIGNMENT    type DWORD value('00000008'xu);
 dcl PFM_TABSTOPS     type DWORD value('00000010'xu);
 dcl PFM_NUMBERING    type DWORD value('00000020'xu);
 dcl PFM_OFFSETINDENT type DWORD value('80000000'xu);

 /* PARAFORMAT numbering options */
 dcl PFN_BULLET       type WORD value('0001'xn);

 /* PARAFORMAT alignment options */
 dcl PFA_LEFT         type WORD value('0001'xn);
 dcl PFA_RIGHT        type WORD value('0002'xn);
 dcl PFA_CENTER       type WORD value('0003'xn);

 /* CHARFORMAT2 and PARAFORMAT2 structures */

 define structure
   1 CHARFORMAT2W,
     2 cbSize          type UINT,
     2 dwMask          type DWORD,
     2 dwEffects       type DWORD,
     2 yHeight         type LONG,
     2 yOffset         type LONG,
       /* > 0 for superscript, < 0 for subscript */
     2 crTextColor     type COLORREF,
     2 bCharSet        type BYTE,
     2 bPitchAndFamily type BYTE,
     2 szFaceName      WCHAR (LF_FACESIZE-1) varz,
     2 wWeight         type WORD, /* Font weight (LOGFONT value) */
     2 sSpacing        type SHORT,/* Amount to space between letters */
     2 crBackColor     type COLORREF,/* Background color */
     2 lcid            type LCID, /* Locale ID */
     2 dwReserved      type DWORD,/* Reserved. Must be 0 */
     2 sStyle          type SHORT,/* Style handle */
     2 wKerning        type WORD,
       /* Twip size above which to kern char pair*/
     2 bUnderlineType  type BYTE, /* Underline type */
     2 bAnimation      type BYTE, /* Animated text like marching ants */
     2 bRevAuthor      type BYTE, /* Revision author index */
     2 bReserved1      type BYTE;

 define structure
   1 CHARFORMAT2A,
     2 cbSize          type UINT,
     2 dwMask          type DWORD,
     2 dwEffects       type DWORD,
     2 yHeight         type LONG,
     2 yOffset         type LONG,
       /* > 0 for superscript, < 0 for subscript */
     2 crTextColor     type COLORREF,
     2 bCharSet        type BYTE,
     2 bPitchAndFamily type BYTE,
     2 szFaceName      char(LF_FACESIZE-1) varz,
     2 wWeight         type WORD, /* Font weight (LOGFONT value) */
     2 sSpacing        type SHORT,/* Amount to space between letters */
     2 crBackColor     type COLORREF,/* Background color */
     2 lcid            type LCID, /* Locale ID */
     2 dwReserved      type DWORD,/* Reserved. Must be 0 */
     2 sStyle          type SHORT,/* Style handle */
     2 wKerning        type WORD,
       /* Twip size above which to kern char pair*/
     2 bUnderlineType  type BYTE, /* Underline type */
     2 bAnimation      type BYTE, /* Animated text like marching ants */
     2 bRevAuthor      type BYTE; /* Revision author index */


 %if UNICODE ^= '' %then %do;
 define alias CHARFORMAT2 type CHARFORMAT2W;
 %end; %else %do;
 define alias CHARFORMAT2 type CHARFORMAT2A;
 %end;

 dcl CHARFORMATDELTA   fixed bin(31)
     value (size(: CHARFORMAT2 :) - size(: CHARFORMAT :));


 /* CHARFORMAT and PARAFORMAT "ALL" masks                          */
 /*  CFM_COLOR mirrors CFE_AUTOCOLOR, a little hack to easily deal */
 /*  with autocolor                                                */

 dcl CFM_EFFECTS type DWORD
     value (ior (CFM_BOLD, CFM_ITALIC, CFM_UNDERLINE, CFM_COLOR,
                 CFM_STRIKEOUT, CFE_PROTECTED, CFM_LINK));
 dcl CFM_ALL     type DWORD
     value (ior (CFM_EFFECTS, CFM_SIZE, CFM_FACE, CFM_OFFSET,
                 CFM_CHARSET));

 /* New masks and effects -- a parenthesized asterisk indicates that */
 /*  the data is stored by RichEdit2.0/3.0, but not displayed        */

 dcl CFM_SMALLCAPS     type DWORD value('0040'xu); /* (*)   */
 dcl CFM_ALLCAPS       type DWORD value('0080'xu);
     /* Displayed by 3.0 */
 dcl CFM_HIDDEN        type DWORD value('0100'xu); /* Hidden by 3.0*/
 dcl CFM_OUTLINE       type DWORD value('0200'xu); /* (*)   */
 dcl CFM_SHADOW        type DWORD value('0400'xu); /* (*)   */
 dcl CFM_EMBOSS        type DWORD value('0800'xu); /* (*)   */
 dcl CFM_IMPRINT       type DWORD value('1000'xu); /* (*)   */
 dcl CFM_DISABLED      type DWORD value('2000'xu);
 dcl CFM_REVISED       type DWORD value('4000'xu);

 dcl CFM_BACKCOLOR     type DWORD value('04000000'xu);
 dcl CFM_LCID          type DWORD value('02000000'xu);
 dcl CFM_UNDERLINETYPE type DWORD value('00800000'xu);
     /* Many displayed by 3.0 */
 dcl CFM_WEIGHT        type DWORD value('00400000'xu);
 dcl CFM_SPACING       type DWORD value('00200000'xu);
     /* Displayed by 3.0 */
 dcl CFM_KERNING       type DWORD value('00100000'xu); /* (*)   */
 dcl CFM_STYLE         type DWORD value('00080000'xu); /* (*)   */
 dcl CFM_ANIMATION     type DWORD value('00040000'xu); /* (*)   */
 dcl CFM_REVAUTHOR     type DWORD value('00008000'xu);

 /* Superscript and subscript are mutually exclusive */
 dcl CFE_SUBSCRIPT     type DWORD value('00010000'xu);
 dcl CFE_SUPERSCRIPT   type DWORD value('00020000'xu);


 dcl CFM_SUBSCRIPT	    type DWORD
     value (ior (CFE_SUBSCRIPT, CFE_SUPERSCRIPT));

 dcl CFM_SUPERSCRIPT   type DWORD value(CFM_SUBSCRIPT);

 dcl CFM_EFFECTS2      type DWORD
     value (ior (CFM_EFFECTS, CFM_DISABLED, CFM_SMALLCAPS, CFM_ALLCAPS,
                 CFM_HIDDEN, CFM_OUTLINE, CFM_SHADOW, CFM_EMBOSS,
                 CFM_IMPRINT, CFM_DISABLED, CFM_REVISED,
                 CFM_SUBSCRIPT, CFM_SUPERSCRIPT, CFM_BACKCOLOR));

 dcl CFM_ALL2	       type DWORD
     value (ior (CFM_ALL, CFM_EFFECTS2, CFM_BACKCOLOR, CFM_LCID,
                 CFM_UNDERLINETYPE, CFM_WEIGHT, CFM_REVAUTHOR,
                 CFM_SPACING, CFM_KERNING, CFM_STYLE, CFM_ANIMATION));

 dcl CFE_SMALLCAPS     type DWORD value(CFM_SMALLCAPS);
 dcl CFE_ALLCAPS       type DWORD value(CFM_ALLCAPS);
 dcl CFE_HIDDEN        type DWORD value(CFM_HIDDEN);
 dcl CFE_OUTLINE       type DWORD value(CFM_OUTLINE);
 dcl CFE_SHADOW        type DWORD value(CFM_SHADOW);
 dcl CFE_EMBOSS        type DWORD value(CFM_EMBOSS);
 dcl CFE_IMPRINT       type DWORD value(CFM_IMPRINT);
 dcl CFE_DISABLED      type DWORD value(CFM_DISABLED);
 dcl CFE_REVISED       type DWORD value(CFM_REVISED);

 /* NOTE: CFE_AUTOCOLOR and CFE_AUTOBACKCOLOR correspond to CFM_COLOR */
 /*       and CFM_BACKCOLOR, respectively, which control them         */
 dcl CFE_AUTOBACKCOLOR type DWORD value(CFM_BACKCOLOR);

 /* Underline types */
 dcl CFU_CF1UNDERLINE        type BYTE value('FF'xn);
     /* map charformat's bit underline to CF2.*/
 dcl CFU_INVERT              type BYTE value('FE'xn);
     /* For IME composition fake a selection.*/
 dcl CFU_UNDERLINEHAIRLINE   type BYTE value(10); /* (*) */
     /* displayed as ordinary underline */
 dcl CFU_UNDERLINETHICK      type BYTE value(9);
 dcl CFU_UNDERLINEWAVE       type BYTE value(8);
 dcl CFU_UNDERLINEDASHDOTDOT type BYTE value(7);
 dcl CFU_UNDERLINEDASHDOT    type BYTE value(6);
 dcl CFU_UNDERLINEDASH       type BYTE value(5);
 dcl CFU_UNDERLINEDOTTED     type BYTE value(4); /* (*)   */
     /* displayed as ordinary underline */
 dcl CFU_UNDERLINEDOUBLE     type BYTE value(3); /* (*)   */
     /* displayed as ordinary underline */
 dcl CFU_UNDERLINEWORD       type BYTE value(2); /* (*)   */
     /* displayed as ordinary underline */
 dcl CFU_UNDERLINE           type BYTE value(1);
 dcl CFU_UNDERLINENONE       type BYTE value(0);

 define structure
   1 PARAFORMAT2,
		 2 cbSize           type UINT,
     2 dwMask           type DWORD,
     2 wNumbering       type WORD,
 %if #RICHEDIT_VER >= 528 %then %do;
     2 wEffects         type WORD,
 %end; %else %do;
     2 wReserved        type WORD,
 %end; /* _RICHEDIT_VER >= 0x0210 */
     2 dxStartIndent    type LONG,
     2 dxRightIndent    type LONG,
     2 dxOffset         type LONG,
     2 wAlignment       type WORD,
     2 cTabCount        type SHORT,
     2 rgxTabs (MAX_TAB_STOPS) type LONG,
     2 dySpaceBefore    type LONG,
       /* Vertical spacing before para           */
     2 dySpaceAfter     type LONG,
       /* Vertical spacing after para            */
     2 dyLineSpacing    type LONG,
       /* Line spacing depending on Rule         */
     2 sStyle           type SHORT,
       /* Style handle                           */
     2 bLineSpacingRule type BYTE,
       /* Rule for line spacing (see tom.doc)    */
     2 bCRC             type BYTE,
       /* Reserved for CRC for rapid searching   */
     2 wShadingWeight   type WORD,
       /* Shading in hundredths of a per cent    */
     2 wShadingStyle    type WORD,
       /* Nibble 0: style, 1: cfpat, 2: cbpat    */
     2 wNumberingStart  type WORD,
       /* Starting value for numbering           */
     2 wNumberingStyle  type WORD,
       /* Alignment, roman/arabic, (), ), ., etc.*/
     2 wNumberingTab    type WORD,
       /* Space bet 1st indent and 1st-line text */
     2 wBorderSpace     type WORD,
       /* Space between border and text (twips)  */
     2 wBorderWidth     type WORD,
       /* Border pen width (twips)               */
     2 wBorders         type WORD;
       /* Byte 0: bits specify which borders     */
       /* Nibble 2: border style, 3: color index */


 /* PARAFORMAT 2.0 masks and effects */

 dcl PFM_SPACEBEFORE     type DWORD value('00000040'xu);
 dcl PFM_SPACEAFTER      type DWORD value('00000080'xu);
 dcl PFM_LINESPACING     type DWORD value('00000100'xu);
 dcl PFM_STYLE           type DWORD value('00000400'xu);
 dcl PFM_BORDER          type DWORD value('00000800'xu); /* (*)    */
 dcl PFM_SHADING         type DWORD value('00001000'xu); /* (*)    */
 dcl PFM_NUMBERINGSTYLE  type DWORD value('00002000'xu); /* RE 3.0 */
 dcl PFM_NUMBERINGTAB    type DWORD value('00004000'xu); /* RE 3.0 */
 dcl PFM_NUMBERINGSTART  type DWORD value('00008000'xu); /* RE 3.0 */

 dcl PFM_RTLPARA         type DWORD value('00010000'xu);
 dcl PFM_KEEP            type DWORD value('00020000'xu); /* (*)    */
 dcl PFM_KEEPNEXT        type DWORD value('00040000'xu); /* (*)    */
 dcl PFM_PAGEBREAKBEFORE type DWORD value('00080000'xu); /* (*)    */
 dcl PFM_NOLINENUMBER    type DWORD value('00100000'xu); /* (*)    */
 dcl PFM_NOWIDOWCONTROL  type DWORD value('00200000'xu); /* (*)    */
 dcl PFM_DONOTHYPHEN     type DWORD value('00400000'xu); /* (*)    */
 dcl PFM_SIDEBYSIDE      type DWORD value('00800000'xu); /* (*)    */
 dcl PFM_TABLE           type DWORD value('c0000000'xu); /* RE 3.0 */

 /* The following three properties are read only */
 dcl PFM_COLLAPSED       type DWORD value('01000000'xu); /* RE 3.0 */
 dcl PFM_OUTLINELEVEL    type DWORD value('02000000'xu); /* RE 3.0 */
 dcl PFM_BOX             type DWORD value('04000000'xu); /* RE 3.0 */

 /* Note: PARAFORMAT has no effects */
 dcl PFM_EFFECTS         type DWORD
     value (ior (PFM_RTLPARA, PFM_KEEP, PFM_KEEPNEXT, PFM_TABLE,
                 PFM_PAGEBREAKBEFORE, PFM_NOLINENUMBER,
                 PFM_NOWIDOWCONTROL, PFM_DONOTHYPHEN, PFM_SIDEBYSIDE,
                 PFM_TABLE));

 dcl PFM_ALL             type DWORD
     value (ior (PFM_STARTINDENT, PFM_RIGHTINDENT, PFM_OFFSET,
                 PFM_ALIGNMENT, PFM_TABSTOPS, PFM_NUMBERING,
                 PFM_OFFSETINDENT, PFM_RTLPARA));

 dcl PFM_ALL2	         type DWORD
     value (ior (PFM_ALL, PFM_EFFECTS, PFM_SPACEBEFORE, PFM_SPACEAFTER,
                 PFM_LINESPACING, PFM_STYLE, PFM_SHADING, PFM_BORDER,
                 PFM_NUMBERINGTAB, PFM_NUMBERINGSTART,
                 PFM_NUMBERINGSTYLE));


 dcl PFE_RTLPARA         type DWORD
                         value(isrl(PFM_RTLPARA,16));
 dcl PFE_KEEP            type DWORD                      /* (*)   */
                         value(isrl(PFM_KEEP,16));
 dcl PFE_KEEPNEXT        type DWORD                      /* (*)   */
                         value(isrl(PFM_KEEPNEXT,16));
 dcl PFE_PAGEBREAKBEFORE type DWORD                      /* (*)   */
                         value(isrl(PFM_PAGEBREAKBEFORE, 16));
 dcl PFE_NOLINENUMBER    type DWORD                      /* (*)   */
                         value(isrl(PFM_NOLINENUMBER,16));
 dcl PFE_NOWIDOWCONTROL  type DWORD                      /* (*)   */
                         value(isrl(PFM_NOWIDOWCONTROL,16));
 dcl PFE_DONOTHYPHEN     type DWORD                      /* (*)   */
                         value(isrl(PFM_DONOTHYPHEN,16));
 dcl PFE_SIDEBYSIDE      type DWORD                      /* (*)   */
                         value(isrl(PFM_SIDEBYSIDE,16));

 /* The following three effects are read only */
 dcl PFE_OUTLINELEVEL    type DWORD                      /* (+)   */
                         value(isrl(PFM_OUTLINELEVEL, 16));
 dcl PFE_COLLAPSED       type DWORD                      /* (+)   */
                         value(isrl(PFM_COLLAPSED, 16));
 dcl PFE_BOX             type DWORD                      /* (+)   */
                         value(isrl(PFM_BOX, 16));

 dcl PFE_TABLE           type DWORD value('4000'xu);
     /* that para is part of a table*/

 /* PARAFORMAT2 wNumbering options (see also PFN_BULLET) */
 dcl PFN_ARABIC          type WORD value(2);
     /* tomListNumberAsArabic:   0, 1, 2,   ...*/
 dcl PFN_LCLETTER        type WORD value(3);
     /* tomListNumberAsLCLetter: a, b, c,   ...*/
 dcl PFN_UCLETTER        type WORD value(4);
     /* tomListNumberAsUCLetter: A, B, C,   ...*/
 dcl PFN_LCROMAN         type WORD value(5);
     /* tomListNumberAsLCRoman:  i, ii, iii,   ...*/
 dcl PFN_UCROMAN         type WORD value(6);
     /* tomListNumberAsUCRoman:  I, II, III,   ...*/

 /* PARAFORMAT2 wNumberingStyle options */
 dcl PFNS_PAREN          type WORD value('0000'xu);
     /* default, e.g.,            1)  */
 dcl PFNS_PARENS         type WORD value('0100'xu);
     /* tomListParentheses/256, e.g., (1)   */
 dcl PFNS_PERIOD         type WORD value('0200'xu);
     /* tomListPeriod/256, e.g.,        1.  */
 dcl PFNS_PLAIN          type WORD value('0300'xu);
     /* tomListPlain/256, e.g.,      1      */
 dcl PFNS_NONUMBER       type WORD value('0400'xu);
     /* Used for continuation w/o number    */

 dcl PFA_JUSTIFY          type WORD value(4);
     /* New paragraph-alignment option 2.0 (*) */
 dcl PFA_FULL_INTERWORD   type WORD value(4);
 dcl PFA_FULL_INTERLETTER type WORD value(5);
 dcl PFA_FULL_SCALED      type WORD value(6);
 dcl PFA_FULL_GLYPHS      type WORD value(7);
 dcl PFA_SNAP_GRID        type WORD value(8);


 /* notification structures */

 %dcl #WM_NOTIFY char ext;
 %if #WM_NOTIFY = '' %then %do;
 %#WM_NOTIFY = 'Y';
 dcl WM_NOTIFY fixed bin(15) value('004E'xn);

 define structure
   1 NMHDR,
     2 hwndFrom type HWND,
     2 idFrom   type UINT,
     2 code     type UINT;
 %end; /* !WM_NOTIFY */

 define structure
   1 MSGFILTER,
     2 nmhdr    type NMHDR,
     2 msg      type UINT,
     2 wParam   type WPARAM,
     2 lParam   type LPARAM;

 define structure
   1 REQRESIZE,
     2 nmhdr    type NMHDR,
     2 rc       type RECT;

 define structure
   1 SELCHANGE,
     2 nmhdr    type NMHDR,
     2 chrg     type CHARRANGE,
     2 seltyp   type WORD;

 dcl SEL_EMPTY       type WORD value('0000'xu);
 dcl SEL_TEXT        type WORD value('0001'xu);
 dcl SEL_OBJECT      type WORD value('0002'xu);
 dcl SEL_MULTICHAR   type WORD value('0004'xu);
 dcl SEL_MULTIOBJECT type WORD value('0008'xu);

 /* used with IRichEditOleCallback::GetContextMenu, this flag will be */
 /* passed as a "selection type".  It indicates that a context menu   */
 /* for a right-mouse drag drop should be generated.  The IOleObject  */
 /* parameter will really be the IDataObject for the drop             */
 dcl GCM_RIGHTMOUSEDROP fixed bin(31) value('8000'xn);

 define structure
   1 ENDROPFILES,
     2 nmhdr        type NMHDR,
     2 hDrop        type HANDLE,
     2 cp           type LONG,
     2 fProtected   type BOOL;

 define structure
   1 ENPROTECTED,
     2 nmhdr        type NMHDR,
     2 msg          type UINT,
     2 wParam       type WPARAM,
     2 lParam       type LPARAM,
     2 chrg         type CHARRANGE;

 define structure
   1 ENSAVECLIPBOARD,
     2 nmhdr        type NMHDR,
     2 cObjectCount type LONG,
     2 cch          type LONG;

 define structure
   1 ENOLEOPFAILED,
     2 nmhdr        type NMHDR,
     2 iob          type LONG,
     2 lOper        type LONG,
     2 hr           type HRESULT;

 dcl OLEOP_DOVERB fixed bin(31) value(1);

 define structure
   1 OBJECTPOSITIONS,
     2 nmhdr        type NMHDR,
     2 cObjectCount type LONG,
     2 pcpPositions pointer;   /* to (*) type LONG */

 define structure
   1 ENLINK,
     2 nmhdr        type NMHDR,
     2 msg          type UINT,
     2 wParam       type WPARAM,
     2 lParam       type LPARAM,
     2 chrg         type CHARRANGE;

 /* PenWin specific */
 define structure
   1 ENCORRECTTEXT,
     2 nmhdr        type NMHDR,
     2 chrg         type CHARRANGE,
     2 seltyp       type WORD;

 /* Far East specific */
 define structure
   1 PUNCTUATION,
     2 iSize         type UINT,
     2 szPunctuation type LPSTR;

 /* Far East specific */
 define structure
   1 COMPCOLOR,
     2 crText       type COLORREF,
     2 crBackground type COLORREF,
     2 dwEffects    type DWORD;


 /* clipboard formats - use as parameter to RegisterClipboardFormat() */
 dcl CF_RTF       TCHAR value('Rich Text Format');
 dcl CF_RTFNOOBJS TCHAR value('Rich Text Format Without Objects');
 dcl CF_RETEXTOBJ TCHAR value('RichEdit Text and Objects');

 /* Paste Special */
 define structure
   1 REPASTESPECIAL,
     2 dwAspect type DWORD,
     2 dwParam  type DWORD;

 /* UndoName info */
 define ordinal
   UNDONAMEID
     ( UID_UNKNOWN  value(0),
       UID_TYPING   value(1),
       UID_DELETE   value(2),
       UID_DRAGDROP value(3),
       UID_CUT      value(4),
       UID_PASTE    value(5)
     ) precision (31);

 /* flags for the GETEXTEX data structure */
 dcl GT_DEFAULT fixed bin(31) value(0);
 dcl GT_USECRLF fixed bin(31) value(1);

 /* EM_GETTEXTEX info                                  */
 /* this struct is passed in the wparam of the message */
 define structure
   1 GETTEXTEX,
     2 cb            type DWORD,/* count of bytes in the string */
     2 flags         type DWORD,/* flags (see the GT_XXX defines */
     2 codepage      type UINT, /* code page for translation */
                     /* (CP_ACP for default, 1200 for Unicode */
     2 lpDefaultChar type LPCSTR,/* replacement for unmappable chars */
     2 lpUsedDefChar type LPBOOL;
       /* pointer to flag set when def char used */

 /* flags for the GETTEXTLENGTHEX data structure */
 dcl GTL_DEFAULT  type DWORD value(0);
     /* do the default (return # of chars) */
 dcl GTL_USECRLF  type DWORD value(1);
     /* compute answer using CRLFs for paragraphs */
 dcl GTL_PRECISE  type DWORD value(2);
     /* compute a precise answer */
 dcl GTL_CLOSE    type DWORD value(4);
     /* fast computation of a "close" answer  */
 dcl GTL_NUMCHARS type DWORD value(8);
     /* return the number of characters */
 dcl GTL_NUMBYTES type DWORD value(16);
     /* return the number of _bytes_ */

 /* EM_GETTEXTLENGTHEX info                        */
 /* this struct is passed in the wparam of the msg */
 define structure
   1 GETTEXTLENGTHEX,
     2 flags    type DWORD,/* flags (see GTL_XXX defines) */
     2 codepage type UINT; /* code page for translation */
                           /* (CP_ACP for default, 1200 for Unicode */

 /* BiDi specific features */
 define structure
   1 BIDIOPTIONS,
     2 cbSize   type UINT,
     2 wMask    type WORD,
     2 wEffects type WORD;

 /* BIDIOPTIONS masks */
 %if #RICHEDIT_VER = 256 %then %do;
 dcl BOM_DEFPARADIR       type WORD value('0001'xu);
     /* Default paragraph direction (implies alignment) (obsolete) */
 dcl BOM_PLAINTEXT        type WORD value('0002'xu);
     /* Use plain text layout (obsolete) */
 dcl BOM_NEUTRALOVERRIDE  type WORD value('0004'xu);
     /* Override neutral layout (obsolete) */
 %end; /* _RICHEDIT_VER == 0x0100 */
 dcl BOM_CONTEXTREADING   type WORD value('0008'xu);
     /* Context reading order */
 dcl BOM_CONTEXTALIGNMENT type WORD value('0010'xu);
     /* Context alignment */

 /* BIDIOPTIONS effects */
 %if #RICHEDIT_VER = 256 %then %do;
 dcl BOE_RTLDIR           type WORD value('0001'xu);
     /* Default paragraph direction (implies alignment) (obsolete) */
 dcl BOE_PLAINTEXT        type WORD value('0002'xu);
     /* Use plain text layout (obsolete) */
 dcl BOE_NEUTRALOVERRIDE  type WORD value('0004'xu);
     /* Override neutral layout (obsolete) */
 %end; /* _RICHEDIT_VER == 0x0100 */
 dcl BOE_CONTEXTREADING   type WORD value('0008'xu);
     /* Context reading order */
 dcl BOE_CONTEXTALIGNMENT type WORD value('0010'xu);
     /* Context alignment */

 /* Additional EM_FINDTEXT[EX] flags */
 dcl FR_MATCHDIAC      type UINT value('20000000'xu);
 dcl FR_MATCHKASHIDA   type UINT value('40000000'xu);
 dcl FR_MATCHALEFHAMZA type UINT value('80000000'xu);

 /* UNICODE embedding character */
 %dcl #WCH_EMBEDDING char ext;
 %if #WCH_EMBEDDING = '' %then %do;
 %#WCH_EMBEDDING = 'Y';
 dcl WCH_EMBEDDING WCHAR value('FFFC'WX);
 %end; /* WCH_EMBEDDING */

 %end; /* !_RICHEDIT_ */

