 /*********************************************************************/
 /*                                                                   */
 /* shellapi.cpy - SHELL.DLL functions, types, and definitions        */
 /*                                                                   */
 /* Copyright 1992 - 1998 Microsoft Corp.  All rights reserved        */
 /*                                                                   */
 /*********************************************************************/

 %dcl #INC_SHELLAPI char ext;
 %if #INC_SHELLAPI = '' %then %do;
 %#INC_SHELLAPI = 'Y';

 /* Pull in WINUSER.CPY if necessary */
 %dcl #WINUSER_ char ext;
 %if #WINUSER_ = '' %then %do;
   %include winuser;
 %end;

 %dcl UNICODE char ext;
 %dcl WINVER  fixed ext;
 %dcl WINNT   char ext;
 %dcl #WIN32_IE fixed ext;

 %dcl WINSHELLAPI char ext;
 %WINSHELLAPI = '';

 %dcl SHSTDAPI char ext;
 %if SHSTDAPI = '' %then %do;
   %SHSTDAPI = 'STDAPI';
   %dcl SHSTDAPI_ entry;
   %SHSTDAPI_: proc (type) returns (char);
     dcl type char;
     return (STDAPI_(type));
   %end SHSTDAPI_;
 %end; /* SHSTDAPI */

 %dcl SHDOCAPI char ext;
 %if SHDOCAPI = '' %then %do;
   %SHDOCAPI = 'STDAPI';
   %dcl SHDOCAPI_ entry;
   %SHDOCAPI_: proc (type) returns (char);
     dcl type char;
     return (STDAPI_(type));
   %end SHDOCAPI_;
 %end;/* SHDOCAPI */


 DECLARE_HANDLE(HDROP);

 dcl DragQueryFileA
     entry (type HDROP,
            type UINT,
            char (*) varz byaddr optional,
            type UINT)
     returns (type UINT byvalue optional)
     WINSHELLAPI APIENTRY external('DragQueryFileA');
 dcl DragQueryFileW
     entry (type HDROP,
            type UINT,
            WCHAR (*) varz byaddr optional,
            type UINT)
     returns (type UINT byvalue optional)
     WINSHELLAPI APIENTRY external('DragQueryFileW');
 %dcl DragQueryFile char ext;
 %if UNICODE ^= '' %then %do;
   %DragQueryFile='DragQueryFileW';
 %end; %else %do;
   %DragQueryFile='DragQueryFileA';
 %end; /* !UNICODE */

 dcl DragQueryPoint
     entry (type HDROP,
            type POINT byaddr)
     returns (type BOOL byvalue optional)
     WINSHELLAPI APIENTRY external('DragQueryPoint');

 dcl DragFinish
     entry (type HDROP )
     WINSHELLAPI APIENTRY external('DragFinish');

 dcl DragAcceptFiles
     entry (type HWND,
            type BOOL)
     returns (type VOID byvalue optional)
     WINSHELLAPI APIENTRY external('DragAcceptFiles');

 dcl ShellExecuteA
     entry (type HWND,
            char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr nonasgn optional,
            type INT)
     returns (type HINSTANCE byvalue optional)
     WINSHELLAPI APIENTRY external('ShellExecuteA');
 dcl ShellExecuteW entry (
            type HWND,
            WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn optional,
            type INT)
     returns (type HINSTANCE byvalue optional)
     WINSHELLAPI APIENTRY external('ShellExecuteW');
 %dcl ShellExecute char ext;
 %if UNICODE ^= '' %then %do;
   %ShellExecute='ShellExecuteW';
 %end; %else %do;
   %ShellExecute='ShellExecuteA';
 %end; /* !UNICODE */

 dcl FindExecutableA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr)
     returns (type HINSTANCE byvalue optional)
     WINSHELLAPI APIENTRY external('FindExecutableA');
 dcl FindExecutableW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr)
     returns (type HINSTANCE byvalue optional)
     WINSHELLAPI APIENTRY external('FindExecutableW');
 %dcl FindExecutable char ext;
 %if UNICODE ^= '' %then %do;
   %FindExecutable='FindExecutableW';
 %end; %else %do;
   %FindExecutable='FindExecutableA';
 %end; /* !UNICODE */

 dcl CommandLineToArgvW
     entry (WCHAR (*) varz byaddr nonasgn,
            fixed bin (31) byaddr)
     returns (pointer byvalue optional) /* to LPWSTR */
     WINSHELLAPI APIENTRY external('CommandLineToArgvW');

 dcl ShellAboutA
     entry (type HWND,
            char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr nonasgn optional,
            type HICON)
     returns (type INT byvalue optional)
     WINSHELLAPI APIENTRY external('ShellAboutA');
 dcl ShellAboutW
     entry (type HWND,
            WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn optional,
            type HICON)
     returns (type INT byvalue optional)
     WINSHELLAPI APIENTRY external('ShellAboutW');
 %dcl ShellAbout char ext;
 %if UNICODE ^= '' %then %do;
   %ShellAbout='ShellAboutW';
 %end; %else %do;
   %ShellAbout='ShellAboutA';
 %end; /* !UNICODE */

 dcl DuplicateIcon
     entry (type HINSTANCE,
            type HICON)
     returns (type HICON byvalue optional)
     WINSHELLAPI APIENTRY external('DuplicateIcon');

 dcl ExtractAssociatedIconA
     entry (type HINSTANCE,
            char (*) varz byaddr,
            type WORD byaddr)
     returns (type HICON byvalue optional)
     WINSHELLAPI APIENTRY external('ExtractAssociatedIconA');
 dcl ExtractAssociatedIconW
     entry (type HINSTANCE,
            Wchar (*) varz byaddr,
            type WORD byaddr)
     returns (type HICON byvalue optional)
     WINSHELLAPI APIENTRY external('ExtractAssociatedIconW');
 %dcl ExtractAssociatedIcon char ext;
 %if UNICODE ^= '' %then %do;
   %ExtractAssociatedIcon='ExtractAssociatedIconW';
 %end; %else %do;
   %ExtractAssociatedIcon='ExtractAssociatedIconA';
 %end; /* !UNICODE */

 dcl ExtractIconA
     entry (type HINSTANCE,
            char (*) varz byaddr nonasgn,
            type UINT)
     returns (type HICON byvalue optional)
     WINSHELLAPI APIENTRY external('ExtractIconA');
 dcl ExtractIconW
     entry (type HINSTANCE,
            WCHAR (*) varz byaddr nonasgn,
            type UINT)
     returns (type HICON byvalue optional)
     WINSHELLAPI APIENTRY external('ExtractIconW');
 %dcl ExtractIcon char ext;
 %if UNICODE ^= '' %then %do;
   %ExtractIcon='ExtractIconW';
 %end; %else %do;
   %ExtractIcon='ExtractIconA';
 %end; /* !UNICODE */


 %if (WINVER >= 1024) %then %do;
 define structure
   1 DRAGINFOA,
     2 uSize       type UINT, /* init with size(:DRAGINFO:) */
     2 pt          type POINT,
     2 fNC         type BOOL,
     2 lpFileList  type LPSTR,
     2 grfKeyState type DWORD;
 define alias LPDRAGINFOA  handle DRAGINFOA;
 define structure
   1 DRAGINFOW,
     2 uSize       type UINT, /* init with size(:DRAGINFO:) */
     2 pt          type POINT,
     2 fNC         type BOOL,
     2 lpFileList  type LPWSTR,
     2 grfKeyState type DWORD;
 define alias LPDRAGINFOW handle DRAGINFOW;
 %if UNICODE ^= '' %then %do;
 define alias   DRAGINFO type   DRAGINFOW;
 define alias LPDRAGINFO type LPDRAGINFOW;
 %end; %else %do;
 define alias   DRAGINFO type   DRAGINFOA;
 define alias LPDRAGINFO type LPDRAGINFOA;
 %end; /* UNICODE */


 /* AppBar stuff */

 dcl ABM_NEW              type DWORD value('00000000'xu);
 dcl ABM_REMOVE           type DWORD value('00000001'xu);
 dcl ABM_QUERYPOS         type DWORD value('00000002'xu);
 dcl ABM_SETPOS           type DWORD value('00000003'xu);
 dcl ABM_GETSTATE         type DWORD value('00000004'xu);
 dcl ABM_GETTASKBARPOS    type DWORD value('00000005'xu);
 dcl ABM_ACTIVATE         type DWORD value('00000006'xu);
     /* lParam == TRUE/FALSE means activate/deactivate */
 dcl ABM_GETAUTOHIDEBAR   type DWORD value('00000007'xu);
 dcl ABM_SETAUTOHIDEBAR   type DWORD value('00000008'xu);
     /* this can fail at any time.  MUST check the result */
     /* lParam = TRUE/FALSE  Set/Unset */
     /* uEdge = what edge */
 dcl ABM_WINDOWPOSCHANGED type DWORD value('00000009'xu);


 /* these are put in the wparam of callback messages */
 dcl ABN_STATECHANGE      type DWORD value('00000000'xu);
 dcl ABN_POSCHANGED       type DWORD value('00000001'xu);
 dcl ABN_FULLSCREENAPP    type DWORD value('00000002'xu);
 dcl ABN_WINDOWARRANGE    type DWORD value('00000003'xu);
     /* lParam == TRUE means hide */

 /* flags for get state */
 dcl ABS_AUTOHIDE         type DWORD value('00000001'xu);
 dcl ABS_ALWAYSONTOP      type DWORD value('00000002'xu);

 dcl ABE_LEFT             fixed bin(31) value(0);
 dcl ABE_TOP              fixed bin(31) value(1);
 dcl ABE_RIGHT            fixed bin(31) value(2);
 dcl ABE_BOTTOM           fixed bin(31) value(3);

 define structure
   1 APPBARDATA,
     2 cbSize           type DWORD,
     2 hWnd             type HWND,
     2 uCallbackMessage type UINT,
     2 uEdge            type UINT,
     2 rc               type RECT,
     2 lParam           type LPARAM; /* message specific */
 define alias PAPPBARDATA handle AppBarData;

 dcl SHAppBarMessage
     entry (type DWORD,
            type APPBARDATA byaddr)
     returns (type UINT byvalue optional)
     WINSHELLAPI APIENTRY external('SHAppBarMessage');

 /* EndAppBar */


 dcl DoEnvironmentSubstA
     entry (char (*) varz byaddr,
            type UINT)
     returns (type DWORD byvalue optional)
     WINSHELLAPI APIENTRY external('DoEnvironmentSubstA');
 dcl DoEnvironmentSubstW
     entry (WCHAR (*) varz byaddr,
            type UINT)
     returns (type DWORD byvalue optional)
     WINSHELLAPI APIENTRY external('DoEnvironmentSubstW');
 %dcl DoEnvironmentSubst char ext;
 %if UNICODE ^= '' %then %do;
   %DoEnvironmentSubst='DoEnvironmentSubstW';
 %end; %else %do;
   %DoEnvironmentSubst='DoEnvironmentSubstA';
 %end; /* !UNICODE */

 dcl FindEnvironmentStringA
     entry (char (*) varz byaddr)
     returns (type LPSTR byvalue optional)
     WINSHELLAPI APIENTRY external('FindEnvironmentStringA');
 dcl FindEnvironmentStringW
     entry (WCHAR (*) varz byaddr)
     returns (type LPWSTR byvalue optional)
     WINSHELLAPI APIENTRY external('FindEnvironmentStringW');
 %dcl FindEnvironmentString char ext;
 %if UNICODE ^= '' %then %do;
   %FindEnvironmentString='FindEnvironmentStringW';
 %end; %else %do;
   %FindEnvironmentString='FindEnvironmentStringA';
 %end; /* !UNICODE */

 EIRESID: proc (x) returns (fixed bin (31) byvalue)
          options (inline reorder) internal;
   dcl x fixed bin (31) byvalue;
   return (-x);
 end EIRESID;

 dcl ExtractIconExA
     entry (char (*) varz byaddr nonasgn,
            fixed bin(31),
            (*) type HICON byaddr optional,
            (*) type HICON byaddr optional,
            type UINT)
     returns (type UINT byvalue optional)
     WINSHELLAPI WINAPI external('ExtractIconExA');
 dcl ExtractIconExW
     entry (WCHAR (*) varz byaddr nonasgn,
            fixed bin(31),
            (*) type HICON byaddr optional,
            (*) type HICON byaddr optional,
            type UINT)
     returns (type UINT byvalue optional)
     WINSHELLAPI WINAPI external('ExtractIconExW');
 %dcl ExtractIconEx char ext;
 %if UNICODE ^= '' %then %do;
   %ExtractIconEx='ExtractIconExW';
 %end; %else %do;
   %ExtractIconEx='ExtractIconExA';
 %end; /* !UNICODE */


 /* Shell File Operations */


 %dcl #FO_MOVE char ext;
 %if #FO_MOVE = '' %then %do;
   /* these need to be kept in sync with the ones in shlobj.cpy */

 dcl FO_MOVE                   type UINT value('0001'xu);
 dcl FO_COPY                   type UINT value('0002'xu);
 dcl FO_DELETE                 type UINT value('0003'xu);
 dcl FO_RENAME                 type UINT value('0004'xu);

 define alias FILEOP_FLAGS type WORD;

 dcl FOF_MULTIDESTFILES        type FILEOP_FLAGS value('0001'xu);
 dcl FOF_CONFIRMMOUSE          type FILEOP_FLAGS value('0002'xu);
 dcl FOF_SILENT                type FILEOP_FLAGS value('0004'xu);
     /* don't create progress/report */
 dcl FOF_RENAMEONCOLLISION     type FILEOP_FLAGS value('0008'xu);
 dcl FOF_NOCONFIRMATION        type FILEOP_FLAGS value('0010'xu);
     /* Don't prompt the user. */
 dcl FOF_WANTMAPPINGHANDLE     type FILEOP_FLAGS value('0020'xu);
     /* Fill in SHFILEOPSTRUCT.hNameMappings   */
     /* Must be freed using SHFreeNameMappings */
 dcl FOF_ALLOWUNDO             type FILEOP_FLAGS value('0040'xu);
 dcl FOF_FILESONLY             type FILEOP_FLAGS value('0080'xu);
     /* on *.*, do only files */
 dcl FOF_SIMPLEPROGRESS        type FILEOP_FLAGS value('0100'xu);
     /* means don't show names of files */
 dcl FOF_NOCONFIRMMKDIR        type FILEOP_FLAGS value('0200'xu);
     /* don't confirm making any needed dirs */
 dcl FOF_NOERRORUI             type FILEOP_FLAGS value('0400'xu);
     /* don't put up error UI */
 dcl FOF_NOCOPYSECURITYATTRIBS type FILEOP_FLAGS value('0800'xu);
     /* dont copy NT file Security Attributes */
 dcl FOF_NORECURSION           type FILEOP_FLAGS value('1000'xu);
     /* don't recurse into directories. */
 %if #WIN32_IE >= 1280 %then %do;
 dcl FOF_NO_CONNECTED_ELEMENTS type FILEOP_FLAGS value('2000'xu);
     /* don't operate on connected elements. */
 dcl FOF_WANTNUKEWARNING       type FILEOP_FLAGS value('4000'xu);
     /* during delete operation, warn if nuking instead of recycling */
     /* (partially overrides FOF_NOCONFIRMATION) */
 %end; /* (_WIN32_IE >= 0x500) */

 define alias PRINTEROP_FLAGS type WORD;

 dcl PO_DELETE                 type PRINTEROP_FLAGS value('0013'xu);
     /* printer is being deleted */
 dcl PO_RENAME                 type PRINTEROP_FLAGS value('0014'xu);
     /* printer is being renamed */
 dcl PO_PORTCHANGE             type PRINTEROP_FLAGS value('0020'xu);
     /* port this printer connected to is being changed */
     /* if this id is set, the strings received by      */
     /* the copyhook are a doubly-null terminated       */
     /* list of strings.  The first is the printer      */
     /* name and the second is the printer port.        */
 dcl PO_REN_PORT               type PRINTEROP_FLAGS value('0034'xu);
     /* PO_RENAME and PO_PORTCHANGE at same time. */

     /* no POF_ flags currently defined */

 %end; /* #FO_MOVE */

 /* implicit parameters are:                                          */
 /*   if pFrom or pTo are unqualified names the current directories   */
 /*   are taken from the global current drive/directory settings      */
 /*   managed by Get/SetCurrentDrive/Directory                        */
 /*                                                                   */
 /*   the global confirmation settings                                */

 define structure
   1 SHFILEOPSTRUCTA unaligned,
     2 hwnd                  type HWND,
     2 wFunc                 type UINT,
     2 pFrom                 type LPCSTR,
     2 pTo                   type LPCSTR,
     2 fFlags                type FILEOP_FLAGS,
     2 fAnyOperationsAborted type BOOL,
     2 hNameMappings         type LPVOID,
     2 lpszProgressTitle     type LPCSTR;
       /* only used if FOF_SIMPLEPROGRESS */
 define alias LPSHFILEOPSTRUCTA handle SHFILEOPSTRUCTA;
 define structure
   1 SHFILEOPSTRUCTW unaligned,
     2 hwnd                  type HWND,
     2 wFunc                 type UINT,
     2 pFrom                 type LPCWSTR,
     2 pTo                   type LPCWSTR,
     2 fFlags                type FILEOP_FLAGS,
     2 fAnyOperationsAborted type BOOL,
     2 hNameMappings         type LPVOID,
     2 lpszProgressTitle     type LPCWSTR;
       /* only used if FOF_SIMPLEPROGRESS */
 define alias LPSHFILEOPSTRUCTW handle SHFILEOPSTRUCTW;
 %if UNICODE ^= '' %then %do;
 define alias   SHFILEOPSTRUCT type   SHFILEOPSTRUCTW;
 define alias LPSHFILEOPSTRUCT type LPSHFILEOPSTRUCTW;
 %end; %else %do;
 define alias   SHFILEOPSTRUCT type   SHFILEOPSTRUCTA;
 define alias LPSHFILEOPSTRUCT type LPSHFILEOPSTRUCTA;
 %end; /* UNICODE */

 dcl SHFileOperationA
     entry (type SHFILEOPSTRUCTA byaddr)
     returns (fixed bin(31) byvalue optional)
     WINSHELLAPI WINAPI external('SHFileOperationA');
 dcl SHFileOperationW
     entry (type SHFILEOPSTRUCTW byaddr)
     returns (fixed bin(31) byvalue optional)
     WINSHELLAPI WINAPI external('SHFileOperationW');
 %dcl SHFileOperation char ext;
 %if UNICODE ^= '' %then %do;
   %SHFileOperation='SHFileOperationW';
 %end; %else %do;
   %SHFileOperation='SHFileOperationA';
 %end; /* !UNICODE */

 dcl SHFreeNameMappings
     entry (type HANDLE)
     WINSHELLAPI WINAPI external('SHFreeNameMappings');

 define structure
   1 SHNAMEMAPPINGA,
     2 pszOldPath type LPSTR,
     2 pszNewPath type LPSTR,
     2 cchOldPath fixed bin(31),
     2 cchNewPath fixed bin(31);
 define alias LPSHNAMEMAPPINGA handle SHNAMEMAPPINGA;
 define structure
   1 SHNAMEMAPPINGW,
     2 pszOldPath type LPWSTR,
     2 pszNewPath type LPWSTR,
     2 cchOldPath fixed bin(31),
     2 cchNewPath fixed bin(31);
 define alias LPSHNAMEMAPPINGW handle SHNAMEMAPPINGW;
 %if UNICODE ^= '' %then %do;
 define alias   SHNAMEMAPPING type   SHNAMEMAPPINGW;
 define alias LPSHNAMEMAPPING type LPSHNAMEMAPPINGW;
 %end; %else %do;
 define alias   SHNAMEMAPPING type   SHNAMEMAPPINGA;
 define alias LPSHNAMEMAPPING type LPSHNAMEMAPPINGA;
 %end; /* UNICODE */


 /* End Shell File Operations */


 /* Begin ShellExecuteEx and family */

 /* ShellExecute() and ShellExecuteEx() error codes */

 /* regular WinExec() codes */
 dcl SE_ERR_FNF          fixed bin(31) value( 2); /* file not found */
 dcl SE_ERR_PNF          fixed bin(31) value( 3); /* path not found */
 dcl SE_ERR_ACCESSDENIED fixed bin(31) value( 5); /* access denied  */
 dcl SE_ERR_OOM          fixed bin(31) value( 8); /* out of memory  */
 dcl SE_ERR_DLLNOTFOUND  fixed bin(31) value(32);

 %end; /* WINVER >= 0x0400 */

 /* error values for ShellExecute() beyond the regular WinExec() codes*/
 dcl SE_ERR_SHARE           fixed bin(31) value(26);
 dcl SE_ERR_ASSOCINCOMPLETE fixed bin(31) value(27);
 dcl SE_ERR_DDETIMEOUT      fixed bin(31) value(28);
 dcl SE_ERR_DDEFAIL         fixed bin(31) value(29);
 dcl SE_ERR_DDEBUSY         fixed bin(31) value(30);
 dcl SE_ERR_NOASSOC         fixed bin(31) value(31);


 %if (WINVER >= 1024) %then %do;

 /* Note CLASSKEY overrides CLASSNAME */
 dcl SEE_MASK_CLASSNAME         type ULONG value('00000001'xu);
 dcl SEE_MASK_CLASSKEY          type ULONG value('00000003'xu);
 /* Note INVOKEIDLIST overrides IDLIST */
 dcl SEE_MASK_IDLIST            type ULONG value('00000004'xu);
 dcl SEE_MASK_INVOKEIDLIST      type ULONG value('0000000c'xu);
 dcl SEE_MASK_ICON              type ULONG value('00000010'xu);
 dcl SEE_MASK_HOTKEY            type ULONG value('00000020'xu);
 dcl SEE_MASK_NOCLOSEPROCESS    type ULONG value('00000040'xu);
 dcl SEE_MASK_CONNECTNETDRV     type ULONG value('00000080'xu);
 dcl SEE_MASK_FLAG_DDEWAIT      type ULONG value('00000100'xu);
 dcl SEE_MASK_DOENVSUBST        type ULONG value('00000200'xu);
 dcl SEE_MASK_FLAG_NO_UI        type ULONG value('00000400'xu);
 dcl SEE_MASK_UNICODE           type ULONG value('00004000'xu);
 dcl SEE_MASK_NO_CONSOLE        type ULONG value('00008000'xu);
 dcl SEE_MASK_ASYNCOK           type ULONG value('00100000'xu);
 dcl SEE_MASK_HMONITOR          type ULONG value('00200000'xu);
 %if #WIN32_IE >= 1280 %then %do;
 dcl SEE_MASK_NOQUERYCLASSSTORE type ULONG value('01000000'xu);
 %end; /* (_WIN32_IE >= 0x500) */

 define structure
   1 SHELLEXECUTEINFOA,
     2 cbSize       type DWORD,
     2 fMask        type ULONG,
     2 hwnd         type HWND,
     2 lpVerb       type LPCSTR,
     2 lpFile       type LPCSTR,
     2 lpParameters type LPCSTR,
     2 lpDirectory  type LPCSTR,
     2 nShow        fixed bin(31),
     2 hInstApp     type HINSTANCE,
     /* Optional fields */
     2 lpIDList     type LPVOID,
     2 lpClass      type LPCSTR,
     2 hkeyClass    type HKEY,
     2 dwHotKey     type DWORD,
     2 * union,
       3 hIcon      type HANDLE,
       3 hMonitor   type HANDLE,
     2 hProcess     type HANDLE;
 define alias LPSHELLEXECUTEINFOA handle SHELLEXECUTEINFOA;
 define structure
   1 SHELLEXECUTEINFOW,
     2 cbSize       type DWORD,
     2 fMask        type ULONG,
     2 hwnd         type HWND,
     2 lpVerb       type LPCWSTR,
     2 lpFile       type LPCWSTR,
     2 lpParameters type LPCWSTR,
     2 lpDirectory  type LPCWSTR,
     2 nShow        fixed bin(31),
     2 hInstApp     type HINSTANCE,
     /* Optional fields */
     2 lpIDList     type LPVOID,
     2 lpClass      type LPCWSTR,
     2 hkeyClass    type HKEY,
     2 dwHotKey     type DWORD,
     2 * union,
       3 hIcon      type HANDLE,
       3 hMonitor   type HANDLE,
     2 hProcess     type HANDLE;
 define alias LPSHELLEXECUTEINFOW handle SHELLEXECUTEINFOW;
 %if UNICODE ^= '' %then %do;
 define alias   SHELLEXECUTEINFO type   SHELLEXECUTEINFOW;
 define alias LPSHELLEXECUTEINFO type LPSHELLEXECUTEINFOW;
 %end; %else %do;
 define alias   SHELLEXECUTEINFO type   SHELLEXECUTEINFOA;
 define alias LPSHELLEXECUTEINFO type LPSHELLEXECUTEINFOA;
 %end; /* UNICODE */

 dcl ShellExecuteExA
     entry (type SHELLEXECUTEINFOA byaddr)
     returns (type BOOL byvalue optional)
     WINSHELLAPI WINAPI external('ShellExecuteExA');
 dcl ShellExecuteExW
     entry (type SHELLEXECUTEINFOW byaddr)
     returns (type BOOL byvalue optional)
     WINSHELLAPI WINAPI external('ShellExecuteExW');
 %dcl ShellExecuteEx char ext;
 %if UNICODE ^= '' %then %do;
   %ShellExecuteEx='ShellExecuteExW';
 %end; %else %do;
   %ShellExecuteEx='ShellExecuteExA';
 %end; /* !UNICODE */

 dcl WinExecErrorA
     entry (type HWND,
            fixed bin(31),
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn)
     WINSHELLAPI WINAPI external('WinExecErrorA');
 dcl WinExecErrorW
     entry (type HWND,
            fixed bin(31),
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn)
     WINSHELLAPI WINAPI external('WinExecErrorW');
 %dcl WinExecError char ext;
 %if UNICODE ^= '' %then %do;
   %WinExecError='WinExecErrorW';
 %end; %else %do;
   %WinExecError='WinExecErrorA';
 %end; /* !UNICODE */

 /*  SHCreateProcessAsUser() */
 define structure
   1 SHCREATEPROCESSINFOW,
     2 cbSize               type DWORD,
     2 fMask                type ULONG,
     2 hwnd                 type HWND,
     2 pszFile              type LPCWSTR,
     2 pszParameters        type LPCWSTR,
     2 pszCurrentDirectory  type LPCWSTR,
     2 hUserToken           type HANDLE,
     2 lpProcessAttributes  type LPSECURITY_ATTRIBUTES,
     2 lpThreadAttributes   type LPSECURITY_ATTRIBUTES,
     2 bInheritHandles      type BOOL,
     2 dwCreationFlags      type DWORD,
     2 lpStartupInfo        type LPSTARTUPINFOW,
     2 lpProcessInformation type LPPROCESS_INFORMATION;
 define alias PSHCREATEPROCESSINFOW handle SHCREATEPROCESSINFOW;

 dcl SHCreateProcessAsUserW
     entry (type SHCREATEPROCESSINFOW byaddr)
     SHSTDAPI_(type BOOL) external('SHCreateProcessAsUserW');

 /*  End ShellExecuteEx and family */


 /* RecycleBin */


 /* struct for query recycle bin info */
 define structure
   1 SHQUERYRBINFO,
     2 cbSize      type DWORD,
     2 i64Size     fixed bin (63),
     2 i64NumItems fixed bin (63);
 define alias LPSHQUERYRBINFO type SHQUERYRBINFO;


 /* flags for SHEmptyRecycleBin */

 dcl SHERB_NOCONFIRMATION type DWORD value('00000001'xu);
 dcl SHERB_NOPROGRESSUI   type DWORD value('00000002'xu);
 dcl SHERB_NOSOUND        type DWORD value('00000004'xu);


 dcl SHQueryRecycleBinA
     entry (char (*) varz byaddr nonasgn optional,
            type SHQUERYRBINFO byaddr)
     SHSTDAPI external('SHQueryRecycleBinA');
 dcl SHQueryRecycleBinW
     entry (WCHAR (*) varz byaddr nonasgn optional,
            type SHQUERYRBINFO byaddr)
     SHSTDAPI external('SHQueryRecycleBinW');
 %dcl SHQueryRecycleBin char ext;
 %if UNICODE ^= '' %then %do;
   %SHQueryRecycleBin='SHQueryRecycleBinW';
 %end; %else %do;
   %SHQueryRecycleBin='SHQueryRecycleBinA';
 %end; /* !UNICODE */

 dcl SHEmptyRecycleBinA
     entry (type HWND,
            char (*) varz byaddr nonasgn optional,
            type DWORD)
     SHSTDAPI external('SHEmptyRecycleBinA');
 dcl SHEmptyRecycleBinW
     entry (type HWND,
            WCHAR (*) varz byaddr nonasgn optional,
            type DWORD)
     SHSTDAPI external('SHEmptyRecycleBinW');
 %dcl SHEmptyRecycleBin char ext;
 %if UNICODE ^= '' %then %do;
   %SHEmptyRecycleBin='SHEmptyRecycleBinW';
 %end; %else %do;
   %SHEmptyRecycleBin='SHEmptyRecycleBinA';
 %end; /* !UNICODE */

 /* end of RecycleBin */


 /* Tray notification definitions */

 define structure
   1 NOTIFYICONDATAA,
     2 cbSize           type DWORD,
     2 hWnd             type HWND,
     2 uID              type UINT,
     2 uFlags           type UINT,
     2 uCallbackMessage type UINT,
     2 hIcon            type HICON,
 %if #WIN32_IE < 1280 %then %do;
     2 szTip            char(64-1) varz
 %end; %else %do;
     2 szTip            char(128-1) varz
 %end;
 %if #WIN32_IE >= 1280 %then %do;
   , 2 dwState          type DWORD,
     2 dwStateMask      type DWORD,
     2 szInfo           char(256-1) varz,
     2 uTimeout         type UINT,
     2 szInfoTitle      char(64-1) varz,
     2 dwInfoFlags      type DWORD
 %end;
   ;
 define alias PNOTIFYICONDATAA handle NOTIFYICONDATAA;

 define structure
   1 NOTIFYICONDATAW,
     2 cbSize           type DWORD,
     2 hWnd             type HWND,
     2 uID              type UINT,
     2 uFlags           type UINT,
     2 uCallbackMessage type UINT,
     2 hIcon            type HICON,
 %if #WIN32_IE < 1280 %then %do;
     2 szTip            WCHAR(64-1) varz
 %end; %else %do;
     2 szTip            WCHAR(128-1) varz
 %end;
 %if #WIN32_IE >= 1280 %then %do;
   , 2 dwState          type DWORD,
     2 dwStateMask      type DWORD,
     2 szInfo           WCHAR(256-1) varz,
     2 uTimeout         type UINT,
     2 szInfoTitle      WCHAR(64-1) varz,
     2 dwInfoFlags      type DWORD
 %end;
   ;
 define alias PNOTIFYICONDATAW handle NOTIFYICONDATAW;
 %if UNICODE ^= '' %then %do;
 define alias  NOTIFYICONDATA type  NOTIFYICONDATAW;
 define alias PNOTIFYICONDATA type PNOTIFYICONDATAW;
 %end; %else %do;
 define alias  NOTIFYICONDATA type  NOTIFYICONDATAA;
 define alias PNOTIFYICONDATA type PNOTIFYICONDATAA;
 %end; /* UNICODE */

 %if #WIN32_IE >= 1280 %then %do;
 dcl NOTIFYICONDATAA_V1_SIZE fixed bin(31)
    value(FIELD_OFFSET(NOTIFYICONDATAA, dwState));
 dcl NOTIFYICONDATAW_V1_SIZE fixed bin(31)
     value(FIELD_OFFSET(NOTIFYICONDATAW, dwState));
 %end; %else %do;
 dcl NOTIFYICONDATAA_V1_SIZE fixed bin(31)
     value(size(: NOTIFYICONDATAA :));
 dcl NOTIFYICONDATAW_V1_SIZE fixed bin(31)
     value(size(: NOTIFYICONDATAW :));
 %end;
 %if UNICODE ^= '' %then %do;
 dcl NOTIFYICONDATA_V1_SIZE  fixed bin(31)
     value(NOTIFYICONDATAW_V1_SIZE);
 %end; %else %do;
 dcl NOTIFYICONDATA_V1_SIZE  fixed bin(31)
     value(NOTIFYICONDATAA_V1_SIZE);
 %end;

 %if #WIN32_IE >= 1280 %then %do;
 /* notifies sent FROM shell to the app. */
 dcl NOTIFYICON_VERSION  fixed bin(31) value(3);
 dcl NIN_GETVERSION      fixed bin(31) value(WM_USER + 0);
 dcl NIN_SELECT          fixed bin(31) value(WM_USER + '2'xn);
 dcl NINF_KEY            fixed bin(31) value('1'xn);
 dcl NIN_KEYSELECT       fixed bin(31) value(ior(NIN_SELECT, NINF_KEY));
 %end;

 dcl NIM_ADD             type DWORD value('00000000'xu);
 dcl NIM_MODIFY          type DWORD value('00000001'xu);
 dcl NIM_DELETE          type DWORD value('00000002'xu);
 %if #WIN32_IE >= 1280 %then %do;
 dcl NIM_SETFOCUS        type DWORD value('00000003'xu);
 %end;

 dcl NIF_MESSAGE         type UINT value('00000001'xu);
 dcl NIF_ICON            type UINT value('00000002'xu);
 dcl NIF_TIP             type UINT value('00000004'xu);
 %if #WIN32_IE >= 1280 %then %do;
 dcl NIF_STATE           type UINT value('00000008'xu);
 dcl NIF_INFO            type UINT value('00000010'xu);

 dcl NIS_HIDDEN          type DWORD value('00000001'xu);
 dcl NIS_SHAREDICON      type DWORD value('00000002'xu);

 /* Notify Icon Infotip flags */
 dcl NIIF_NONE           type DWORD value('00000000'xu);
 /* icon flags are mutually exclusive and take only the lowest 2 bits */
 dcl NIIF_INFO           type DWORD value('00000001'xu);
 dcl NIIF_WARNING        type DWORD value('00000002'xu);
 dcl NIIF_ERROR          type DWORD value('00000003'xu);

 %end;

 dcl Shell_NotifyIconA
     entry (type DWORD,
            type NOTIFYICONDATAA byaddr)
     returns (type BOOL byvalue optional)
     WINSHELLAPI WINAPI external('Shell_NotifyIconA');
 dcl Shell_NotifyIconW
     entry (type DWORD,
            type NOTIFYICONDATAW byaddr)
     returns (type BOOL byvalue optional)
     WINSHELLAPI WINAPI external('Shell_NotifyIconW');
 %dcl Shell_NotifyIcon char ext;
 %if UNICODE ^= '' %then %do;
   %Shell_NotifyIcon='Shell_NotifyIconW';
 %end; %else %do;
   %Shell_NotifyIcon='Shell_NotifyIconA';
 %end; /* !UNICODE */

 /* End Tray Notification Icons */


 %dcl SHFILEINFO_DEFINED char ext;
 %if SHFILEINFO_DEFINED = '' %then %do;
 %SHFILEINFO_DEFINED = 'Y';
 /* Begin SHGetFileInfo */

 /* The SHGetFileInfo API provides an easy way to get attributes      */
 /* for a file given a pathname.                                      */
 /*                                                                   */
 /*   PARAMETERS                                                      */
 /*     pszPath              file name to get info about              */
 /*     dwFileAttributes     file attribs, only used with             */
 /*                          SHGFI_USEFILEATTRIBUTES                  */
 /*     psfi                 place to return file info                */
 /*     cbFileInfo           size of structure                        */
 /*     uFlags               flags                                    */
 /*                                                                   */
 /*   RETURN                                                          */
 /*     TRUE if things worked                                         */

 define structure
   1 SHFILEINFOA,
     2 hIcon         type HICON,     /* out: icon */
     2 iIcon         fixed bin(31),  /* out: icon index */
     2 dwAttributes  type DWORD,     /* out: SFGAO_ flags */
     2 szDisplayName char (MAX_PATH-1) varz,
                                     /* out: display name (or path) */
     2 szTypeName    char (80-1) varz; /* out: type name */
 define structure
   1 SHFILEINFOW,
     2 hIcon         type HICON,     /* out: icon */
     2 iIcon         fixed bin(31),  /* out: icon index */
     2 dwAttributes  type DWORD,     /* out: SFGAO_ flags */
     2 szDisplayName WCHAR(MAX_PATH-1) varz,
                                     /* out: display name (or path) */
     2 szTypeName    WCHAR(80-1) varz; /* out: type name */
 %if UNICODE ^= '' %then %do;
 define alias SHFILEINFO type SHFILEINFOW;
 %end; %else %do;
 define alias SHFILEINFO type SHFILEINFOA;
 %end; /* UNICODE */

 /* NOTE: This is also in shlwapi.h.  Please keep in synch. */
 %end; /* !SHFILEINFO_DEFINED */

 dcl SHGFI_ICON              type DWORD value('00000100'xu);
     /* get icon */
 dcl SHGFI_DISPLAYNAME       type DWORD value('00000200'xu);
     /* get display name */
 dcl SHGFI_TYPENAME          type DWORD value('00000400'xu);
     /* get type name */
 dcl SHGFI_ATTRIBUTES        type DWORD value('00000800'xu);
     /* get attributes */
 dcl SHGFI_ICONLOCATION      type DWORD value('00001000'xu);
     /* get icon location */
 dcl SHGFI_EXETYPE           type DWORD value('00002000'xu);
     /* return exe type */
 dcl SHGFI_SYSICONINDEX      type DWORD value('00004000'xu);
     /* get system icon index */
 dcl SHGFI_LINKOVERLAY       type DWORD value('00008000'xu);
     /* put a link overlay on icon */
 dcl SHGFI_SELECTED          type DWORD value('00010000'xu);
     /* show icon in selected state */
 dcl SHGFI_ATTR_SPECIFIED    type DWORD value('00020000'xu);
     /* get only specified attributes */
 dcl SHGFI_LARGEICON         type DWORD value('00000000'xu);
     /* get large icon */
 dcl SHGFI_SMALLICON         type DWORD value('00000001'xu);
     /* get small icon */
 dcl SHGFI_OPENICON          type DWORD value('00000002'xu);
     /* get open icon */
 dcl SHGFI_SHELLICONSIZE     type DWORD value('00000004'xu);
     /* get shell size icon */
 dcl SHGFI_PIDL              type DWORD value('00000008'xu);
     /* pszPath is a pidl */
 dcl SHGFI_USEFILEATTRIBUTES type DWORD value('00000010'xu);
     /* use passed dwFileAttribute */

 dcl SHGetFileInfoA
     entry (char (*) varz byaddr nonasgn,
            /* use pli_p2z to pass addr(ITEMIDLIST) */
            type DWORD,
            type SHFILEINFOA byaddr,
            type UINT,
            type UINT)
     SHSTDAPI_(type DWORD) external('SHGetFileInfoA');
 dcl SHGetFileInfoW
     entry (WCHAR (*) varz byaddr nonasgn,
            /* use pli_p2z to pass addr(ITEMIDLIST) */
            type DWORD,
            type SHFILEINFOW byaddr,
            type UINT,
            type UINT)
     SHSTDAPI_(type DWORD) external('SHGetFileInfoW');
 %dcl SHGetFileInfo char ext;
 %if UNICODE ^= '' %then %do;
   %SHGetFileInfo='SHGetFileInfoW';
 %end; %else %do;
   %SHGetFileInfo='SHGetFileInfoA';
 %end; /* !UNICODE */

 dcl SHGetDiskFreeSpaceA
     entry (char (*) varz byaddr nonasgn,
            type ULARGE_INTEGER byaddr,
            type ULARGE_INTEGER byaddr,
            type ULARGE_INTEGER byaddr)
     SHSTDAPI_(type BOOL) external('SHGetDiskFreeSpaceA');
 dcl SHGetDiskFreeSpaceW
     entry (WCHAR (*) varz byaddr nonasgn,
            type ULARGE_INTEGER byaddr,
            type ULARGE_INTEGER byaddr,
            type ULARGE_INTEGER byaddr)
     SHSTDAPI_(type BOOL) external('SHGetDiskFreeSpaceW');
 %dcl SHGetDiskFreeSpace char ext;
 %if UNICODE ^= '' %then %do;
   %SHGetDiskFreeSpace='SHGetDiskFreeSpaceW';
 %end; %else %do;
   %SHGetDiskFreeSpace='SHGetDiskFreeSpaceA';
 %end; /* !UNICODE */

 dcl SHGetNewLinkInfoA
     entry (char (*) varz byaddr nonasgn, /* use pli_p2z to pass PIDL */
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr,
            type BOOL byaddr,
            type UINT)
     SHSTDAPI_(type BOOL) external('SHGetNewLinkInfoA');
 dcl SHGetNewLinkInfoW
     entry (WCHAR (*) varz byaddr nonasgn,/* use pli_p2z to pass PIDL */
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr,
            type BOOL byaddr,
            type UINT)
     SHSTDAPI_(type BOOL) external('SHGetNewLinkInfoW');
 %dcl SHGetNewLinkInfo char ext;
 %if UNICODE ^= '' %then %do;
   %SHGetNewLinkInfo='SHGetNewLinkInfoW';
 %end; %else %do;
   %SHGetNewLinkInfo='SHGetNewLinkInfoA';
 %end; /* !UNICODE */

 dcl SHGNLI_PIDL       type UINT value('00000001'xu);
     /* pszLinkTo is a pidl */
 dcl SHGNLI_PREFIXNAME type UINT value('00000002'xu);
     /* Make name "Shortcut to xxx" */
 dcl SHGNLI_NOUNIQUE   type UINT value('00000004'xu);
     /* don't do the unique name generation */


 /* End SHGetFileInfo */

 /* Printer stuff */
 dcl PRINTACTION_OPEN             type UINT value(0);
 dcl PRINTACTION_PROPERTIES       type UINT value(1);
 dcl PRINTACTION_NETINSTALL       type UINT value(2);
 dcl PRINTACTION_NETINSTALLLINK   type UINT value(3);
 dcl PRINTACTION_TESTPAGE         type UINT value(4);
 dcl PRINTACTION_OPENNETPRN       type UINT value(5);
 %if WINNT ^= '' %then %do;
 dcl PRINTACTION_DOCUMENTDEFAULTS type UINT value(6);
 dcl PRINTACTION_SERVERPROPERTIES type UINT value(7);
 %end;

 dcl SHInvokePrinterCommandA
     entry (type HWND,
            type UINT,
            char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn optional,
            type BOOL)
     SHSTDAPI_(type BOOL) external('SHInvokePrinterCommandA');
 dcl SHInvokePrinterCommandW
     entry (type HWND,
            type UINT,
            WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn optional,
            type BOOL)
     SHSTDAPI_(type BOOL) external('SHInvokePrinterCommandW');
 %dcl SHInvokePrinterCommand char ext;
 %if UNICODE ^= '' %then %do;
   %SHInvokePrinterCommand='SHInvokePrinterCommandW';
 %end; %else %do;
   %SHInvokePrinterCommand='SHInvokePrinterCommandA';
 %end; /* !UNICODE */

 %end; /* WINVER >= 0x0400 */

 %end; /* _INC_SHELLAPI */

