 /*********************************************************************/
 /*                                                                   */
 /* Source File Name = SQLADEF.CPY                                    */
 /*                                                                   */
 /* (C) COPYRIGHT International Business Machines Corp. 1993, 1997    */
 /* All Rights Reserved                                               */
 /* Licensed Materials - Property of IBM                              */
 /*                                                                   */
 /* US Government Users Restricted Rights - Use, duplication or       */
 /* disclosure restricted by GSA ADP Schedule Contract with IBM Corp. */
 /*                                                                   */
 /* Function = Include File defining:                                 */
 /*              Information for Precompiler Generated C Files        */
 /*                                                                   */
 /* Operating System = Common C Include File                          */
 /*                                                                   */
 /*********************************************************************/

 %dcl SQL_H_SQLADEF char ext;
 %if SQL_H_SQLADEF = '' %then %do;
 %SQL_H_SQLADEF = 'Y'; /* Permit duplicate Includes */

 %dcl SQL_H_SQLSYSTM char ext;
 %if SQL_H_SQLSYSTM = '' %then %do;
 %include sqlsystm;    /* System dependent defines  */
 %end;

 /* The macros for initializing LOB declarations have no PL/I equiv. */


 define structure
   1 sqla_runtime_info,
     2 id      char(8),
     2 wc_size fixed bin(16) unsigned,
     2 wc_type fixed bin(16) unsigned,
     2 unused  char(4);

 /* Prototypes for Runtime API's */

 define structure
   1 sqla_setd_list,
     2 sqltype fixed bin(16) unsigned, /* SQL data type */
     2 sqllen  fixed bin(32) unsigned, /* declared length */
     2 sqldata pointer,                /* address of host var */
     2 sqlind  pointer;                /* address of ind. var */

 define structure
  1 sqla_setds_list,
    2 sqldslen  fixed bin(32) unsigned, /* length of ADT */
    2 sqldsname pointer;                /* address of type name */

 dcl sqlaaloc
     entry (fixed bin(16) unsigned,
            fixed bin(16) unsigned,
            fixed bin(16) unsigned,
            pointer)
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlaaloc');

 dcl sqlaAllocateCursorRS
     entry (fixed bin(16) unsigned,
            fixed bin(32) unsigned,
            pointer)
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlaAllocateCursorRS');


 dcl sqlaAssociateLocatorRS
     entry (fixed bin(32) unsigned,
            fixed bin(31),
            pointer,            /* C: char * */
            fixed bin(31),
            pointer)
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlaAssociateLocatorRS');

 dcl sqlacall
     entry (fixed bin(16) unsigned,
            fixed bin(16) unsigned,
            fixed bin(16) unsigned,
            fixed bin(16) unsigned,
            pointer)
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlacall');

 dcl sqlacmpd
     entry (fixed bin(16) unsigned,
            fixed bin(16) unsigned,
            fixed bin(16) unsigned,
            fixed bin(16) unsigned,
            pointer)
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlacmpd');

 dcl sqladloc
     entry (fixed bin(16) unsigned,
            pointer)
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqladloc');

 dcl sqlasetd
     entry (fixed bin(16) unsigned,
            fixed bin(16) unsigned,
            fixed bin(16) unsigned,
            handle sqla_setd_list,
            pointer)
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlasetd');

 dcl sqlasetda
     entry (fixed bin(16) unsigned,
            fixed bin(16) unsigned,
            fixed bin(16) unsigned,
            handle sqla_setd_list,
            handle sqla_setds_list,
            pointer)
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlasetda');

 /* NOTE: sqlasets has been obsoleted in favor of sqlastls,  */
 /* and will be going away in a future release.              */
 dcl sqlasets
     entry (fixed bin(16) unsigned,
            pointer,
            pointer)
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlasets');

 dcl sqlastls
     entry (fixed bin(32) unsigned,
            pointer,
            pointer)
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlastls');

 /* NOTE: sqlasetv has been obsoleted in favor of sqlastlv,  */
 /* and willbe going away in a future release.               */
 dcl sqlasetv
     entry (fixed bin(16) unsigned,
            fixed bin(16) unsigned,
            fixed bin(16) unsigned,
            fixed bin(16) unsigned,
            pointer,
            fixed bin(16) unsigned byaddr,
            pointer)
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlasetv');

 dcl sqlastlv
     entry (fixed bin(16) unsigned,
            fixed bin(16) unsigned,
            fixed bin(16) unsigned,
            fixed bin(32) unsigned,
            pointer,
            fixed bin(16) unsigned byaddr,
            pointer)
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlastlv');

 dcl sqlastlva
     entry (fixed bin(16) unsigned,
            fixed bin(16) unsigned,
            fixed bin(16) unsigned,
            fixed bin(32) unsigned,
            pointer,
            fixed bin(32) unsigned,
            pointer,
            fixed bin(16) unsigned byaddr,
            pointer)
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlastlva');

 dcl sqlastvr
     entry (fixed bin(16) unsigned,
            fixed bin(16) unsigned,
            fixed bin(16) unsigned,
            fixed bin(32) unsigned,
            fixed bin(32) unsigned byaddr,
            pointer,
            fixed bin(16) unsigned byaddr,
            pointer)
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlastvr');

 dcl sqlastvra
     entry (fixed bin(16) unsigned,
            fixed bin(16) unsigned,
            fixed bin(16) unsigned,
            fixed bin(32) unsigned,
            fixed bin(32) unsigned byaddr,
            pointer,
            fixed bin(32) unsigned,
            pointer,
            fixed bin(16) unsigned byaddr,
            pointer)
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlastvra');

 dcl sqlastop
     entry (pointer)
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlastop');

 dcl sqlastrt
     entry (char(*) byaddr,                /* varz? */
            type sqla_runtime_info byaddr,
            pointer)         /* SQLCA */
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlastrt');

 dcl sqlausda
     entry (fixed bin(16) unsigned,
            pointer,         /* SQLDA */
            pointer)
     returns (type SQL_API_RC byvalue optional)
     SQL_API_FN external('sqlausda');

 %end; /* SQL_H_SQLADEF */
