 /********************************************************************/
 /*                                                                  */
 /*  PL/I Include file: SQLSYSTM.CPY                                 */
 /*                                                                  */
 /*  This file is installed in the \IBMPLI\INCLUDE\SDKWIN\ directory.*/
 /*                                                                  */
 /*                                                                  */
 /*  NAME - SQLSYSTM.CPY                                             */
 /*                                                                  */
 /*  DESCRIPTION                                                     */
 /*                                                                  */
 /*    This include file is translated into a PL/I include file,     */
 /*    from the C header files supplied with the                     */
 /*    IBM DATABASE 2 SOFTWARE DEVELOPERS KIT    product.            */
 /*    This include file is intended for use with the                */
 /*    IBM DATABASE 2 SOFTWARE DEVELOPERS KIT   product.             */
 /*                                                                  */
 /*                                                                  */
 /*    (C) Copyright IBM Corp. 1994, 1996. All Rights Reserved.      */
 /*    US Government Users Restricted Rights-- Use, duplication or   */
 /*    disclosure restricted by GSA ADP Schedule Contract with       */
 /*    IBM Corp.                                                     */
 /*    Licensed Materials - Property of IBM                          */
 /*                                                                  */
 /*  Function = Include File defining:                               */
 /*               Operating System Specific Information              */
 /*                                                                  */
 /*  Operating System = Windows                                      */
 /*                                                                  */
 /*                                                                  */
 /*  DISCLAIMER OF WARRANTIES                                        */
 /*    The following enclosed code is sample code created by IBM   */
 /*    Corporation. This sample code is not part of any standard     */
 /*    IBM product and is provided to you solely for the purpose of  */
 /*    assisting you in the development of your applications.  The   */
 /*    code is provided "AS IS", without warranty of any kind.       */
 /*    IBM shall not be liable for any damages arising out of your   */
 /*    use of the sample code, even if IBM has been advised of the   */
 /*    possibility of such damages.                                  */
 /*                                                                  */
 /********************************************************************/

 %dcl SQL_H_SQLSYSTM char ext;
 %if SQL_H_SQLSYSTM = '' %then %do;
 /* Permit duplicate Includes */
 %SQL_H_SQLSYSTM = 'Y';


 %dcl DB2NT char ext;
 %if DB2NT = '' %then %do;
 %DB2NT = '1';
 %end;


 %dcl #SQL_API_RC char ext;
 %if #SQL_API_RC = '' %then %do;
 %#SQL_API_RC = 'Y';
 define alias SQL_API_RC fixed bin(31);

 %dcl SQL_API_FN char scan;
 %SQL_API_FN = 'options(linkage(system) byvalue nodescriptor)';

 %dcl SQL_POINTER char ext;
 %SQL_POINTER = '';

 %dcl SQL_API_INTR char scan;
 %SQL_API_INTR = 'options(linkage(system) byvalue nodescriptor)';
 %end; /* #SQL_API_RC */

 %dcl ODBCVER char ext;
 %dcl #WINNT_ char ext;
 %if (ODBCVER = '') & (#WINNT_ = '') %then %do;
 /* Define aliases */
 /* define alias wchar_t unsigned fixed bin(16) */
 /* define alias double real float bin(53) */
 %end;

 /*********************************************************************/
 /*                                                                   */
 /* Define fixed size integer types.                                  */
 /*                                                                   */
 /*********************************************************************/

 define alias sqlint8   fixed bin (7) signed;
 define alias sqluint8  fixed bin (8) unsigned;

 define alias sqlint16  fixed bin (15) signed;
 define alias sqluint16 fixed bin (16) unsigned;

 define alias sqlint32  fixed bin (31) signed;
 define alias sqluint32 fixed bin (32) unsigned;

 define alias SQL_BIGINT_TYPE  fixed bin (63) signed;
 define alias SQL_BIGUINT_TYPE fixed bin (64) unsigned;
 define alias sqlint64  type SQL_BIGINT_TYPE;
 define alias sqluint64 type SQL_BIGUINT_TYPE;

 /*********************************************************************/
 /*                                                                   */
 /* The sqlintptr and sqluintptr are defined as integer types large   */
 /* enough to contain pointer values on this platform.                */
 /*                                                                   */
 /*********************************************************************/
 define alias sqlintptr  type sqlint32;
 define alias sqluintptr type sqluint32;

 %end; /* SQL_H_SQLSYSTM */
